----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date:    21:44:50 04/26/2010 
-- Design Name: 
-- Module Name:    BLOCK_SEPARATOR_PROCESS - Behavioral 
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

---- Uncomment the following library declaration if instantiating
---- any Xilinx primitives in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity BLOCK_CONNECTOR_PROCESS is
port(
		I_SL_CLK						:	in		std_logic;
		I_SL_RST						:	in		std_logic;
		I_SL_FLAME_ENABLE			:	in		std_logic;
		I_SL_BLOCK_START			:	in		std_logic;
		I_SLV7T0_DATA				:	in		std_logic_vector(7 downto 0);
		I_SLV11T0_H_RESOLUTION	:	in		std_logic_vector(11 downto 0);
		I_SLV11T0_V_RESOLUTION	:	in		std_logic_vector(11 downto 0);
		I_SL_VSYNC					:	in		std_logic;
		I_SL_HSYNC					:	in		std_logic;
		I_SL_DE						:	in		std_logic;
		I_SL_VSYNC_8L_DFF			:	in		std_logic;
		I_SL_HSYNC_8L_DFF			:	in		std_logic;
		I_SL_DE_8L_DFF				:	in		std_logic;
		O_SLV7T0_DATA				:	out	std_logic_vector(7 downto 0)
);
end BLOCK_CONNECTOR_PROCESS;

architecture Behavioral of BLOCK_CONNECTOR_PROCESS is

component BLOCK_CONNECTOR_RW
port(
		I_SL_CLK					:	in		std_logic;
		I_SL_RST					:	in		std_logic;
		I_SL_RW_FLAG			:	in		std_logic;
		I_SL_BLOCK_START		:	in		std_logic;
		I_SLV2T0_READ_LINE	:	in		std_logic_vector(2 downto 0);
		I_SL_DE					:	in		std_logic;--DEbAM̏ꏊǂɂ邩߂ĂȂ̂
		I_SLV7T0_DATA			:	in		std_logic_vector(7 downto 0);
		O_SLV7T0_DATA			:	out	std_logic_vector(7 downto 0)
);
end component;

signal	sig_slv11t0_line_count			:	std_logic_vector(11 downto 0):="000000000000";
signal	sig_sl_de_down_edge_create1	:	std_logic;
signal	sig_sl_de_down_edge_create2	:	std_logic;
signal	sig_sl_de_down_edge				:	std_logic;
signal	sig_sl_rw_flag_a					:	std_logic;
signal	sig_sl_rw_flag_b					:	std_logic;
signal	sig_slv7t0_out_data_a			:	std_logic_vector(7 downto 0);
--signal	sig_slv7t0_out_data_a_1c_dff	:	std_logic_vector(7 downto 0);
signal	sig_slv7t0_out_data_b			:	std_logic_vector(7 downto 0);
--signal	sig_slv7t0_out_data_b_1c_dff	:	std_logic_vector(7 downto 0);
signal	sig_sl_de							:	std_logic;

signal	sig_slv10t0_read_line_count	:	std_logic_vector(10 downto 0):=(others=>'0');

begin

--RAM̐؂ւ^C~ÓAǂݎpI_SL_DȄI[M8ꍇi1ubNC̓ǂݎ肪IꍇƂƂɂĂ͂ǂ낤H
--ݑI_SL_BLOCK_STARTM̃JEgƂÂł͓ǂݎ蒆RAM؂ւႤȋC
--݂Aǂݎ̂قuNԂ݂镪AԂ킯Biŏ[[[ƏŁASTARTMȂ󔒂̎Ԃ\̂ŁAobt@[ӂƂ悤ȂƂ͂Ȃǂ


	sig_sl_de	<=	I_SL_DE	or	I_SL_DE_8L_DFF;

	process(I_SL_CLK)
	begin
		if(I_SL_CLK'event and I_SL_CLK='1')then
			if(sig_sl_de='1')then
				sig_sl_de_down_edge_create1	<='1';
			else
				sig_sl_de_down_edge_create1	<='0';
			end if;
			
			if(sig_sl_de_down_edge_create1='1')then
				sig_sl_de_down_edge_create2	<='1';
			else
				sig_sl_de_down_edge_create2	<='0';
			end if;
		end if;
	end process;

	sig_sl_de_down_edge	<= not sig_sl_de_down_edge_create1	and	sig_sl_de_down_edge_create2;

	process(I_SL_CLK)
	begin
		if(I_SL_CLK'event and I_SL_CLK='1')then
			if(I_SL_VSYNC_8L_DFF='0')then
				sig_slv10t0_read_line_count	<=	(others=>'0');
			elsif(sig_sl_de_down_edge='1')then
				sig_slv10t0_read_line_count	<=	sig_slv10t0_read_line_count	+	1;				
			end if;
		end if;
	end process;



	process(I_SL_CLK)
	begin
		if(I_SL_CLK'event and I_SL_CLK='1')then
--			if(sig_slv10t0_read_line_count	<	"00000001000")then
--				sig_sl_rw_flag_a	<=			sig_slv10t0_read_line_count(3);--ŏ8C܂ł͗݃[hɂ
--				sig_sl_rw_flag_b	<=			sig_slv10t0_read_line_count(3);
--			else
				sig_sl_rw_flag_a	<=			sig_slv10t0_read_line_count(3);
				sig_sl_rw_flag_b	<=	not	sig_slv10t0_read_line_count(3);
--			end if;
		end if;
	end process;
	
	RAM_A	:	BLOCK_CONNECTOR_RW	port map(
		I_SL_CLK					=>	I_SL_CLK,
		I_SL_RST					=>	I_SL_RST,
		I_SL_RW_FLAG			=>	sig_sl_rw_flag_a,
		I_SL_BLOCK_START		=>	I_SL_BLOCK_START,
		I_SLV2T0_READ_LINE	=>	sig_slv10t0_read_line_count(2 downto 0),--ǂݎRAM̐؂ւƁA傫RAMAB̐؂ւɎgĂ
		I_SL_DE					=>	sig_sl_de,--DE̓AhXJEgAbvɎgĂ
		I_SLV7T0_DATA			=>	I_SLV7T0_DATA,
		O_SLV7T0_DATA			=>	sig_slv7t0_out_data_a
	); --̒̓RAM̐؂ւ͂ԂOMłĂ邩ȂA͐ԂƏԂ܂ݍĂۂHH
--RAM̐؂ւ̃^C~OOɍŏIf[^ł悤ȊɂȂĂBŏIf[^̎CLKRAM؂ւ
--DExKv͂Ȃۂ
	RAM_B	:	BLOCK_CONNECTOR_RW	port map(
		I_SL_CLK					=>	I_SL_CLK,
		I_SL_RST					=>	I_SL_RST,
		I_SL_RW_FLAG			=>	sig_sl_rw_flag_b,
		I_SL_BLOCK_START		=>	I_SL_BLOCK_START,
		I_SLV2T0_READ_LINE	=>	sig_slv10t0_read_line_count(2 downto 0),
		I_SL_DE					=>	sig_sl_de,
		I_SLV7T0_DATA			=>	I_SLV7T0_DATA,
		O_SLV7T0_DATA			=>	sig_slv7t0_out_data_b
	);
	
	process(I_SL_CLK)
	begin
		if(I_SL_CLK'event and I_SL_CLK='1')then
			if(sig_slv10t0_read_line_count(3)='1')then--ǂRAM̓o͂邩ÃJEgxKv͖݂H@DEJEgMCLK@@RAMǂݏoԁ@Ԃ
				O_SLV7T0_DATA	<=	sig_slv7t0_out_data_a;
			else
				O_SLV7T0_DATA	<=	sig_slv7t0_out_data_b;
			end if;
		end if;
	end process;

end Behavioral;