------------------------------------------------------------
-- Product     : JPEG_ENCODER v1.1                       --
-- Module      : BLOCK_SEPARATOR_PROCESS v1.1             --
-- Last Update : 2011/04/20                               --
--                                                        --
-- Engineer    : Takuya Katayama                          --
-- Mail        : pajamas@hotmail.co.jp                    --
--                                                        --
-- Copyright (C) 2011 Takuya Katayama All Rights Reserved.--
------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

entity BLOCK_RW is
port(
		I_SL_CLK					:	in		std_logic;
		I_SL_RST					:	in		std_logic;
		I_SL_VSYNC				:	in		std_logic;
		I_SL_HSYNC				:	in		std_logic;
		I_SL_DE					:	in		std_logic;
		I_SLV11T0_H_RESOLUTION	:	in		std_logic_vector(11 downto 0);
		I_SL_RW_FLAG			:	in		std_logic;
		I_SLV2T0_WIRTE_LINE	:	in		std_logic_vector(2 downto 0);
		I_SLV7T0_DATA			:	in		std_logic_vector(7 downto 0);
		O_SL_START				:	out	std_logic;
		O_SLV7T0_DATA			:	out	std_logic_vector(7 downto 0)
);
end BLOCK_RW;

architecture Behavioral of BLOCK_RW is

component BRAM8_2560
port(
		clka	: IN	std_logic;
		wea	: IN	std_logic_VECTOR(0 downto 0);
		addra	: IN	std_logic_VECTOR(11 downto 0);
		dina	: IN	std_logic_VECTOR(7 downto 0);
		douta	: OUT	std_logic_VECTOR(7 downto 0)
);
end component;

signal	sig_slv7t0_data					:	std_logic_vector(7 downto 0):="00000000";

signal	sig_slv7t0_enable_line			:	std_logic_vector(7 downto 0):="00000000";

signal	sig_slv13t0_start_flag_counter		:	std_logic_vector(13 downto 0);

signal	sig_slv8t0_start_flag_count			:	std_logic_vector(8 downto 0);

signal	sig_slv63t0_wait_56clk_count			:	std_logic_vector(63 downto 0);
signal	sig_slv63t0_wait_56clk_count_output	:	std_logic_vector(63 downto 0);

signal	sig_slv11t0_adress_line_1		:	std_logic_vector(11 downto 0);
signal	sig_slv11t0_adress_line_2		:	std_logic_vector(11 downto 0);
signal	sig_slv11t0_adress_line_3		:	std_logic_vector(11 downto 0);
signal	sig_slv11t0_adress_line_4		:	std_logic_vector(11 downto 0);
signal	sig_slv11t0_adress_line_5		:	std_logic_vector(11 downto 0);
signal	sig_slv11t0_adress_line_6		:	std_logic_vector(11 downto 0);
signal	sig_slv11t0_adress_line_7		:	std_logic_vector(11 downto 0);
signal	sig_slv11t0_adress_line_8		:	std_logic_vector(11 downto 0);

signal	sig_slv7t0_out_data1				:	std_logic_vector(7 downto 0);
signal	sig_slv7t0_out_data2				:	std_logic_vector(7 downto 0);
signal	sig_slv7t0_out_data3				:	std_logic_vector(7 downto 0);
signal	sig_slv7t0_out_data4				:	std_logic_vector(7 downto 0);
signal	sig_slv7t0_out_data5				:	std_logic_vector(7 downto 0);
signal	sig_slv7t0_out_data6				:	std_logic_vector(7 downto 0);
signal	sig_slv7t0_out_data7				:	std_logic_vector(7 downto 0);
signal	sig_slv7t0_out_data8				:	std_logic_vector(7 downto 0);


begin

--Write EnableĂԁAf[^҂
	process(I_SL_CLK)
	begin
		if(I_SL_CLK'event and I_SL_CLK='1')then
			sig_slv7t0_data	<=	I_SLV7T0_DATA;
		end if;
	end process;

--Write Enable쐬ꏊ@CɂāA݂RAMقȂ
	process(I_SL_CLK)
	begin
		if(I_SL_CLK'event and I_SL_CLK='1')then
			if(I_SL_RW_FLAG='0'	and I_SL_DE='1')then
				if(I_SLV2T0_WIRTE_LINE="000")then
					sig_slv7t0_enable_line	<=	"00000001";
				elsif(I_SLV2T0_WIRTE_LINE="001")then
					sig_slv7t0_enable_line	<=	"00000010";
				elsif(I_SLV2T0_WIRTE_LINE="010")then
					sig_slv7t0_enable_line	<=	"00000100";
				elsif(I_SLV2T0_WIRTE_LINE="011")then
					sig_slv7t0_enable_line	<=	"00001000";
				elsif(I_SLV2T0_WIRTE_LINE="100")then
					sig_slv7t0_enable_line	<=	"00010000";
				elsif(I_SLV2T0_WIRTE_LINE="101")then
					sig_slv7t0_enable_line	<=	"00100000";
				elsif(I_SLV2T0_WIRTE_LINE="110")then
					sig_slv7t0_enable_line	<=	"01000000";
				elsif(I_SLV2T0_WIRTE_LINE="111")then
					sig_slv7t0_enable_line	<=	"10000000";
				end if;
			else
				sig_slv7t0_enable_line		<=	"00000000";
			end if;
		end if;
	end process;

--56CLK҂鎞̃JEg

	process(I_SL_CLK)
	begin
		if(I_SL_CLK'event and I_SL_CLK='1')then
			if(I_SL_RW_FLAG='1')then
				sig_slv63t0_wait_56clk_count(63 downto 0)	<=	sig_slv63t0_wait_56clk_count(62 downto 0)	&	sig_slv63t0_wait_56clk_count(63);
			else
				sig_slv63t0_wait_56clk_count(63 downto 0)	<=	"0000000000000000000000000000000000000000000000000000000000000001";
			end if;
		end if;
	end process;
--1clk_delay
	process(I_SL_CLK)
	begin
		if(I_SL_CLK'event and I_SL_CLK='1')then
			sig_slv63t0_wait_56clk_count_output	<=	sig_slv63t0_wait_56clk_count;
		end if;
	end process;
--START_FLAG
	process(I_SL_CLK)
	begin
		if(I_SL_CLK'event and I_SL_CLK='1')then
			if(I_SL_RW_FLAG='1')then
				sig_slv13t0_start_flag_counter	<=	sig_slv13t0_start_flag_counter	+	1;
			else
				sig_slv13t0_start_flag_counter	<=	"00000000000000";
			end if;
		end if;
	end process;
	process(I_SL_CLK)
	begin
		if(I_SL_CLK'event and I_SL_CLK='1')then
			if(sig_slv13t0_start_flag_counter(5 downto 0)="000001" and I_SL_RW_FLAG='1')then
				if(sig_slv8t0_start_flag_count<I_SLV11T0_H_RESOLUTION(11 downto 3))then
					O_SL_START							<=	'1';
					sig_slv8t0_start_flag_count	<=	sig_slv8t0_start_flag_count	+	1;
				else
					O_SL_START							<=	'0';
					sig_slv8t0_start_flag_count	<=	sig_slv8t0_start_flag_count;
				end if;
			elsif(I_SL_RW_FLAG='1')then
				O_SL_START							<=	'0';
				sig_slv8t0_start_flag_count	<=	sig_slv8t0_start_flag_count;
			else
				O_SL_START							<=	'0';
				sig_slv8t0_start_flag_count	<=	(others=>'0');
			end if;
		end if;
	end process;
--EnableɂȂĂꏊ̃AhXJE^JEgAbvĂB[h̏ꍇ56CLKWAIT܂
	process(I_SL_CLK)
	begin
		if(I_SL_CLK'event and I_SL_CLK='1')then
			if(I_SL_RW_FLAG='0')then
				if(sig_slv7t0_enable_line(0)='1')then
					sig_slv11t0_adress_line_1	<=	sig_slv11t0_adress_line_1 + 1;
				elsif(sig_slv7t0_enable_line(1)='1')then
					sig_slv11t0_adress_line_2	<=	sig_slv11t0_adress_line_2 + 1;
				elsif(sig_slv7t0_enable_line(2)='1')then
					sig_slv11t0_adress_line_3	<=	sig_slv11t0_adress_line_3 + 1;
				elsif(sig_slv7t0_enable_line(3)='1')then
					sig_slv11t0_adress_line_4	<=	sig_slv11t0_adress_line_4 + 1;
				elsif(sig_slv7t0_enable_line(4)='1')then
					sig_slv11t0_adress_line_5	<=	sig_slv11t0_adress_line_5 + 1;
				elsif(sig_slv7t0_enable_line(5)='1')then
					sig_slv11t0_adress_line_6	<=	sig_slv11t0_adress_line_6 + 1;
				elsif(sig_slv7t0_enable_line(6)='1')then
					sig_slv11t0_adress_line_7	<=	sig_slv11t0_adress_line_7 + 1;
				elsif(sig_slv7t0_enable_line(7)='1')then
					sig_slv11t0_adress_line_8	<=	sig_slv11t0_adress_line_8 + 1;
				else
					sig_slv11t0_adress_line_1	<=	"000000000000";
					sig_slv11t0_adress_line_2	<=	"000000000000";
					sig_slv11t0_adress_line_3	<=	"000000000000";
					sig_slv11t0_adress_line_4	<=	"000000000000";
					sig_slv11t0_adress_line_5	<=	"000000000000";
					sig_slv11t0_adress_line_6	<=	"000000000000";
					sig_slv11t0_adress_line_7	<=	"000000000000";
					sig_slv11t0_adress_line_8	<=	"000000000000";
				end if;
			else
				if(sig_slv63t0_wait_56clk_count(7 downto 0)>"00000000" and I_SL_RW_FLAG='1')then
					if(sig_slv11t0_adress_line_1<(I_SLV11T0_H_RESOLUTION - 1))then
						sig_slv11t0_adress_line_1	<=	sig_slv11t0_adress_line_1 + 1;
					else
						sig_slv11t0_adress_line_1	<=	sig_slv11t0_adress_line_1;
					end if;
				elsif(sig_slv63t0_wait_56clk_count(15 downto 8)>"00000000")then
					if(sig_slv11t0_adress_line_2<(I_SLV11T0_H_RESOLUTION - 1))then
						sig_slv11t0_adress_line_2	<=	sig_slv11t0_adress_line_2 + 1;
					else
						sig_slv11t0_adress_line_2	<=	sig_slv11t0_adress_line_2;
					end if;
				elsif(sig_slv63t0_wait_56clk_count(23 downto 16)>"00000000")then
					if(sig_slv11t0_adress_line_3<(I_SLV11T0_H_RESOLUTION - 1))then
						sig_slv11t0_adress_line_3	<=	sig_slv11t0_adress_line_3 + 1;
					else
						sig_slv11t0_adress_line_3	<=	sig_slv11t0_adress_line_3;
					end if;
				elsif(sig_slv63t0_wait_56clk_count(31 downto 24)>"00000000")then
					if(sig_slv11t0_adress_line_4<(I_SLV11T0_H_RESOLUTION - 1))then
						sig_slv11t0_adress_line_4	<=	sig_slv11t0_adress_line_4 + 1;
					else
						sig_slv11t0_adress_line_4	<=	sig_slv11t0_adress_line_4;
					end if;
				elsif(sig_slv63t0_wait_56clk_count(39 downto 32)>"00000000")then
					if(sig_slv11t0_adress_line_5<(I_SLV11T0_H_RESOLUTION - 1))then
						sig_slv11t0_adress_line_5	<=	sig_slv11t0_adress_line_5 + 1;
					else
						sig_slv11t0_adress_line_5	<=	sig_slv11t0_adress_line_5;
					end if;
				elsif(sig_slv63t0_wait_56clk_count(47 downto 40)>"00000000")then
					if(sig_slv11t0_adress_line_6<(I_SLV11T0_H_RESOLUTION - 1))then
						sig_slv11t0_adress_line_6	<=	sig_slv11t0_adress_line_6 + 1;
					else
						sig_slv11t0_adress_line_6	<=	sig_slv11t0_adress_line_6;
					end if;
				elsif(sig_slv63t0_wait_56clk_count(55 downto 48)>"00000000")then
					if(sig_slv11t0_adress_line_7<(I_SLV11T0_H_RESOLUTION - 1))then
						sig_slv11t0_adress_line_7	<=	sig_slv11t0_adress_line_7 + 1;
					else
						sig_slv11t0_adress_line_7	<=	sig_slv11t0_adress_line_7;
					end if;
				elsif(sig_slv63t0_wait_56clk_count(63 downto 56)>"00000000")then
					if(sig_slv11t0_adress_line_8<(I_SLV11T0_H_RESOLUTION - 1))then
						sig_slv11t0_adress_line_8	<=	sig_slv11t0_adress_line_8 + 1;
					else
						sig_slv11t0_adress_line_8	<=	sig_slv11t0_adress_line_8;
					end if;
				end if;
			end if;
		end if;
	end process;



	line_1 : BRAM8_2560	port map (
		clka	=>	I_SL_CLK,
		wea	=> sig_slv7t0_enable_line(0 downto 0),
		addra	=> sig_slv11t0_adress_line_1,
		dina	=> sig_slv7t0_data,
		douta	=> sig_slv7t0_out_data1
	);

	line_2 : BRAM8_2560	port map (
		clka	=>	I_SL_CLK,
		wea	=> sig_slv7t0_enable_line(1 downto 1),
		addra	=> sig_slv11t0_adress_line_2,
		dina	=> sig_slv7t0_data,
		douta	=> sig_slv7t0_out_data2
	);

	line_3 : BRAM8_2560	port map (
		clka	=>	I_SL_CLK,
		wea	=> sig_slv7t0_enable_line(2 downto 2),
		addra	=> sig_slv11t0_adress_line_3,
		dina	=> sig_slv7t0_data,
		douta	=> sig_slv7t0_out_data3
	);

	line_4 : BRAM8_2560	port map (
		clka	=>	I_SL_CLK,
		wea	=> sig_slv7t0_enable_line(3 downto 3),
		addra	=> sig_slv11t0_adress_line_4,
		dina	=> sig_slv7t0_data,
		douta	=> sig_slv7t0_out_data4
	);

	line_5 : BRAM8_2560	port map (
		clka	=>	I_SL_CLK,
		wea	=> sig_slv7t0_enable_line(4 downto 4),
		addra	=> sig_slv11t0_adress_line_5,
		dina	=> sig_slv7t0_data,
		douta	=> sig_slv7t0_out_data5
	);

	line_6 : BRAM8_2560	port map (
		clka	=>	I_SL_CLK,
		wea	=> sig_slv7t0_enable_line(5 downto 5),
		addra	=> sig_slv11t0_adress_line_6,
		dina	=> sig_slv7t0_data,
		douta	=> sig_slv7t0_out_data6
	);

	line_7 : BRAM8_2560	port map (
		clka	=>	I_SL_CLK,
		wea	=> sig_slv7t0_enable_line(6 downto 6),
		addra	=> sig_slv11t0_adress_line_7,
		dina	=> sig_slv7t0_data,
		douta	=> sig_slv7t0_out_data7
	);

	line_8 : BRAM8_2560	port map (
		clka	=>	I_SL_CLK,
		wea	=> sig_slv7t0_enable_line(7 downto 7),
		addra	=> sig_slv11t0_adress_line_8,
		dina	=> sig_slv7t0_data,
		douta	=> sig_slv7t0_out_data8
	);

	process(I_SL_CLK)
	begin
		if(I_SL_CLK'event and I_SL_CLK='1')then
			if(sig_slv63t0_wait_56clk_count_output(7 downto 0)>"00000000")then
				O_SLV7T0_DATA	<=	sig_slv7t0_out_data1;
			elsif(sig_slv63t0_wait_56clk_count_output(15 downto 8)>"00000000")then
				O_SLV7T0_DATA	<=	sig_slv7t0_out_data2;
			elsif(sig_slv63t0_wait_56clk_count_output(23 downto 16)>"00000000")then
				O_SLV7T0_DATA	<=	sig_slv7t0_out_data3;
			elsif(sig_slv63t0_wait_56clk_count_output(31 downto 24)>"00000000")then
				O_SLV7T0_DATA	<=	sig_slv7t0_out_data4;
			elsif(sig_slv63t0_wait_56clk_count_output(39 downto 32)>"00000000")then
				O_SLV7T0_DATA	<=	sig_slv7t0_out_data5;
			elsif(sig_slv63t0_wait_56clk_count_output(47 downto 40)>"00000000")then
				O_SLV7T0_DATA	<=	sig_slv7t0_out_data6;
			elsif(sig_slv63t0_wait_56clk_count_output(55 downto 48)>"00000000")then
				O_SLV7T0_DATA	<=	sig_slv7t0_out_data7;
			elsif(sig_slv63t0_wait_56clk_count_output(63 downto 56)>"00000000")then
				O_SLV7T0_DATA	<=	sig_slv7t0_out_data8;
			end if;
		end if;	
	end process;
	

end Behavioral;