----------------------------------------------------------------------------------
-- Product     : DATA_TRANSFER_PROCESS v1.0
-- Module      : DATA_TRANSFER_PROCESS v1.0
-- Last Update : 2011/04/07
-- 
-- Engineer    : Takuya Katayama
-- Mail        : pajamas@hotmail.co.jp
--
-- Copyright (C) 2011 Takuya Katayama All Rights Reserved.
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

entity DATA_TRANSFER_PROCESS is
port(
		I_SL_CLK					:	in		std_logic;
		I_SL_TC_CLK				:	in		std_logic;
		I_SL_RESET				:	in		std_logic;
		I_SL_WRITE_ENABLE		:	in		std_logic;
		I_SL_DATA_ENABLE		:	in		std_logic;
		I_SLV15T0_DATA			:	in		std_logic_vector(15 downto 0);
		I_SL_BUSY				:	in		std_logic;--low_active
		O_SL_FLAME_ENABLE		:	out	std_logic;--low_active
		O_SL_STROBE				:	out	std_logic;--low_active
		O_SLV15T0_DATA			:	out	std_logic_vector(15 downto 0);
	--test_output
		O_SL_OVER_FLOW			:	out	std_logic;
		O_SLV15T0_READ_ADDRESS	:	out	std_logic_vector(15 downto 0)
);
end DATA_TRANSFER_PROCESS;

architecture Behavioral of DATA_TRANSFER_PROCESS is
-------------------------------------------------
--[U[ύX\̈--------------------------------
-------------------------------------------------

-------------------------------------------------
--16iBRAM̍őAhX+1(=ێ\)Ă--
-------------------------------------------------
--constant	con_slv31t0_max_address		:	std_logic_vector(31 downto 0):=x"00016800";
constant	con_slv19t0_max_address		:	std_logic_vector(19 downto 0):=x"80000";
-------------------------------------------------
--ύXBRAM_IPɍ킹ĕύXĂ-----------------
-------------------------------------------------
component DATA_MEMORY
	port (
	clka: IN std_logic;
	wea: IN std_logic_VECTOR(0 downto 0);
	addra: IN std_logic_VECTOR(18 downto 0);
	dina: IN std_logic_VECTOR(15 downto 0);
	clkb: IN std_logic;
	addrb: IN std_logic_VECTOR(18 downto 0);
	doutb: OUT std_logic_VECTOR(15 downto 0));
end component;

-------------------------------------------------
--[U[ύX\̈I-----------------------------
-------------------------------------------------

signal	sig_slv19t0_write_address			:	std_logic_vector(19 downto 0):=(others=>'0');
signal	sig_slv19t0_read_address			:	std_logic_vector(19 downto 0):=(others=>'0');

signal	sig_slv19t0_read_end_adress		:	std_logic_vector(19 downto 0):=(others=>'0');

signal	sig_sl_write_enable					:	std_logic:='0';
signal	sig_sl_data_enable					:	std_logic_vector(0 downto 0);
signal	sig_slv15t0_data						:	std_logic_vector(15 downto 0);

signal	sig_sl_write_end						:	std_logic:='0';

signal	sig_sl_busy								:	std_logic:='0';

signal	sig_sl_flame_enable					:	std_logic:='0';
signal	sig_sl_strobe							:	std_logic:='0';
signal	sig_slv2t0_state						:	std_logic_vector(2 downto 0):=(others=>'0');

signal	sig_sl_busy_up_edge					:	std_logic:='0';
signal	sig_sl_busy_down_edge				:	std_logic:='0';
signal	sig_sl_busy_edge_create1			:	std_logic:='0';
signal	sig_sl_busy_edge_create2			:	std_logic:='0';

signal	sig_slv15t0_next_read_wait_timer	:	std_logic_vector(15 downto 0):=(others=>'0');

signal	sig_sl_over_flow						:	std_logic:='0';

begin

--ݗLԃ`FbJ[
process(I_SL_CLK)
begin
	if(I_SL_CLK'event and I_SL_CLK='1')then
		sig_sl_write_enable	<=	I_SL_WRITE_ENABLE;
		sig_slv15t0_data		<=	I_SLV15T0_DATA;
		if(I_SL_WRITE_ENABLE='1' and I_SL_DATA_ENABLE='1')then
			sig_sl_data_enable	<=	(others=>'1');
		else
			sig_sl_data_enable	<=	(others=>'0');
		end if;
	end if;
end process;

--ݏĨAhX`FbJ[
process(I_SL_CLK,I_SL_RESET)
begin
	if(I_SL_RESET='0')then
		sig_slv19t0_read_end_adress	<=	(others=>'0');
		sig_sl_write_end					<=	'0';
	elsif(I_SL_CLK'event and I_SL_CLK='1')then
		if(I_SL_WRITE_ENABLE='0' and sig_sl_write_enable='1')then--݂I낤Ƃu
			sig_slv19t0_read_end_adress	<=	sig_slv19t0_write_address;--ĨAhXL
			sig_sl_write_end					<=	'1';
		else
			sig_slv19t0_read_end_adress	<=	sig_slv19t0_read_end_adress;--͕ێ
			sig_sl_write_end					<=	sig_sl_write_end;
		end if;
	end if;
end process;

--f[^ӂĖǂ`FbN
process(I_SL_CLK,I_SL_RESET)
begin
	if(I_SL_RESET='0')then
		sig_sl_over_flow	<=	'0';
	elsif(I_SL_CLK'event and I_SL_CLK='1')then
		if(con_slv19t0_max_address	<	sig_slv19t0_write_address)then
			sig_sl_over_flow	<=	'1';
		else
			sig_sl_over_flow	<=	sig_sl_over_flow;			
		end if;
	end if;
end process;


--AhXRg[[
process(I_SL_CLK,I_SL_RESET)
begin
	if(I_SL_RESET='0')then
		sig_slv19t0_write_address	<=	(others=>'0');
	elsif(I_SL_CLK'event and I_SL_CLK='1')then
		if(sig_sl_write_enable='1')then--ݗLԂłꍇ
			if(sig_sl_data_enable(0)='1' and sig_sl_over_flow='0')then--ݗLłꍇ
				sig_slv19t0_write_address	<=	sig_slv19t0_write_address	+	1;
			else--݂LłȂꍇ
				sig_slv19t0_write_address	<=	sig_slv19t0_write_address;
			end if;
		else--ݗLԂłȂꍇ
			sig_slv19t0_write_address	<=	(others=>'0');
		end if;
	end if;
end process;

--BRAMpENABLEɂ镔EEEB
--process(I_SL_CLK)
--begin
--	if(I_SL_CLK'event and I_SL_CLK='1')then
--		if(sig_sl_data_enable='0')then
--			sig_sl_data_enable_bram				<=	(others=>'0');
--			sig_slv19t0_write_address_bram	<=	sig_slv19t0_write_address;
--			sig_slv15t0_data_bram				<=	sig_slv15t0_data;
--		else
--			sig_sl_data_enable_bram				<=	(others=>'1');
--			sig_slv19t0_write_address_bram	<=	sig_slv19t0_write_address;
--			sig_slv15t0_data_bram				<=	sig_slv15t0_data;
--		end if;
--	end if;
--end process;

--BRAM֐ڑ--݂1MBێ\Ȑݒ

-------------------------------------------------
--[U[ύX\̈--------------------------------
-------------------------------------------------

-------------------------------------------------
--ύXBRAM_IPɍ킹ĕύXĂ-----------------
-------------------------------------------------
RAM	:	DATA_MEMORY	port map(
		clka	=> I_SL_CLK,
		wea	=> sig_sl_data_enable,
		addra	=> sig_slv19t0_write_address(18 downto 0),
		dina	=> sig_slv15t0_data,
		clkb	=> I_SL_TC_CLK,
		addrb	=> sig_slv19t0_read_address(18 downto 0),
		doutb	=> O_SLV15T0_DATA
);

-------------------------------------------------
--[U[ύX\̈I-----------------------------
-------------------------------------------------

--BUSỸGbWo
process(I_SL_TC_CLK)
begin
	if(I_SL_TC_CLK'event and I_SL_TC_CLK='1')then
		if(sig_sl_busy='1')then
			sig_sl_busy_edge_create1	<=	'1';
		else
			sig_sl_busy_edge_create1	<=	'0';
		end if;
		if(sig_sl_busy_edge_create1='1')then
			sig_sl_busy_edge_create2	<=	'1';
		else
			sig_sl_busy_edge_create2	<=	'0';
		end if;			
	end if;
end process;

sig_sl_busy_down_edge	<=	not sig_sl_busy_edge_create1	and sig_sl_busy_edge_create2;
sig_sl_busy_up_edge		<=	sig_sl_busy_edge_create1	and not sig_sl_busy_edge_create2;

process(I_SL_TC_CLK,I_SL_RESET)
begin
	if(I_SL_RESET='0')then--ZbgAԂdv
		sig_sl_flame_enable			<=	'1';
		sig_sl_strobe					<=	'1';
		sig_slv19t0_read_address	<=	(others=>'0');
		sig_slv2t0_state				<=	"000";
	elsif(I_SL_TC_CLK'event and I_SL_TC_CLK='1')then
		if(sig_slv2t0_state="000")then--X^[gۂBusy
			if(sig_sl_write_end='0')then--ݏIȂƐi񂶂_
					sig_sl_flame_enable			<=	'1';
					sig_sl_strobe					<=	'1';
					sig_slv19t0_read_address	<=	sig_slv19t0_read_address;
					sig_slv2t0_state				<=	"000";
			else
				if(sig_sl_busy='1')then
					sig_sl_flame_enable			<=	'0';
					sig_sl_strobe					<=	'0';
					sig_slv19t0_read_address	<=	sig_slv19t0_read_address;
					sig_slv2t0_state				<=	"001";
				else
					sig_sl_flame_enable			<=	'0';
					sig_sl_strobe					<=	'1';
					sig_slv19t0_read_address	<=	sig_slv19t0_read_address;
					sig_slv2t0_state				<=	"000";
				end if;
			end if;
		elsif(sig_slv2t0_state="001")then--busyOKȂ̂ŃXg{𕰂āHX^[g
			sig_sl_flame_enable			<=	'0';
			sig_sl_strobe					<=	'0';
			sig_slv19t0_read_address	<=	sig_slv19t0_read_address;
			if(sig_sl_busy_down_edge='1')then--BUSY̗GbWo܂Ŏ̃Xe[gւ͍sȂ
				sig_slv2t0_state				<=	"010";
			else
				sig_slv2t0_state				<=	"001";
			end if;
		elsif(sig_slv2t0_state="010")then--busyēxOKɂȂ܂Ńf[^ێ
			if(sig_sl_busy='1')then
				if(sig_slv19t0_read_address < sig_slv19t0_read_end_adress)then
					sig_sl_flame_enable			<=	'0';
					sig_sl_strobe					<=	'1';
					sig_slv19t0_read_address	<=	sig_slv19t0_read_address;
					sig_slv2t0_state				<=	"011";
				else
					sig_sl_flame_enable			<=	'0';
					sig_sl_strobe					<=	'0';
					sig_slv19t0_read_address	<=	sig_slv19t0_read_address;
					sig_slv2t0_state				<=	"011";
				end if;
			else
				sig_sl_flame_enable			<=	'0';
				sig_sl_strobe					<=	'0';
				sig_slv19t0_read_address	<=	sig_slv19t0_read_address;
				sig_slv2t0_state				<=	"010";
			end if;
		elsif(sig_slv2t0_state="011")then--busyēxOKɂȂ̂ŃXg{ɖ߂Bf[^ŏIłȂ΁Af[^XV̂߂Ɏ̃Xe[gIX^[gɖ߂@ႦΔEND
			if(sig_slv19t0_read_address < sig_slv19t0_read_end_adress)then
				sig_sl_flame_enable			<=	'0';
				sig_sl_strobe					<=	'1';
				sig_slv19t0_read_address	<=	sig_slv19t0_read_address;
				if(sig_slv15t0_next_read_wait_timer="1111111111111111")then
					sig_slv2t0_state						<=	"100";
					sig_slv15t0_next_read_wait_timer	<=	(others=>'0');
				else
					sig_slv15t0_next_read_wait_timer	<=	sig_slv15t0_next_read_wait_timer	+	1;
					sig_slv2t0_state						<=	"011";
				end if;
			else
				sig_sl_flame_enable			<=	'1';
				sig_sl_strobe					<=	'1';
				sig_slv19t0_read_address	<=	sig_slv19t0_read_address;
				sig_slv2t0_state				<=	"111";
			end if;
		elsif(sig_slv2t0_state="100")then--f[^XV
			sig_sl_flame_enable			<=	'0';
			sig_sl_strobe					<=	'1';
			sig_slv19t0_read_address	<=	sig_slv19t0_read_address	+	1;
			sig_slv2t0_state				<=	"000";
		end if;
	end if;
end process;

process(I_SL_TC_CLK)
begin
	if(I_SL_TC_CLK'event and I_SL_TC_CLK='1')then
		sig_sl_busy			<=	I_SL_BUSY;
		O_SL_FLAME_ENABLE	<=	sig_sl_flame_enable;
		O_SL_STROBE			<=	sig_sl_strobe;
		O_SL_OVER_FLOW		<=	sig_sl_over_flow;

	end if;
end process;

--test
O_SLV15T0_READ_ADDRESS	<=	sig_slv19t0_read_address(15 downto 0);


end Behavioral;