--------------------------------------------------------------------------------
-- Company: 
-- Engineer:
--
-- Create Date:   14:58:50 02/21/2011
-- Design Name:   
-- Module Name:   D:/DATA_TRANSFER_PROCESS/DATA_TRANSFER_PROCESS/src/TEST_DATA_TRANSFER_PROCESS.vhd
-- Project Name:  DATA_TRANSFER_PROCESS
-- Target Device:  
-- Tool versions:  
-- Description:   
-- 
-- VHDL Test Bench Created by ISE for module: DATA_TRANSFER_PROCESS
-- 
-- Dependencies:
-- 
-- Revision:
-- Revision 0.01 - File Created
-- Additional Comments:
--
-- Notes: 
-- This testbench has been automatically generated using types std_logic and
-- std_logic_vector for the ports of the unit under test.  Xilinx recommends
-- that these types always be used for the top-level I/O of a design in order
-- to guarantee that the testbench will bind correctly to the post-implementation 
-- simulation model.
--------------------------------------------------------------------------------
LIBRARY ieee;
USE ieee.std_logic_1164.ALL;
USE ieee.std_logic_unsigned.all;
USE ieee.numeric_std.ALL;
 
ENTITY TEST_DATA_TRANSFER_PROCESS IS
END TEST_DATA_TRANSFER_PROCESS;
 
ARCHITECTURE behavior OF TEST_DATA_TRANSFER_PROCESS IS 
 
    -- Component Declaration for the Unit Under Test (UUT)
 
    COMPONENT DATA_TRANSFER_PROCESS
    PORT(
         I_SL_CLK : IN  std_logic;
         I_SL_RESET : IN  std_logic;
         I_SLV15T0_DATA : IN  std_logic_vector(15 downto 0);
         I_SL_DATA_ENABLE : IN  std_logic;
         I_SL_WRITE_ENABLE : IN  std_logic;
         O_SL_WRITE_FULL : OUT  std_logic;
         I_SL_BUSY : IN  std_logic;
         O_SL_STROBE : OUT  std_logic;
         O_SL_FLAME_ENABLE : OUT  std_logic;
         O_SLV15T0_DATA : OUT  std_logic_vector(15 downto 0)
        );
    END COMPONENT;
    

   --Inputs
   signal I_SL_CLK : std_logic := '0';
   signal I_SL_RESET : std_logic := '0';
   signal I_SLV15T0_DATA : std_logic_vector(15 downto 0) := (others => '0');
   signal I_SL_DATA_ENABLE : std_logic := '0';
   signal I_SL_WRITE_ENABLE : std_logic := '0';
   signal I_SL_BUSY : std_logic := '1';

 	--Outputs
   signal O_SL_WRITE_FULL : std_logic;
   signal O_SL_STROBE : std_logic;
   signal O_SL_FLAME_ENABLE : std_logic;
   signal O_SLV15T0_DATA : std_logic_vector(15 downto 0);
	
   signal sig_slv15t0_clk_count : std_logic_vector(15 downto 0) := (others => '0');
	
   signal sig_slv7t0_count : std_logic_vector(7 downto 0) := (others => '0');
   signal sig_slv2t0_busy_state : std_logic_vector(2 downto 0) := (others => '0');
 
   signal sig_slv15t0_busy_count : std_logic_vector(15 downto 0) := (others => '0');
   signal sig_sl_busy_count_start : std_logic := '0';
 
BEGIN
 
	-- Instantiate the Unit Under Test (UUT)
   uut: DATA_TRANSFER_PROCESS PORT MAP (
          I_SL_CLK => I_SL_CLK,
          I_SL_RESET => I_SL_RESET,
          I_SLV15T0_DATA => I_SLV15T0_DATA,
          I_SL_DATA_ENABLE => I_SL_DATA_ENABLE,
          I_SL_WRITE_ENABLE => I_SL_WRITE_ENABLE,
          O_SL_WRITE_FULL => O_SL_WRITE_FULL,
          I_SL_BUSY => I_SL_BUSY,
          O_SL_STROBE => O_SL_STROBE,
          O_SL_FLAME_ENABLE => O_SL_FLAME_ENABLE,
          O_SLV15T0_DATA => O_SLV15T0_DATA
        );

I_SL_CLK	<=	not I_SL_CLK after 3 ns;

process(I_SL_CLK)
begin
	if(I_SL_CLK'event and I_SL_CLK='1')then
		if(sig_slv15t0_clk_count="1111111111111111")then
			sig_slv15t0_clk_count	<=	(others=>'1');
		else
			sig_slv15t0_clk_count	<=	sig_slv15t0_clk_count	+	1;
		end if;
	end if;
end process;

process(I_SL_CLK)
begin
	if(I_SL_CLK'event and I_SL_CLK='1')then
		if(sig_slv15t0_clk_count="0000000000000010")then
			I_SL_RESET			<=	'1';
		elsif(sig_slv15t0_clk_count="0000000000000011")then
			I_SL_WRITE_ENABLE	<=	'1';
		elsif(sig_slv15t0_clk_count="0000000000000100")then
			I_SL_DATA_ENABLE	<=	'1';
			I_SLV15T0_DATA		<=	"0000000000000001";		
		elsif(sig_slv15t0_clk_count="0000000000000101")then
			I_SLV15T0_DATA		<=	"0000000000000010";
		elsif(sig_slv15t0_clk_count="0000000000000110")then
			I_SLV15T0_DATA		<=	"0000000000000011";
		elsif(sig_slv15t0_clk_count="0000000000000111")then
			I_SL_DATA_ENABLE	<=	'0';
		elsif(sig_slv15t0_clk_count="0000000000001000")then
			I_SL_WRITE_ENABLE	<=	'0';
		end if;
	end if;
end process;

process(I_SL_CLK)
begin
	if(I_SL_CLK'event and I_SL_CLK='1')then
		if(sig_sl_busy_count_start='1')then
			sig_slv15t0_busy_count	<=	sig_slv15t0_busy_count	+	1;
		else
			sig_slv15t0_busy_count	<=	(others=>'0');
		end if;
	end if;
end process;

process(I_SL_CLK)
begin
	if(I_SL_CLK'event and I_SL_CLK='1')then
		if(sig_slv15t0_clk_count="0000000000111111")then--X^[g
			sig_slv2t0_busy_state	<=	"001";
		elsif(sig_slv2t0_busy_state="001")then--X^[głΎ
			I_SL_BUSY					<=	'1';
			sig_slv2t0_busy_state	<=	"010";
		elsif(sig_slv2t0_busy_state="010")then--Xg{sĂ΁AbusyɂĎ
			if(sig_slv15t0_busy_count="0000000010000000")then
				sig_sl_busy_count_start	<=	'0';
				I_SL_BUSY					<=	'0';
				sig_slv2t0_busy_state	<=	"011";
			elsif(O_SL_STROBE='0')then
				sig_sl_busy_count_start	<=	'1';
				sig_slv2t0_busy_state	<=	"010";
			else
				I_SL_BUSY					<=	'1';
				sig_slv2t0_busy_state	<=	"010";
			end if;
		elsif(sig_slv2t0_busy_state="011")then--΂炭busyɂĂ
			if(sig_slv7t0_count="00100000")then
				sig_slv7t0_count			<=	(others=>'0');
				I_SL_BUSY					<=	'0';
				sig_slv2t0_busy_state	<=	"100";		
			else
				sig_slv7t0_count			<=	sig_slv7t0_count	+	1;
				I_SL_BUSY					<=	'0';
				sig_slv2t0_busy_state	<=	"011";
			end if;
		elsif(sig_slv2t0_busy_state="100")then--΂炭̂busy
			I_SL_BUSY					<=	'1';
			sig_slv2t0_busy_state	<=	"001";
		end if;
	end if;
end process;
END;