----------------------------------------------------------------------------------
-- Product     : DATA_TRANSFER_PROCESS v1.0
-- Module      : DATA_TRANSFER_PROCESS v1.0
-- Last Update : 2011/04/07
-- 
-- Engineer    : Takuya Katayama
-- Mail        : pajamas@hotmail.co.jp
--
-- Copyright (C) 2011 Takuya Katayama All Rights Reserved.
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

entity DATA_TRANSFER_PROCESS is
port(
	--write
		I_SL_CLK					:	in		std_logic;
		I_SL_RESET				:	in		std_logic;
		I_SL_WRITE_ENABLE		:	in		std_logic;
		I_SL_DATA_ENABLE		:	in		std_logic;
		I_SLV15T0_DATA			:	in		std_logic_vector(15 downto 0);
	--read
		I_SL_BUSY				:	in		std_logic;--low_active
		O_SL_FLAME_ENABLE		:	out	std_logic;--low_active
		O_SL_STROBE				:	out	std_logic;--low_active
		O_SLV15T0_DATA			:	out	std_logic_vector(15 downto 0);
	--test_output
		O_SL_OVER_FLOW			:	out	std_logic;
		O_SLV15T0_READ_ADDRESS	:	out	std_logic_vector(15 downto 0)
);
end DATA_TRANSFER_PROCESS;

architecture Behavioral of DATA_TRANSFER_PROCESS is
-------------------------------------------------
--[U[ύX\̈--------------------------------
-------------------------------------------------

-------------------------------------------------
--16iBRAM̍őAhX+1(=ێ\)Ă--
-------------------------------------------------
constant	con_slv31t0_max_address		:	std_logic_vector(31 downto 0):=x"000C0000";
-------------------------------------------------
--ύXBRAM_IPɍ킹ĕύXĂ-----------------
-------------------------------------------------
component DATA_MEMORY
	port (
	clka: IN std_logic;
	wea: IN std_logic_VECTOR(0 downto 0);
	addra: IN std_logic_VECTOR(18 downto 0);
--	dina: IN std_logic_VECTOR(15 downto 0);
	dina: IN std_logic_VECTOR(0 downto 0);
	clkb: IN std_logic;
	addrb: IN std_logic_VECTOR(18 downto 0);
--	doutb: OUT std_logic_VECTOR(15 downto 0));
	doutb: OUT std_logic_VECTOR(0 downto 0));
end component;

-------------------------------------------------
--[U[ύX\̈I-----------------------------
-------------------------------------------------

signal	sig_slv31t0_write_address			:	std_logic_vector(31 downto 0):=(others=>'0');
signal	sig_slv31t0_read_address			:	std_logic_vector(31 downto 0):=(others=>'0');

signal	sig_slv31t0_read_end_adress		:	std_logic_vector(31 downto 0):=(others=>'0');

signal	sig_sl_write_enable					:	std_logic:='0';
signal	sig_sl_data_enable					:	std_logic:='0';
signal	sig_slv15t0_data						:	std_logic_vector(15 downto 0);

signal	sig_sl_write_end						:	std_logic:='0';

signal	sig_sl_data_enable_bram				:	std_logic_vector(0 downto 0);
signal	sig_slv31t0_write_address_bram	:	std_logic_vector(31 downto 0);
signal	sig_slv15t0_data_bram				:	std_logic_vector(15 downto 0);

signal	sig_sl_busy								:	std_logic:='0';

signal	sig_sl_flame_enable					:	std_logic:='0';
signal	sig_sl_strobe							:	std_logic:='0';
signal	sig_slv2t0_state						:	std_logic_vector(2 downto 0):=(others=>'0');

signal	sig_sl_busy_up_edge					:	std_logic:='0';
signal	sig_sl_busy_down_edge				:	std_logic:='0';
signal	sig_sl_busy_edge_create1			:	std_logic:='0';
signal	sig_sl_busy_edge_create2			:	std_logic:='0';

signal	sig_slv15t0_next_read_wait_timer	:	std_logic_vector(15 downto 0):=(others=>'0');

signal	sig_slv3t0_test_state				:	std_logic_vector(3 downto 0):=(others=>'0');

signal	sig_sl_over_flow						:	std_logic:='0';

begin

--ݗLԃ`FbJ[
process(I_SL_CLK)
begin
	if(I_SL_CLK'event and I_SL_CLK='1')then
		if(I_SL_WRITE_ENABLE='1')then
			sig_sl_write_enable	<=	I_SL_WRITE_ENABLE;
			sig_sl_data_enable	<=	I_SL_DATA_ENABLE;
			sig_slv15t0_data		<=	I_SLV15T0_DATA;
		else
			sig_sl_write_enable	<=	I_SL_WRITE_ENABLE;
			sig_sl_data_enable	<=	'0';
			sig_slv15t0_data		<=	I_SLV15T0_DATA;
		end if;
	end if;
end process;

--process(I_SL_CLK)
--begin
--	if(I_SL_CLK'event and I_SL_CLK='1')then
		sig_sl_busy	<=	I_SL_BUSY;
--	end if;
--end process;

--ݏĨAhX`FbJ[
process(I_SL_CLK,I_SL_RESET)
begin
	if(I_SL_RESET='0')then
		sig_slv31t0_read_end_adress	<=	(others=>'0');
		sig_sl_write_end					<=	'0';
	elsif(I_SL_CLK'event and I_SL_CLK='1')then
		if(I_SL_WRITE_ENABLE='0' and sig_sl_write_enable='1')then--݂I낤Ƃu
--			sig_slv15t0_read_end_adress	<=	sig_slv15t0_write_address	-	1;--ĨAhXL
			sig_slv31t0_read_end_adress	<=	sig_slv31t0_write_address;--ĨAhXL
			sig_sl_write_end					<=	'1';
		else
			sig_slv31t0_read_end_adress	<=	sig_slv31t0_read_end_adress;--͕ێ
			sig_sl_write_end					<=	sig_sl_write_end;
		end if;
	end if;
end process;

--f[^ӂĖǂ`FbN

O_SL_OVER_FLOW	<=	sig_sl_over_flow;

process(I_SL_CLK,I_SL_RESET)
begin
	if(I_SL_RESET='0')then
		sig_sl_over_flow	<=	'0';
	elsif(I_SL_CLK'event and I_SL_CLK='1')then
		if(con_slv31t0_max_address	<	sig_slv31t0_write_address)then
			sig_sl_over_flow	<=	'1';
		else
			sig_sl_over_flow	<=	sig_sl_over_flow;			
		end if;
	end if;
end process;


--AhXRg[[
process(I_SL_CLK,I_SL_RESET)
begin
	if(I_SL_RESET='0')then
		sig_slv31t0_write_address	<=	(others=>'0');
	elsif(I_SL_CLK'event and I_SL_CLK='1')then
		if(sig_sl_write_enable='1')then--ݗLԂłꍇ
			if(sig_sl_data_enable='1')then--ݗLłꍇ
				sig_slv31t0_write_address	<=	sig_slv31t0_write_address	+	1;
			else--݂LłȂꍇ
				sig_slv31t0_write_address	<=	sig_slv31t0_write_address;
			end if;
		else--ݗLԂłȂꍇ
			sig_slv31t0_write_address	<=	(others=>'0');
		end if;
	end if;
end process;

--BRAMpENABLEɂ镔EEEB
process(I_SL_CLK)
begin
	if(I_SL_CLK'event and I_SL_CLK='1')then
		if(sig_sl_data_enable='0')then
			sig_sl_data_enable_bram				<=	(others=>'0');
			sig_slv31t0_write_address_bram	<=	sig_slv31t0_write_address;
			sig_slv15t0_data_bram				<=	sig_slv15t0_data;
		else
			sig_sl_data_enable_bram				<=	(others=>'1');
			sig_slv31t0_write_address_bram	<=	sig_slv31t0_write_address;
			sig_slv15t0_data_bram				<=	sig_slv15t0_data;
		end if;
	end if;
end process;

--BRAM֐ڑ--݂1MBێ\Ȑݒ

-------------------------------------------------
--[U[ύX\̈--------------------------------
-------------------------------------------------

-------------------------------------------------
--ύXBRAM_IPɍ킹ĕύXĂ-----------------
-------------------------------------------------
RAM_0	:	DATA_MEMORY	port map(
		clka	=> I_SL_CLK,
		wea	=> sig_sl_data_enable_bram,
		addra	=> sig_slv31t0_write_address_bram(18 downto 0),
		dina	=> sig_slv15t0_data_bram(0 downto 0),
		clkb	=> I_SL_CLK,
		addrb	=> sig_slv31t0_read_address(18 downto 0),
		doutb	=> O_SLV15T0_DATA(0 downto 0)
);
RAM_1	:	DATA_MEMORY	port map(
		clka	=> I_SL_CLK,
		wea	=> sig_sl_data_enable_bram,
		addra	=> sig_slv31t0_write_address_bram(18 downto 0),
		dina	=> sig_slv15t0_data_bram(1 downto 1),
		clkb	=> I_SL_CLK,
		addrb	=> sig_slv31t0_read_address(18 downto 0),
		doutb	=> O_SLV15T0_DATA(1 downto 1)
);
RAM_2	:	DATA_MEMORY	port map(
		clka	=> I_SL_CLK,
		wea	=> sig_sl_data_enable_bram,
		addra	=> sig_slv31t0_write_address_bram(18 downto 0),
		dina	=> sig_slv15t0_data_bram(2 downto 2),
		clkb	=> I_SL_CLK,
		addrb	=> sig_slv31t0_read_address(18 downto 0),
		doutb	=> O_SLV15T0_DATA(2 downto 2)
);
RAM_3	:	DATA_MEMORY	port map(
		clka	=> I_SL_CLK,
		wea	=> sig_sl_data_enable_bram,
		addra	=> sig_slv31t0_write_address_bram(18 downto 0),
		dina	=> sig_slv15t0_data_bram(3 downto 3),
		clkb	=> I_SL_CLK,
		addrb	=> sig_slv31t0_read_address(18 downto 0),
		doutb	=> O_SLV15T0_DATA(3 downto 3)
);
RAM_4	:	DATA_MEMORY	port map(
		clka	=> I_SL_CLK,
		wea	=> sig_sl_data_enable_bram,
		addra	=> sig_slv31t0_write_address_bram(18 downto 0),
		dina	=> sig_slv15t0_data_bram(4 downto 4),
		clkb	=> I_SL_CLK,
		addrb	=> sig_slv31t0_read_address(18 downto 0),
		doutb	=> O_SLV15T0_DATA(4 downto 4)
);
RAM_5	:	DATA_MEMORY	port map(
		clka	=> I_SL_CLK,
		wea	=> sig_sl_data_enable_bram,
		addra	=> sig_slv31t0_write_address_bram(18 downto 0),
		dina	=> sig_slv15t0_data_bram(5 downto 5),
		clkb	=> I_SL_CLK,
		addrb	=> sig_slv31t0_read_address(18 downto 0),
		doutb	=> O_SLV15T0_DATA(5 downto 5)
);
RAM_6	:	DATA_MEMORY	port map(
		clka	=> I_SL_CLK,
		wea	=> sig_sl_data_enable_bram,
		addra	=> sig_slv31t0_write_address_bram(18 downto 0),
		dina	=> sig_slv15t0_data_bram(6 downto 6),
		clkb	=> I_SL_CLK,
		addrb	=> sig_slv31t0_read_address(18 downto 0),
		doutb	=> O_SLV15T0_DATA(6 downto 6)
);
RAM_7	:	DATA_MEMORY	port map(
		clka	=> I_SL_CLK,
		wea	=> sig_sl_data_enable_bram,
		addra	=> sig_slv31t0_write_address_bram(18 downto 0),
		dina	=> sig_slv15t0_data_bram(7 downto 7),
		clkb	=> I_SL_CLK,
		addrb	=> sig_slv31t0_read_address(18 downto 0),
		doutb	=> O_SLV15T0_DATA(7 downto 7)
);
RAM_8	:	DATA_MEMORY	port map(
		clka	=> I_SL_CLK,
		wea	=> sig_sl_data_enable_bram,
		addra	=> sig_slv31t0_write_address_bram(18 downto 0),
		dina	=> sig_slv15t0_data_bram(8 downto 8),
		clkb	=> I_SL_CLK,
		addrb	=> sig_slv31t0_read_address(18 downto 0),
		doutb	=> O_SLV15T0_DATA(8 downto 8)
);
RAM_9	:	DATA_MEMORY	port map(
		clka	=> I_SL_CLK,
		wea	=> sig_sl_data_enable_bram,
		addra	=> sig_slv31t0_write_address_bram(18 downto 0),
		dina	=> sig_slv15t0_data_bram(9 downto 9),
		clkb	=> I_SL_CLK,
		addrb	=> sig_slv31t0_read_address(18 downto 0),
		doutb	=> O_SLV15T0_DATA(9 downto 9)
);
RAM_A	:	DATA_MEMORY	port map(
		clka	=> I_SL_CLK,
		wea	=> sig_sl_data_enable_bram,
		addra	=> sig_slv31t0_write_address_bram(18 downto 0),
		dina	=> sig_slv15t0_data_bram(10 downto 10),
		clkb	=> I_SL_CLK,
		addrb	=> sig_slv31t0_read_address(18 downto 0),
		doutb	=> O_SLV15T0_DATA(10 downto 10)
);
RAM_B	:	DATA_MEMORY	port map(
		clka	=> I_SL_CLK,
		wea	=> sig_sl_data_enable_bram,
		addra	=> sig_slv31t0_write_address_bram(18 downto 0),
		dina	=> sig_slv15t0_data_bram(11 downto 11),
		clkb	=> I_SL_CLK,
		addrb	=> sig_slv31t0_read_address(18 downto 0),
		doutb	=> O_SLV15T0_DATA(11 downto 11)
);
RAM_C	:	DATA_MEMORY	port map(
		clka	=> I_SL_CLK,
		wea	=> sig_sl_data_enable_bram,
		addra	=> sig_slv31t0_write_address_bram(18 downto 0),
		dina	=> sig_slv15t0_data_bram(12 downto 12),
		clkb	=> I_SL_CLK,
		addrb	=> sig_slv31t0_read_address(18 downto 0),
		doutb	=> O_SLV15T0_DATA(12 downto 12)
);
RAM_D	:	DATA_MEMORY	port map(
		clka	=> I_SL_CLK,
		wea	=> sig_sl_data_enable_bram,
		addra	=> sig_slv31t0_write_address_bram(18 downto 0),
		dina	=> sig_slv15t0_data_bram(13 downto 13),
		clkb	=> I_SL_CLK,
		addrb	=> sig_slv31t0_read_address(18 downto 0),
		doutb	=> O_SLV15T0_DATA(13 downto 13)
);
RAM_E	:	DATA_MEMORY	port map(
		clka	=> I_SL_CLK,
		wea	=> sig_sl_data_enable_bram,
		addra	=> sig_slv31t0_write_address_bram(18 downto 0),
		dina	=> sig_slv15t0_data_bram(14 downto 14),
		clkb	=> I_SL_CLK,
		addrb	=> sig_slv31t0_read_address(18 downto 0),
		doutb	=> O_SLV15T0_DATA(14 downto 14)
);
RAM_F	:	DATA_MEMORY	port map(
		clka	=> I_SL_CLK,
		wea	=> sig_sl_data_enable_bram,
		addra	=> sig_slv31t0_write_address_bram(18 downto 0),
		dina	=> sig_slv15t0_data_bram(15 downto 15),
		clkb	=> I_SL_CLK,
		addrb	=> sig_slv31t0_read_address(18 downto 0),
		doutb	=> O_SLV15T0_DATA(15 downto 15)
);

-------------------------------------------------
--[U[ύX\̈I-----------------------------
-------------------------------------------------

--BUSỸGbWo
process(I_SL_CLK)
begin
	if(I_SL_CLK'event and I_SL_CLK='1')then
		if(sig_sl_busy='1')then
			sig_sl_busy_edge_create1	<=	'1';
		else
			sig_sl_busy_edge_create1	<=	'0';
		end if;
		if(sig_sl_busy_edge_create1='1')then
			sig_sl_busy_edge_create2	<=	'1';
		else
			sig_sl_busy_edge_create2	<=	'0';
		end if;			
	end if;
end process;

sig_sl_busy_down_edge	<=	not sig_sl_busy_edge_create1	and sig_sl_busy_edge_create2;
sig_sl_busy_up_edge		<=	sig_sl_busy_edge_create1	and not sig_sl_busy_edge_create2;

process(I_SL_CLK,I_SL_RESET)
begin
	if(I_SL_RESET='0')then--ZbgAԂdv
		sig_sl_flame_enable			<=	'1';
		sig_sl_strobe					<=	'1';
		sig_slv31t0_read_address	<=	(others=>'0');
		sig_slv2t0_state				<=	"000";
	elsif(I_SL_CLK'event and I_SL_CLK='1')then
		if(sig_slv2t0_state="000")then--X^[gۂBusy
			if(sig_sl_write_end='0')then--ݏIȂƐi񂶂_
					sig_sl_flame_enable			<=	'1';
					sig_sl_strobe					<=	'1';
					sig_slv31t0_read_address	<=	sig_slv31t0_read_address;
					sig_slv2t0_state				<=	"000";
			else
				if(sig_sl_busy='1')then
					sig_sl_flame_enable			<=	'0';
					sig_sl_strobe					<=	'0';
					sig_slv31t0_read_address	<=	sig_slv31t0_read_address;
					sig_slv2t0_state				<=	"001";
				else
					sig_sl_flame_enable			<=	'0';
					sig_sl_strobe					<=	'1';
					sig_slv31t0_read_address	<=	sig_slv31t0_read_address;
					sig_slv2t0_state				<=	"000";
				end if;
			end if;
		elsif(sig_slv2t0_state="001")then--busyOKȂ̂ŃXg{𕰂āHX^[g
			sig_sl_flame_enable			<=	'0';
			sig_sl_strobe					<=	'0';
			sig_slv31t0_read_address	<=	sig_slv31t0_read_address;
			if(sig_sl_busy_down_edge='1')then--BUSY̗GbWo܂Ŏ̃Xe[gւ͍sȂ
				sig_slv2t0_state				<=	"010";
				sig_slv3t0_test_state		<=	"0100";--test
			else
				sig_slv2t0_state				<=	"001";
				sig_slv3t0_test_state		<=	"0101";--test
			end if;
		elsif(sig_slv2t0_state="010")then--busyēxOKɂȂ܂Ńf[^ێ
			if(sig_sl_busy='1')then
				if(sig_slv31t0_read_address < sig_slv31t0_read_end_adress)then
					sig_sl_flame_enable			<=	'0';
					sig_sl_strobe					<=	'1';
					sig_slv31t0_read_address	<=	sig_slv31t0_read_address;
					sig_slv2t0_state				<=	"011";
					sig_slv3t0_test_state		<=	"0110";--test
				else
					sig_sl_flame_enable			<=	'0';
					sig_sl_strobe					<=	'0';
					sig_slv31t0_read_address	<=	sig_slv31t0_read_address;
					sig_slv2t0_state				<=	"011";
					sig_slv3t0_test_state		<=	"0111";--test
				end if;
			else
				sig_sl_flame_enable			<=	'0';
				sig_sl_strobe					<=	'0';
				sig_slv31t0_read_address	<=	sig_slv31t0_read_address;
				sig_slv2t0_state				<=	"010";
				sig_slv3t0_test_state		<=	"1000";--test
			end if;
		elsif(sig_slv2t0_state="011")then--busyēxOKɂȂ̂ŃXg{ɖ߂Bf[^ŏIłȂ΁Af[^XV̂߂Ɏ̃Xe[gIX^[gɖ߂@ႦΔEND
			if(sig_slv31t0_read_address < sig_slv31t0_read_end_adress)then
				sig_sl_flame_enable			<=	'0';
				sig_sl_strobe					<=	'1';
				sig_slv31t0_read_address	<=	sig_slv31t0_read_address;
				if(sig_slv15t0_next_read_wait_timer="1111111111111111")then
					sig_slv2t0_state						<=	"100";
					sig_slv15t0_next_read_wait_timer	<=	(others=>'0');
					sig_slv3t0_test_state		<=	"1001";--test
				else
					sig_slv15t0_next_read_wait_timer	<=	sig_slv15t0_next_read_wait_timer	+	1;
					sig_slv2t0_state						<=	"011";
					sig_slv3t0_test_state		<=	"1010";--test
				end if;
			else
				sig_sl_flame_enable			<=	'1';
				sig_sl_strobe					<=	'1';
				sig_slv31t0_read_address	<=	sig_slv31t0_read_address;
				sig_slv2t0_state				<=	"111";
				sig_slv3t0_test_state		<=	"1011";--test
			end if;
		elsif(sig_slv2t0_state="100")then--f[^XV
			sig_sl_flame_enable			<=	'0';
			sig_sl_strobe					<=	'1';
			sig_slv31t0_read_address	<=	sig_slv31t0_read_address	+	1;
			sig_slv2t0_state				<=	"000";
			sig_slv3t0_test_state		<=	"1100";--test
		end if;
	end if;
end process;

O_SL_FLAME_ENABLE	<=	sig_sl_flame_enable;
O_SL_STROBE			<=	sig_sl_strobe;

--test_output
O_SLV15T0_READ_ADDRESS	<=	sig_slv31t0_read_address(15 downto 0);
--O_SLV15T0_READ_ADDRESS	<=	"000000000"	&	sig_slv3t0_test_state	&	sig_slv2t0_state;
--test_output_end

end Behavioral;