------------------------------------------------------------
-- Product     : JPEG_ENCODER v1.1                       --
-- Module      : DCT_PROCESS v1.2                         --
-- Last Update : 2011/06/12                               --
--                                                        --
-- Engineer    : Takuya Katayama                          --
-- Mail        : pajamas@hotmail.co.jp                    --
--                                                        --
-- Copyright (C) 2011 Takuya Katayama All Rights Reserved.--
------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

entity DCT_8POINT_2 is
port(	I_SL_CLK			:	in		std_logic;
		I_SL_RESET		:	in		std_logic;
		I_SL_START		:	in		std_logic;
		I_SLV10T0_DATA	:	in		std_logic_vector(10 downto 0);
		O_SL_START		:	out	std_logic;
		O_SLV11T0_DATA	:	out	std_logic_vector(11 downto 0)
);
end DCT_8POINT_2;

architecture Behavioral of DCT_8POINT_2 is

component DCT_POINT2
	port(
			I_SL_CLK					:	in		std_logic;
			I_SLV10T0_DATA			:	in		std_logic_vector(10 downto 0);
			I_SLV15T0_DCT_VALUE	:	in		std_logic_vector(15 downto 0);
			I_SL_DCT_VALUE_FLAG	:	in		std_logic;
			O_SLV11T0_DATA			:	out	std_logic_vector(11 downto 0)
	);
end component;

constant	con_start_flag_delay_int			:	integer:=15;--̃ubN̒xʂ͍̒l{2
signal	sig_slv31t0_start_flag_shift_reg	:	std_logic_vector(31 downto 0);
                                                                                 
signal	sig_slv10t0_data			:	std_logic_vector(10 downto 0);
signal	sig_slv10t0_data_f		:	std_logic_vector(10 downto 0);

signal	sig_slv2t0_count			:	std_logic_vector(2 downto 0);
signal	sig_slv2t0_count_d01		:	std_logic_vector(2 downto 0);
signal	sig_slv2t0_count_d02		:	std_logic_vector(2 downto 0);
signal	sig_slv2t0_count_d03		:	std_logic_vector(2 downto 0);
signal	sig_slv2t0_count_d04		:	std_logic_vector(2 downto 0);
signal	sig_slv2t0_count_d05		:	std_logic_vector(2 downto 0);
signal	sig_slv2t0_count_d06		:	std_logic_vector(2 downto 0);
signal	sig_slv2t0_count_d07		:	std_logic_vector(2 downto 0);
signal	sig_slv2t0_count_d08		:	std_logic_vector(2 downto 0);
signal	sig_slv2t0_count_d09		:	std_logic_vector(2 downto 0);
signal	sig_slv2t0_count_d10		:	std_logic_vector(2 downto 0);
signal	sig_slv2t0_count_d11		:	std_logic_vector(2 downto 0);
signal	sig_slv2t0_count_d12		:	std_logic_vector(2 downto 0);
signal	sig_slv2t0_count_d13		:	std_logic_vector(2 downto 0);
signal	sig_slv2t0_count_d14		:	std_logic_vector(2 downto 0);
signal	sig_slv2t0_count_d15		:	std_logic_vector(2 downto 0);


signal	sig_slv15t0_dct_value1	:	std_logic_vector(15 downto 0);
signal	sig_slv15t0_dct_value2	:	std_logic_vector(15 downto 0);
signal	sig_slv15t0_dct_value3	:	std_logic_vector(15 downto 0);
signal	sig_slv15t0_dct_value4	:	std_logic_vector(15 downto 0);
signal	sig_slv15t0_dct_value5	:	std_logic_vector(15 downto 0);
signal	sig_slv15t0_dct_value6	:	std_logic_vector(15 downto 0);
signal	sig_slv15t0_dct_value7	:	std_logic_vector(15 downto 0);
signal	sig_slv15t0_dct_value8	:	std_logic_vector(15 downto 0);
signal	sig_sl_dct_value1_flag	:	std_logic;        
signal	sig_sl_dct_value2_flag	:	std_logic;
signal	sig_sl_dct_value3_flag	:	std_logic;
signal	sig_sl_dct_value4_flag	:	std_logic;
signal	sig_sl_dct_value5_flag	:	std_logic;
signal	sig_sl_dct_value6_flag	:	std_logic;
signal	sig_sl_dct_value7_flag	:	std_logic;
signal	sig_sl_dct_value8_flag	:	std_logic;

signal	sig_slv11t0_dct_point1_1	:	std_logic_vector(11 downto 0);

signal	sig_slv11t0_dct_point2_1	:	std_logic_vector(11 downto 0);
signal	sig_slv11t0_dct_point2_2	:	std_logic_vector(11 downto 0);

signal	sig_slv11t0_dct_point3_1	:	std_logic_vector(11 downto 0);
signal	sig_slv11t0_dct_point3_2	:	std_logic_vector(11 downto 0);
signal	sig_slv11t0_dct_point3_3	:	std_logic_vector(11 downto 0);

signal	sig_slv11t0_dct_point4_1	:	std_logic_vector(11 downto 0);
signal	sig_slv11t0_dct_point4_2	:	std_logic_vector(11 downto 0);
signal	sig_slv11t0_dct_point4_3	:	std_logic_vector(11 downto 0);
signal	sig_slv11t0_dct_point4_4	:	std_logic_vector(11 downto 0);

signal	sig_slv11t0_dct_point5_1	:	std_logic_vector(11 downto 0);
signal	sig_slv11t0_dct_point5_2	:	std_logic_vector(11 downto 0);
signal	sig_slv11t0_dct_point5_3	:	std_logic_vector(11 downto 0);
signal	sig_slv11t0_dct_point5_4	:	std_logic_vector(11 downto 0);
signal	sig_slv11t0_dct_point5_5	:	std_logic_vector(11 downto 0);
                                                   
signal	sig_slv11t0_dct_point6_1	:	std_logic_vector(11 downto 0);
signal	sig_slv11t0_dct_point6_2	:	std_logic_vector(11 downto 0);
signal	sig_slv11t0_dct_point6_3	:	std_logic_vector(11 downto 0);
signal	sig_slv11t0_dct_point6_4	:	std_logic_vector(11 downto 0);
signal	sig_slv11t0_dct_point6_5	:	std_logic_vector(11 downto 0);
signal	sig_slv11t0_dct_point6_6	:	std_logic_vector(11 downto 0);

signal	sig_slv11t0_dct_point7_1	:	std_logic_vector(11 downto 0);
signal	sig_slv11t0_dct_point7_2	:	std_logic_vector(11 downto 0);
signal	sig_slv11t0_dct_point7_3	:	std_logic_vector(11 downto 0);
signal	sig_slv11t0_dct_point7_4	:	std_logic_vector(11 downto 0);
signal	sig_slv11t0_dct_point7_5	:	std_logic_vector(11 downto 0);
signal	sig_slv11t0_dct_point7_6	:	std_logic_vector(11 downto 0);
signal	sig_slv11t0_dct_point7_7	:	std_logic_vector(11 downto 0);
                                                   
signal	sig_slv11t0_dct_point8_1	:	std_logic_vector(11 downto 0);
signal	sig_slv11t0_dct_point8_2	:	std_logic_vector(11 downto 0);
signal	sig_slv11t0_dct_point8_3	:	std_logic_vector(11 downto 0);
signal	sig_slv11t0_dct_point8_4	:	std_logic_vector(11 downto 0);
signal	sig_slv11t0_dct_point8_5	:	std_logic_vector(11 downto 0);
signal	sig_slv11t0_dct_point8_6	:	std_logic_vector(11 downto 0);
signal	sig_slv11t0_dct_point8_7	:	std_logic_vector(11 downto 0);
signal	sig_slv11t0_dct_point8_8	:	std_logic_vector(11 downto 0);
                                                   
begin

process(I_SL_CLK)
begin
	if(I_SL_CLK'event and I_SL_CLK='1')then
			sig_slv31t0_start_flag_shift_reg(31 downto 1)	<=	sig_slv31t0_start_flag_shift_reg(30 downto 1)	&	I_SL_START;
			O_SL_START	<=	sig_slv31t0_start_flag_shift_reg(con_start_flag_delay_int);
	end if;
end process;

--擪DCTďZpCvC
process(I_SL_CLK)
begin
	if(I_SL_CLK'event and I_SL_CLK='1')then
		if(I_SL_START='1' or sig_slv2t0_count="111")then
			sig_slv2t0_count	<=	"000";
		else
			sig_slv2t0_count	<=	sig_slv2t0_count	+	1;
		end if;
	end if;
end process;

--DCTWĂяo܂ŁA҂
process(I_SL_CLK)
begin
	if(I_SL_CLK'event and I_SL_CLK='1')then
		sig_slv10t0_data_f	<=	I_SLV10T0_DATA;
		sig_slv10t0_data		<=	sig_slv10t0_data_f;
	end if;
end process;

--DCŤŒlvZʕ\(؎̂)
process(I_SL_CLK)
begin
	if(I_SL_CLK'event and I_SL_CLK='1')then
		if(sig_slv2t0_count="000")then
			sig_slv15t0_dct_value1	<=	"0101101010000010";
			sig_slv15t0_dct_value2	<=	"0111110110001010";
			sig_slv15t0_dct_value3	<=	"0111011001000001";
			sig_slv15t0_dct_value4	<=	"0110101001101101";
			sig_slv15t0_dct_value5	<=	"0101101010000010";
			sig_slv15t0_dct_value6	<=	"0100011100011100";
			sig_slv15t0_dct_value7	<=	"0011000011111011";
			sig_slv15t0_dct_value8	<=	"0001100011111000";
			sig_sl_dct_value1_flag	<=	'0';
			sig_sl_dct_value2_flag	<=	'0';
			sig_sl_dct_value3_flag	<=	'0';
			sig_sl_dct_value4_flag	<=	'0';
			sig_sl_dct_value5_flag	<=	'0';
			sig_sl_dct_value6_flag	<=	'0';
			sig_sl_dct_value7_flag	<=	'0';
			sig_sl_dct_value8_flag	<=	'0';
		elsif(sig_slv2t0_count="001")then
			sig_slv15t0_dct_value1	<=	"0101101010000010";
			sig_slv15t0_dct_value2	<=	"0110101001101101";
			sig_slv15t0_dct_value3	<=	"0011000011111011";
			sig_slv15t0_dct_value4	<=	"0001100011111000";
			sig_slv15t0_dct_value5	<=	"0101101010000010";
			sig_slv15t0_dct_value6	<=	"0111110110001010";
			sig_slv15t0_dct_value7	<=	"0111011001000001";
			sig_slv15t0_dct_value8	<=	"0100011100011100";
			sig_sl_dct_value1_flag	<=	'0';
			sig_sl_dct_value2_flag	<=	'0';
			sig_sl_dct_value3_flag	<=	'0';
			sig_sl_dct_value4_flag	<=	'1';
			sig_sl_dct_value5_flag	<=	'1';
			sig_sl_dct_value6_flag	<=	'1';
			sig_sl_dct_value7_flag	<=	'1';
			sig_sl_dct_value8_flag	<=	'1';
		elsif(sig_slv2t0_count="010")then
			sig_slv15t0_dct_value1	<=	"0101101010000010";
			sig_slv15t0_dct_value2	<=	"0100011100011100";
			sig_slv15t0_dct_value3	<=	"0011000011111011";
			sig_slv15t0_dct_value4	<=	"0111110110001010";
			sig_slv15t0_dct_value5	<=	"0101101010000010";
			sig_slv15t0_dct_value6	<=	"0001100011111000";
			sig_slv15t0_dct_value7	<=	"0111011001000001";
			sig_slv15t0_dct_value8	<=	"0110101001101101";
			sig_sl_dct_value1_flag	<=	'0';
			sig_sl_dct_value2_flag	<=	'0';
			sig_sl_dct_value3_flag	<=	'1';
			sig_sl_dct_value4_flag	<=	'1';
			sig_sl_dct_value5_flag	<=	'1';
			sig_sl_dct_value6_flag	<=	'0';
			sig_sl_dct_value7_flag	<=	'0';
			sig_sl_dct_value8_flag	<=	'0';
		elsif(sig_slv2t0_count="011")then
			sig_slv15t0_dct_value1	<=	"0101101010000010";
			sig_slv15t0_dct_value2	<=	"0001100011111000";
			sig_slv15t0_dct_value3	<=	"0111011001000001";
			sig_slv15t0_dct_value4	<=	"0100011100011100";
			sig_slv15t0_dct_value5	<=	"0101101010000010";
			sig_slv15t0_dct_value6	<=	"0110101001101101";
			sig_slv15t0_dct_value7	<=	"0011000011111011";
			sig_slv15t0_dct_value8	<=	"0111110110001010";
			sig_sl_dct_value1_flag	<=	'0';
			sig_sl_dct_value2_flag	<=	'0';
			sig_sl_dct_value3_flag	<=	'1';
			sig_sl_dct_value4_flag	<=	'1';
			sig_sl_dct_value5_flag	<=	'0';
			sig_sl_dct_value6_flag	<=	'0';
			sig_sl_dct_value7_flag	<=	'1';
			sig_sl_dct_value8_flag	<=	'1';
		elsif(sig_slv2t0_count="100")then
			sig_slv15t0_dct_value1	<=	"0101101010000010";
			sig_slv15t0_dct_value2	<=	"0001100011111000";
			sig_slv15t0_dct_value3	<=	"0111011001000001";
			sig_slv15t0_dct_value4	<=	"0100011100011100";
			sig_slv15t0_dct_value5	<=	"0101101010000010";
			sig_slv15t0_dct_value6	<=	"0110101001101101";
			sig_slv15t0_dct_value7	<=	"0011000011111011";
			sig_slv15t0_dct_value8	<=	"0111110110001010";
			sig_sl_dct_value1_flag	<=	'0';
			sig_sl_dct_value2_flag	<=	'1';
			sig_sl_dct_value3_flag	<=	'1';
			sig_sl_dct_value4_flag	<=	'0';
			sig_sl_dct_value5_flag	<=	'0';
			sig_sl_dct_value6_flag	<=	'1';
			sig_sl_dct_value7_flag	<=	'1';
			sig_sl_dct_value8_flag	<=	'0';
		elsif(sig_slv2t0_count="101")then
			sig_slv15t0_dct_value1	<=	"0101101010000010";
			sig_slv15t0_dct_value2	<=	"0100011100011100";
			sig_slv15t0_dct_value3	<=	"0011000011111011";
			sig_slv15t0_dct_value4	<=	"0111110110001010";
			sig_slv15t0_dct_value5	<=	"0101101010000010";
			sig_slv15t0_dct_value6	<=	"0001100011111000";
			sig_slv15t0_dct_value7	<=	"0111011001000001";
			sig_slv15t0_dct_value8	<=	"0110101001101101";
			sig_sl_dct_value1_flag	<=	'0';
			sig_sl_dct_value2_flag	<=	'1';
			sig_sl_dct_value3_flag	<=	'1';
			sig_sl_dct_value4_flag	<=	'0';
			sig_sl_dct_value5_flag	<=	'1';
			sig_sl_dct_value6_flag	<=	'1';
			sig_sl_dct_value7_flag	<=	'0';
			sig_sl_dct_value8_flag	<=	'1';
		elsif(sig_slv2t0_count="110")then
			sig_slv15t0_dct_value1	<=	"0101101010000010";
			sig_slv15t0_dct_value2	<=	"0110101001101101";
			sig_slv15t0_dct_value3	<=	"0011000011111011";
			sig_slv15t0_dct_value4	<=	"0001100011111000";
			sig_slv15t0_dct_value5	<=	"0101101010000010";
			sig_slv15t0_dct_value6	<=	"0111110110001010";
			sig_slv15t0_dct_value7	<=	"0111011001000001";
			sig_slv15t0_dct_value8	<=	"0100011100011100";
			sig_sl_dct_value1_flag	<=	'0';
			sig_sl_dct_value2_flag	<=	'1';
			sig_sl_dct_value3_flag	<=	'0';
			sig_sl_dct_value4_flag	<=	'0';
			sig_sl_dct_value5_flag	<=	'1';
			sig_sl_dct_value6_flag	<=	'0';
			sig_sl_dct_value7_flag	<=	'1';
			sig_sl_dct_value8_flag	<=	'0';
		elsif(sig_slv2t0_count="111")then
			sig_slv15t0_dct_value1	<=	"0101101010000010";
			sig_slv15t0_dct_value2	<=	"0111110110001010";
			sig_slv15t0_dct_value3	<=	"0111011001000001";
			sig_slv15t0_dct_value4	<=	"0110101001101101";
			sig_slv15t0_dct_value5	<=	"0101101010000010";
			sig_slv15t0_dct_value6	<=	"0100011100011100";
			sig_slv15t0_dct_value7	<=	"0011000011111011";
			sig_slv15t0_dct_value8	<=	"0001100011111000";
			sig_sl_dct_value1_flag	<=	'0';
			sig_sl_dct_value2_flag	<=	'1';
			sig_sl_dct_value3_flag	<=	'0';
			sig_sl_dct_value4_flag	<=	'1';
			sig_sl_dct_value5_flag	<=	'0';
			sig_sl_dct_value6_flag	<=	'1';
			sig_sl_dct_value7_flag	<=	'0';
			sig_sl_dct_value8_flag	<=	'1';
		end if;
	end if;
end process;


process(I_SL_CLK)
begin
	if(I_SL_CLK'event and I_SL_CLK='1')then
		sig_slv2t0_count_d01	<=	sig_slv2t0_count;
		sig_slv2t0_count_d02	<=	sig_slv2t0_count_d01;
		sig_slv2t0_count_d03	<=	sig_slv2t0_count_d02;
		sig_slv2t0_count_d04	<=	sig_slv2t0_count_d03;
		sig_slv2t0_count_d05	<=	sig_slv2t0_count_d04;
		sig_slv2t0_count_d06	<=	sig_slv2t0_count_d05;
		sig_slv2t0_count_d07	<=	sig_slv2t0_count_d06;
		sig_slv2t0_count_d08	<=	sig_slv2t0_count_d07;
		sig_slv2t0_count_d09	<=	sig_slv2t0_count_d08;
		sig_slv2t0_count_d10	<=	sig_slv2t0_count_d09;
		sig_slv2t0_count_d11	<=	sig_slv2t0_count_d10;
		sig_slv2t0_count_d12	<=	sig_slv2t0_count_d11;
		sig_slv2t0_count_d13	<=	sig_slv2t0_count_d12;
		sig_slv2t0_count_d14	<=	sig_slv2t0_count_d13;
		sig_slv2t0_count_d15	<=	sig_slv2t0_count_d14;
	end if;                                      
end process;

-------------------------------------------------------------------------

	point1	:	DCT_POINT2	port map(
			I_SL_CLK					=>	I_SL_CLK,
			I_SLV10T0_DATA			=>	sig_slv10t0_data,
			I_SLV15T0_DCT_VALUE	=>	sig_slv15t0_dct_value1,
			I_SL_DCT_VALUE_FLAG	=>	sig_sl_dct_value1_flag,
			O_SLV11T0_DATA			=>	sig_slv11t0_dct_point1_1
	);
	point2	:	DCT_POINT2	port map(
			I_SL_CLK					=>	I_SL_CLK,
			I_SLV10T0_DATA			=>	sig_slv10t0_data,
			I_SLV15T0_DCT_VALUE	=>	sig_slv15t0_dct_value2,
			I_SL_DCT_VALUE_FLAG	=>	sig_sl_dct_value2_flag,
			O_SLV11T0_DATA			=>	sig_slv11t0_dct_point2_1
	);
	point3	:	DCT_POINT2	port map(
			I_SL_CLK					=>	I_SL_CLK,
			I_SLV10T0_DATA			=>	sig_slv10t0_data,
			I_SLV15T0_DCT_VALUE	=>	sig_slv15t0_dct_value3,
			I_SL_DCT_VALUE_FLAG	=>	sig_sl_dct_value3_flag,
			O_SLV11T0_DATA			=>	sig_slv11t0_dct_point3_1
	);
	point4	:	DCT_POINT2	port map(
			I_SL_CLK					=>	I_SL_CLK,
			I_SLV10T0_DATA			=>	sig_slv10t0_data,
			I_SLV15T0_DCT_VALUE	=>	sig_slv15t0_dct_value4,
			I_SL_DCT_VALUE_FLAG	=>	sig_sl_dct_value4_flag,
			O_SLV11T0_DATA			=>	sig_slv11t0_dct_point4_1
	);	
	point5	:	DCT_POINT2	port map(
			I_SL_CLK					=>	I_SL_CLK,
			I_SLV10T0_DATA			=>	sig_slv10t0_data,
			I_SLV15T0_DCT_VALUE	=>	sig_slv15t0_dct_value5,
			I_SL_DCT_VALUE_FLAG	=>	sig_sl_dct_value5_flag,
			O_SLV11T0_DATA			=>	sig_slv11t0_dct_point5_1
	);
	point6	:	DCT_POINT2	port map(
			I_SL_CLK					=>	I_SL_CLK,
			I_SLV10T0_DATA			=>	sig_slv10t0_data,
			I_SLV15T0_DCT_VALUE	=>	sig_slv15t0_dct_value6,
			I_SL_DCT_VALUE_FLAG	=>	sig_sl_dct_value6_flag,
			O_SLV11T0_DATA			=>	sig_slv11t0_dct_point6_1
	);
	point7	:	DCT_POINT2	port map(
			I_SL_CLK					=>	I_SL_CLK,
			I_SLV10T0_DATA			=>	sig_slv10t0_data,
			I_SLV15T0_DCT_VALUE	=>	sig_slv15t0_dct_value7,
			I_SL_DCT_VALUE_FLAG	=>	sig_sl_dct_value7_flag,
			O_SLV11T0_DATA			=>	sig_slv11t0_dct_point7_1
	);
	point8	:	DCT_POINT2	port map(
			I_SL_CLK					=>	I_SL_CLK,
			I_SLV10T0_DATA			=>	sig_slv10t0_data,
			I_SLV15T0_DCT_VALUE	=>	sig_slv15t0_dct_value8,
			I_SL_DCT_VALUE_FLAG	=>	sig_sl_dct_value8_flag,
			O_SLV11T0_DATA			=>	sig_slv11t0_dct_point8_1
	);	

-------------------------------------------------------------------------
--M^C~O悭EĂB
--8_oĂ̂ŁEEEB
process(I_SL_CLK)
begin
	if(I_SL_CLK'event and I_SL_CLK='1')then
		sig_slv11t0_dct_point2_2	<=	sig_slv11t0_dct_point2_1;
	end if;
end process;
process(I_SL_CLK)
begin
	if(I_SL_CLK'event and I_SL_CLK='1')then
		sig_slv11t0_dct_point3_2	<=	sig_slv11t0_dct_point3_1;
		sig_slv11t0_dct_point3_3	<=	sig_slv11t0_dct_point3_2;
	end if;
end process;
process(I_SL_CLK)
begin
	if(I_SL_CLK'event and I_SL_CLK='1')then
		sig_slv11t0_dct_point4_2	<=	sig_slv11t0_dct_point4_1;
		sig_slv11t0_dct_point4_3	<=	sig_slv11t0_dct_point4_2;
		sig_slv11t0_dct_point4_4	<=	sig_slv11t0_dct_point4_3;
	end if;
end process;
process(I_SL_CLK)
begin
	if(I_SL_CLK'event and I_SL_CLK='1')then
		sig_slv11t0_dct_point5_2	<=	sig_slv11t0_dct_point5_1;
		sig_slv11t0_dct_point5_3	<=	sig_slv11t0_dct_point5_2;
		sig_slv11t0_dct_point5_4	<=	sig_slv11t0_dct_point5_3;
		sig_slv11t0_dct_point5_5	<=	sig_slv11t0_dct_point5_4;
	end if;
end process;
process(I_SL_CLK)
begin
	if(I_SL_CLK'event and I_SL_CLK='1')then
		sig_slv11t0_dct_point6_2	<=	sig_slv11t0_dct_point6_1;
		sig_slv11t0_dct_point6_3	<=	sig_slv11t0_dct_point6_2;
		sig_slv11t0_dct_point6_4	<=	sig_slv11t0_dct_point6_3;
		sig_slv11t0_dct_point6_5	<=	sig_slv11t0_dct_point6_4;
		sig_slv11t0_dct_point6_6	<=	sig_slv11t0_dct_point6_5;
	end if;
end process;
process(I_SL_CLK)
begin
	if(I_SL_CLK'event and I_SL_CLK='1')then
		sig_slv11t0_dct_point7_2	<=	sig_slv11t0_dct_point7_1;
		sig_slv11t0_dct_point7_3	<=	sig_slv11t0_dct_point7_2;
		sig_slv11t0_dct_point7_4	<=	sig_slv11t0_dct_point7_3;
		sig_slv11t0_dct_point7_5	<=	sig_slv11t0_dct_point7_4;
		sig_slv11t0_dct_point7_6	<=	sig_slv11t0_dct_point7_5;
		sig_slv11t0_dct_point7_7	<=	sig_slv11t0_dct_point7_6;
	end if;
end process;
process(I_SL_CLK)
begin
	if(I_SL_CLK'event and I_SL_CLK='1')then
		sig_slv11t0_dct_point8_2	<=	sig_slv11t0_dct_point8_1;
		sig_slv11t0_dct_point8_3	<=	sig_slv11t0_dct_point8_2;
		sig_slv11t0_dct_point8_4	<=	sig_slv11t0_dct_point8_3;
		sig_slv11t0_dct_point8_5	<=	sig_slv11t0_dct_point8_4;
		sig_slv11t0_dct_point8_6	<=	sig_slv11t0_dct_point8_5;
		sig_slv11t0_dct_point8_7	<=	sig_slv11t0_dct_point8_6;
		sig_slv11t0_dct_point8_8	<=	sig_slv11t0_dct_point8_7;
	end if;
end process;

process(I_SL_CLK)
begin
	if(I_SL_CLK'event and I_SL_CLK='1')then
		if(sig_slv2t0_count_d15="000")then
			O_SLV11T0_DATA	<=	sig_slv11t0_dct_point1_1;
		elsif(sig_slv2t0_count_d15="001")then
			O_SLV11T0_DATA	<=	sig_slv11t0_dct_point2_2;
		elsif(sig_slv2t0_count_d15="010")then
			O_SLV11T0_DATA	<=	sig_slv11t0_dct_point3_3;
		elsif(sig_slv2t0_count_d15="011")then
			O_SLV11T0_DATA	<=	sig_slv11t0_dct_point4_4;
		elsif(sig_slv2t0_count_d15="100")then
			O_SLV11T0_DATA	<=	sig_slv11t0_dct_point5_5;
		elsif(sig_slv2t0_count_d15="101")then
			O_SLV11T0_DATA	<=	sig_slv11t0_dct_point6_6;
		elsif(sig_slv2t0_count_d15="110")then
			O_SLV11T0_DATA	<=	sig_slv11t0_dct_point7_7;
		elsif(sig_slv2t0_count_d15="111")then
			O_SLV11T0_DATA	<=	sig_slv11t0_dct_point8_8;
		end if;
	end if;
end process;

end Behavioral;