------------------------------------------------------------
-- Product     : JPEG_ENCODER v1.1                       --
-- Module      : HUFFMAN_ENCODER_PROCESS v1.1             --
-- Last Update : 2011/04/20                               --
--                                                        --
-- Engineer    : Takuya Katayama                          --
-- Mail        : pajamas@hotmail.co.jp                    --
--                                                        --
-- Copyright (C) 2011 Takuya Katayama All Rights Reserved.--
------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

entity FF_CHECK_BUFFER is
port(	
		I_SL_CLK								:	in		std_logic;
		I_SL_FLAME_ENABLE					:	in		std_logic;
		I_SL_WRITE_ENABLE					:	in		std_logic;
		I_SLV15T0_DATA						:	in		std_logic_vector(15 downto 0);
		I_SL_BIT_TO_2BYTE_BUFFER_END	:	in		std_logic;
		O_SL_DATA_ENABLE					:	out	std_logic;
		O_SLV15T0_DATA						:	out	std_logic_vector(15 downto 0);
		O_SL_FF_CHECK_BUFFER_END		:	out	std_logic;
	--fobOp
		O_SLV7T0_LED_DATA					:	out	std_logic_vector(7 downto 0)
);
end FF_CHECK_BUFFER;

architecture Behavioral of FF_CHECK_BUFFER is

signal	sig_sl_data_enable					:	std_logic:='0';
signal	sig_sl_data_enable_01c_dff			:	std_logic:='0';

signal	sig_slv1t0_ff_detector				:	std_logic_vector(1 downto 0):=(others=>'0');

signal	sig_slv15t0_data						:	std_logic_vector(15 downto 0):=(others=>'0');
signal	sig_slv15t0_data_01c_dff			:	std_logic_vector(15 downto 0):=(others=>'0');

signal	sig_slv127t0_ff_detect_buffer				:	std_logic_vector(127 downto 0);
signal	sig_int127t0_ff_detect_buffer_pointer	:	integer range 31 to 127:=127;

signal	sig_sl_1st_buffer_output_end				:	std_logic:='0';
signal	sig_sl_1st_buffer_output_end_01c_dff	:	std_logic:='0';


begin

sig_sl_data_enable				<=	I_SL_WRITE_ENABLE;
sig_slv15t0_data					<=	I_SLV15T0_DATA;
sig_sl_1st_buffer_output_end	<=	I_SL_BIT_TO_2BYTE_BUFFER_END;

--FF΁A00}ă}[J[łȂ𖾋LȂĂ͂Ȃ
process(I_SL_CLK)
begin
	if(I_SL_CLK'event and I_SL_CLK='1')then
		if(sig_sl_data_enable='1')then
			if(sig_slv15t0_data(15 downto 8)="11111111")then
				sig_slv1t0_ff_detector(1)	<=	'1';
				if(sig_slv15t0_data(7 downto 0)="11111111")then
					sig_slv1t0_ff_detector(0)	<=	'1';
				else
					sig_slv1t0_ff_detector(0)	<=	'0';
				end if;
			else
				sig_slv1t0_ff_detector(1)	<=	'0';
				if(sig_slv15t0_data(7 downto 0)="11111111")then
					sig_slv1t0_ff_detector(0)	<=	'1';
				else
					sig_slv1t0_ff_detector(0)	<=	'0';
				end if;
			end if;
		else
			sig_slv1t0_ff_detector		<=	"00";
		end if;
	sig_slv15t0_data_01c_dff	<=	sig_slv15t0_data;
	sig_sl_data_enable_01c_dff	<=	sig_sl_data_enable;
	sig_sl_1st_buffer_output_end_01c_dff	<=	sig_sl_1st_buffer_output_end;
	end if;
end process;

process(I_SL_CLK)
begin
	if(I_SL_CLK'event and I_SL_CLK='1')then
		if(I_SL_FLAME_ENABLE='0')then
			sig_int127t0_ff_detect_buffer_pointer	<=	127;
			O_SL_DATA_ENABLE								<=	'0';
			O_SL_FF_CHECK_BUFFER_END					<=	'0';	
		--obt@[Kʈȉ@ON
		elsif(sig_int127t0_ff_detect_buffer_pointer >= 111 and sig_sl_data_enable_01c_dff='1')then
			if(sig_slv1t0_ff_detector="00")then--ރf[^=16bit
				O_SL_DATA_ENABLE								<=	'0';
				sig_int127t0_ff_detect_buffer_pointer	<=	sig_int127t0_ff_detect_buffer_pointer - 16;
			elsif(sig_slv1t0_ff_detector="10")then--ރf[^=24bit
				O_SL_DATA_ENABLE								<=	'0';
				sig_int127t0_ff_detect_buffer_pointer	<=	sig_int127t0_ff_detect_buffer_pointer - 24;
			elsif(sig_slv1t0_ff_detector="01")then--ރf[^=24bit
				O_SL_DATA_ENABLE								<=	'0';
				sig_int127t0_ff_detect_buffer_pointer	<=	sig_int127t0_ff_detect_buffer_pointer - 24;
			elsif(sig_slv1t0_ff_detector="11")then--ރf[^=32bit
				O_SL_DATA_ENABLE								<=	'0';
				sig_int127t0_ff_detect_buffer_pointer	<=	sig_int127t0_ff_detect_buffer_pointer - 32;
			end if;
		--obt@[Kʈȉ@OFF
		elsif(sig_int127t0_ff_detect_buffer_pointer >= 111 and sig_sl_1st_buffer_output_end_01c_dff='0')then
			O_SL_DATA_ENABLE								<=	'0';
			sig_int127t0_ff_detect_buffer_pointer	<=	sig_int127t0_ff_detect_buffer_pointer;
		--obt@[Kʈȏ@ON
		elsif(sig_sl_data_enable_01c_dff='1')then
			if(sig_slv1t0_ff_detector="00")then--ރf[^=16bit
				O_SL_DATA_ENABLE								<=	'1';
				sig_int127t0_ff_detect_buffer_pointer	<=	sig_int127t0_ff_detect_buffer_pointer;
			elsif(sig_slv1t0_ff_detector="10")then--ރf[^=24bit
				O_SL_DATA_ENABLE								<=	'1';
				sig_int127t0_ff_detect_buffer_pointer	<=	sig_int127t0_ff_detect_buffer_pointer - 8;
			elsif(sig_slv1t0_ff_detector="01")then--ރf[^=24bit
				O_SL_DATA_ENABLE								<=	'1';
				sig_int127t0_ff_detect_buffer_pointer	<=	sig_int127t0_ff_detect_buffer_pointer - 8;
			elsif(sig_slv1t0_ff_detector="11")then--ރf[^=32bit
				O_SL_DATA_ENABLE								<=	'1';
				sig_int127t0_ff_detect_buffer_pointer	<=	sig_int127t0_ff_detect_buffer_pointer - 16;
			end if;
		--obt@[Kʈȏ@OFF	
		elsif(sig_int127t0_ff_detect_buffer_pointer < 111)then
			O_SL_DATA_ENABLE								<=	'1';
			sig_int127t0_ff_detect_buffer_pointer	<=	sig_int127t0_ff_detect_buffer_pointer + 16;	
		--t[I[f̏ꍇ͋ro
		elsif(sig_sl_1st_buffer_output_end_01c_dff='1' and sig_int127t0_ff_detect_buffer_pointer < 127)then
			O_SL_DATA_ENABLE								<=	'1';
			sig_int127t0_ff_detect_buffer_pointer	<=	127;
			O_SL_FF_CHECK_BUFFER_END					<=	'1';
		else
			O_SL_DATA_ENABLE								<=	'0';
			sig_int127t0_ff_detect_buffer_pointer	<=	sig_int127t0_ff_detect_buffer_pointer;
		end if;
	end if;
end process;

--process(I_SL_CLK)
--begin
--	if(I_SL_CLK'event and I_SL_CLK='1')then
--		--obt@o͂邵A݂
--		if(sig_int127t0_ff_detect_buffer_pointer < 111 and sig_sl_data_enable_01c_dff='1')then
--			O_SLV15T0_DATA	<=	sig_slv127t0_ff_detect_buffer(127 downto 112);
--			if(sig_slv1t0_ff_detector(1)='0')then
--				sig_slv127t0_ff_detect_buffer(127 downto 96 -(111 - sig_int127t0_ff_detect_buffer_pointer))	<=	sig_slv127t0_ff_detect_buffer(111 downto sig_int127t0_ff_detect_buffer_pointer + 1) & sig_slv15t0_data_01c_dff & "0000000000000000";
--			else
--				sig_slv127t0_ff_detect_buffer(127 downto 96 -(111 - sig_int127t0_ff_detect_buffer_pointer))	<=	sig_slv127t0_ff_detect_buffer(111 downto sig_int127t0_ff_detect_buffer_pointer + 1) & sig_slv15t0_data_01c_dff(15 downto 8) & "00000000" & sig_slv15t0_data_01c_dff(7 downto 0) & "00000000";
--			end if;
--		--obt@o͂邪A݂͂Ȃ
--		elsif(sig_int127t0_ff_detect_buffer_pointer < 111)then
--				O_SLV15T0_DATA	<=	sig_slv127t0_ff_detect_buffer(127 downto 112);
--				sig_slv127t0_ff_detect_buffer(127 downto 16)	<=	sig_slv127t0_ff_detect_buffer(111 downto 0);
--		--obt@o͂ȂA݂͂
--		elsif(sig_sl_data_enable_01c_dff='1')then
--			if(sig_slv1t0_ff_detector(1)='0')then
--				sig_slv127t0_ff_detect_buffer(sig_int127t0_ff_detect_buffer_pointer downto sig_int127t0_ff_detect_buffer_pointer - 31)	<= sig_slv15t0_data_01c_dff & "0000000000000000";
--			else
--				sig_slv127t0_ff_detect_buffer(sig_int127t0_ff_detect_buffer_pointer downto sig_int127t0_ff_detect_buffer_pointer - 31)	<=	sig_slv15t0_data_01c_dff(15 downto 8) & "00000000" & sig_slv15t0_data_01c_dff(7 downto 0) & "00000000";
--			end if;
--		--t[I[f̏ꍇ͋ro
--		elsif(sig_sl_1st_buffer_output_end_01c_dff='1' and sig_int127t0_ff_detect_buffer_pointer < 127)then
--			O_SLV15T0_DATA	<=	sig_slv127t0_ff_detect_buffer(127 downto 112);
--		end if;
--	end if;
--end process;

process(I_SL_CLK)
begin
	if(I_SL_CLK'event and I_SL_CLK='1')then
		--obt@o͂邵A݂
		if(sig_int127t0_ff_detect_buffer_pointer < 111 and sig_sl_data_enable_01c_dff='1')then
			O_SLV15T0_DATA	<=	sig_slv127t0_ff_detect_buffer(127 downto 112);
			if(sig_slv1t0_ff_detector(1)='0')then
				if(sig_int127t0_ff_detect_buffer_pointer=103)then
					sig_slv127t0_ff_detect_buffer(127 downto 88)	<=	sig_slv127t0_ff_detect_buffer(111 downto 104)	&	sig_slv15t0_data_01c_dff & "0000000000000000";
				elsif(sig_int127t0_ff_detect_buffer_pointer=95)then
					sig_slv127t0_ff_detect_buffer(127 downto 80)	<=	sig_slv127t0_ff_detect_buffer(111 downto 96)		&	sig_slv15t0_data_01c_dff & "0000000000000000";
				elsif(sig_int127t0_ff_detect_buffer_pointer=87)then
					sig_slv127t0_ff_detect_buffer(127 downto 72)	<=	sig_slv127t0_ff_detect_buffer(111 downto 88)		&	sig_slv15t0_data_01c_dff & "0000000000000000";
				elsif(sig_int127t0_ff_detect_buffer_pointer=79)then
					sig_slv127t0_ff_detect_buffer(127 downto 64)	<=	sig_slv127t0_ff_detect_buffer(111 downto 80) 	&	sig_slv15t0_data_01c_dff & "0000000000000000";
				elsif(sig_int127t0_ff_detect_buffer_pointer=71)then
					sig_slv127t0_ff_detect_buffer(127 downto 56)	<=	sig_slv127t0_ff_detect_buffer(111 downto 72) 	&	sig_slv15t0_data_01c_dff & "0000000000000000";
				elsif(sig_int127t0_ff_detect_buffer_pointer=63)then
					sig_slv127t0_ff_detect_buffer(127 downto 48)	<=	sig_slv127t0_ff_detect_buffer(111 downto 64)		&	sig_slv15t0_data_01c_dff & "0000000000000000";
				elsif(sig_int127t0_ff_detect_buffer_pointer=55)then
					sig_slv127t0_ff_detect_buffer(127 downto 40)	<=	sig_slv127t0_ff_detect_buffer(111 downto 56)		&	sig_slv15t0_data_01c_dff & "0000000000000000";
				elsif(sig_int127t0_ff_detect_buffer_pointer=47)then
					sig_slv127t0_ff_detect_buffer(127 downto 32)	<=	sig_slv127t0_ff_detect_buffer(111 downto 48)		&	sig_slv15t0_data_01c_dff & "0000000000000000";
				elsif(sig_int127t0_ff_detect_buffer_pointer=39)then
					sig_slv127t0_ff_detect_buffer(127 downto 24)	<=	sig_slv127t0_ff_detect_buffer(111 downto 40)		&	sig_slv15t0_data_01c_dff & "0000000000000000";
				elsif(sig_int127t0_ff_detect_buffer_pointer=31)then
					sig_slv127t0_ff_detect_buffer(127 downto 16)	<=	sig_slv127t0_ff_detect_buffer(111 downto 32)		&	sig_slv15t0_data_01c_dff & "0000000000000000";
				else
					sig_slv127t0_ff_detect_buffer						<=	sig_slv127t0_ff_detect_buffer;
				end if;
			else
				if(sig_int127t0_ff_detect_buffer_pointer=103)then
					sig_slv127t0_ff_detect_buffer(127 downto 88)	<=	sig_slv127t0_ff_detect_buffer(111 downto 104)	&	sig_slv15t0_data_01c_dff(15 downto 8) & "00000000" & sig_slv15t0_data_01c_dff(7 downto 0) & "00000000";
				elsif(sig_int127t0_ff_detect_buffer_pointer=95)then
					sig_slv127t0_ff_detect_buffer(127 downto 80)	<=	sig_slv127t0_ff_detect_buffer(111 downto 96)		&	sig_slv15t0_data_01c_dff(15 downto 8) & "00000000" & sig_slv15t0_data_01c_dff(7 downto 0) & "00000000";
				elsif(sig_int127t0_ff_detect_buffer_pointer=87)then
					sig_slv127t0_ff_detect_buffer(127 downto 72)	<=	sig_slv127t0_ff_detect_buffer(111 downto 88)		&	sig_slv15t0_data_01c_dff(15 downto 8) & "00000000" & sig_slv15t0_data_01c_dff(7 downto 0) & "00000000";
				elsif(sig_int127t0_ff_detect_buffer_pointer=79)then
					sig_slv127t0_ff_detect_buffer(127 downto 64)	<=	sig_slv127t0_ff_detect_buffer(111 downto 80) 	&	sig_slv15t0_data_01c_dff(15 downto 8) & "00000000" & sig_slv15t0_data_01c_dff(7 downto 0) & "00000000";
				elsif(sig_int127t0_ff_detect_buffer_pointer=71)then
					sig_slv127t0_ff_detect_buffer(127 downto 56)	<=	sig_slv127t0_ff_detect_buffer(111 downto 72) 	&	sig_slv15t0_data_01c_dff(15 downto 8) & "00000000" & sig_slv15t0_data_01c_dff(7 downto 0) & "00000000";
				elsif(sig_int127t0_ff_detect_buffer_pointer=63)then
					sig_slv127t0_ff_detect_buffer(127 downto 48)	<=	sig_slv127t0_ff_detect_buffer(111 downto 64)		&	sig_slv15t0_data_01c_dff(15 downto 8) & "00000000" & sig_slv15t0_data_01c_dff(7 downto 0) & "00000000";
				elsif(sig_int127t0_ff_detect_buffer_pointer=55)then
					sig_slv127t0_ff_detect_buffer(127 downto 40)	<=	sig_slv127t0_ff_detect_buffer(111 downto 56)		&	sig_slv15t0_data_01c_dff(15 downto 8) & "00000000" & sig_slv15t0_data_01c_dff(7 downto 0) & "00000000";
				elsif(sig_int127t0_ff_detect_buffer_pointer=47)then
					sig_slv127t0_ff_detect_buffer(127 downto 32)	<=	sig_slv127t0_ff_detect_buffer(111 downto 48)		&	sig_slv15t0_data_01c_dff(15 downto 8) & "00000000" & sig_slv15t0_data_01c_dff(7 downto 0) & "00000000";
				elsif(sig_int127t0_ff_detect_buffer_pointer=39)then
					sig_slv127t0_ff_detect_buffer(127 downto 24)	<=	sig_slv127t0_ff_detect_buffer(111 downto 40)		&	sig_slv15t0_data_01c_dff(15 downto 8) & "00000000" & sig_slv15t0_data_01c_dff(7 downto 0) & "00000000";
				elsif(sig_int127t0_ff_detect_buffer_pointer=31)then
					sig_slv127t0_ff_detect_buffer(127 downto 16)	<=	sig_slv127t0_ff_detect_buffer(111 downto 32)		&	sig_slv15t0_data_01c_dff(15 downto 8) & "00000000" & sig_slv15t0_data_01c_dff(7 downto 0) & "00000000";
				else
					sig_slv127t0_ff_detect_buffer						<=	sig_slv127t0_ff_detect_buffer;
				end if;
			end if;
		--obt@o͂邪A݂͂Ȃ
		elsif(sig_int127t0_ff_detect_buffer_pointer < 111)then
				O_SLV15T0_DATA	<=	sig_slv127t0_ff_detect_buffer(127 downto 112);
				sig_slv127t0_ff_detect_buffer(127 downto 16)	<=	sig_slv127t0_ff_detect_buffer(111 downto 0);
		--obt@o͂ȂA݂͂
		elsif(sig_sl_data_enable_01c_dff='1')then
			if(sig_slv1t0_ff_detector(1)='0')then
				sig_slv127t0_ff_detect_buffer(sig_int127t0_ff_detect_buffer_pointer downto sig_int127t0_ff_detect_buffer_pointer - 31)	<= sig_slv15t0_data_01c_dff & "0000000000000000";
			else
				sig_slv127t0_ff_detect_buffer(sig_int127t0_ff_detect_buffer_pointer downto sig_int127t0_ff_detect_buffer_pointer - 31)	<=	sig_slv15t0_data_01c_dff(15 downto 8) & "00000000" & sig_slv15t0_data_01c_dff(7 downto 0) & "00000000";
			end if;
		--t[I[f̏ꍇ͋ro
		elsif(sig_sl_1st_buffer_output_end_01c_dff='1' and sig_int127t0_ff_detect_buffer_pointer < 127)then
			O_SLV15T0_DATA	<=	sig_slv127t0_ff_detect_buffer(127 downto 112);
		end if;
	end if;
end process;


--fifo test
--ȉAfobNp
process(I_SL_CLK)
begin
	if(I_SL_CLK'event and I_SL_CLK='1')then
		if(sig_int127t0_ff_detect_buffer_pointer < 32)then
			O_SLV7T0_LED_DATA(3)	<=	'1';
		elsif(sig_int127t0_ff_detect_buffer_pointer < 36)then
			O_SLV7T0_LED_DATA(2)	<=	'1';
		elsif(sig_int127t0_ff_detect_buffer_pointer < 40)then
			O_SLV7T0_LED_DATA(1)	<=	'1';
		elsif(sig_int127t0_ff_detect_buffer_pointer < 44)then
			O_SLV7T0_LED_DATA(0)	<=	'1';
		else
			O_SLV7T0_LED_DATA(3 downto 0)	<=	"0000";
		end if;
	end if;
end process;

end Behavioral;