----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date:    19:19:21 11/03/2010 
-- Design Name: 
-- Module Name:    LUMINANCE_AC_ROM - Behavioral 
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

---- Uncomment the following library declaration if instantiating
---- any Xilinx primitives in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity LUMINANCE_AC_ROM is
	port(
	--=======
	--==INPUT
	--=======
	--==system
	I_SL_RST					:	IN		std_logic;
	I_SL_CLK					:	IN		std_logic;
	--==
	I_SLV3T0_LENGTH_SIZE	:	IN		std_logic_vector(3 downto 0);
	I_INT0T10_DATA_WIDTH	:	IN		integer range 0 to 10;
	--========
	--==OUTPUT
	--========
	--==
	O_INT0T15_DATA_WIDTH	:	OUT	integer range 0 to 15;
	O_SLV15T0_AC_HUFFMAN	:	OUT	std_logic_vector(15 downto 0)
	);
end LUMINANCE_AC_ROM;

architecture Behavioral of LUMINANCE_AC_ROM is

begin

	--===================================
	--AC_HUFFMAN_LUT
	--y\̒lz
	--JPEG TOC++ł̎܂ pp260~pp264
	--===================================
	process(I_SL_RST,I_SL_CLK)
	begin
		if(I_SL_RST='0')then
			O_INT0T15_DATA_WIDTH	<=	0;
			O_SLV15T0_AC_HUFFMAN	<=	(others=>'0');
		elsif(I_SL_CLK'event and I_SL_CLK='1')then
			--==I_SLV3T0_LENGTH_SIZE = "0000"
			if(I_SLV3T0_LENGTH_SIZE = "0000" and I_INT0T10_DATA_WIDTH = 0)then
				O_INT0T15_DATA_WIDTH	<=	3;
				O_SLV15T0_AC_HUFFMAN	<=	X"000A";
			elsif(I_SLV3T0_LENGTH_SIZE = "0000" and I_INT0T10_DATA_WIDTH = 1)then
				O_INT0T15_DATA_WIDTH	<=	1;
				O_SLV15T0_AC_HUFFMAN	<=	X"0000";
			elsif(I_SLV3T0_LENGTH_SIZE = "0000" and I_INT0T10_DATA_WIDTH = 2)then
				O_INT0T15_DATA_WIDTH	<=	1;
				O_SLV15T0_AC_HUFFMAN	<=	X"0001";
			elsif(I_SLV3T0_LENGTH_SIZE = "0000" and I_INT0T10_DATA_WIDTH = 3)then
				O_INT0T15_DATA_WIDTH	<=	2;
				O_SLV15T0_AC_HUFFMAN	<=	X"0004";
			elsif(I_SLV3T0_LENGTH_SIZE = "0000" and I_INT0T10_DATA_WIDTH = 4)then
				O_INT0T15_DATA_WIDTH	<=	3;
				O_SLV15T0_AC_HUFFMAN	<=	X"000B";
			elsif(I_SLV3T0_LENGTH_SIZE = "0000" and I_INT0T10_DATA_WIDTH = 5)then
				O_INT0T15_DATA_WIDTH	<=	4;
				O_SLV15T0_AC_HUFFMAN	<=	X"001A";
			elsif(I_SLV3T0_LENGTH_SIZE = "0000" and I_INT0T10_DATA_WIDTH = 6)then
				O_INT0T15_DATA_WIDTH	<=	6;
				O_SLV15T0_AC_HUFFMAN	<=	X"0078";
			elsif(I_SLV3T0_LENGTH_SIZE = "0000" and I_INT0T10_DATA_WIDTH = 7)then
				O_INT0T15_DATA_WIDTH	<=	7;
				O_SLV15T0_AC_HUFFMAN	<=	X"00F8";
			elsif(I_SLV3T0_LENGTH_SIZE = "0000" and I_INT0T10_DATA_WIDTH = 8)then
				O_INT0T15_DATA_WIDTH	<=	9;
				O_SLV15T0_AC_HUFFMAN	<=	X"03F6";
			elsif(I_SLV3T0_LENGTH_SIZE = "0000" and I_INT0T10_DATA_WIDTH = 9)then
				O_INT0T15_DATA_WIDTH	<=	15;
				O_SLV15T0_AC_HUFFMAN	<=	X"FF82";
			elsif(I_SLV3T0_LENGTH_SIZE = "0000" and I_INT0T10_DATA_WIDTH = 10)then
				O_INT0T15_DATA_WIDTH	<=	15;
				O_SLV15T0_AC_HUFFMAN	<=	X"FF83";
			--==I_SLV3T0_LENGTH_SIZE = "0001"
			elsif(I_SLV3T0_LENGTH_SIZE = "0001" and I_INT0T10_DATA_WIDTH = 1)then
				O_INT0T15_DATA_WIDTH	<=	3;
				O_SLV15T0_AC_HUFFMAN	<=	X"000C";
			elsif(I_SLV3T0_LENGTH_SIZE = "0001" and I_INT0T10_DATA_WIDTH = 2)then
				O_INT0T15_DATA_WIDTH	<=	4;
				O_SLV15T0_AC_HUFFMAN	<=	X"001B";
			elsif(I_SLV3T0_LENGTH_SIZE = "0001" and I_INT0T10_DATA_WIDTH = 3)then
				O_INT0T15_DATA_WIDTH	<=	6;
				O_SLV15T0_AC_HUFFMAN	<=	X"0079";
			elsif(I_SLV3T0_LENGTH_SIZE = "0001" and I_INT0T10_DATA_WIDTH = 4)then
				O_INT0T15_DATA_WIDTH	<=	8;
				O_SLV15T0_AC_HUFFMAN	<=	X"01F6";
			elsif(I_SLV3T0_LENGTH_SIZE = "0001" and I_INT0T10_DATA_WIDTH = 5)then
				O_INT0T15_DATA_WIDTH	<=	10;
				O_SLV15T0_AC_HUFFMAN	<=	X"07F6";
			elsif(I_SLV3T0_LENGTH_SIZE = "0001" and I_INT0T10_DATA_WIDTH = 6)then
				O_INT0T15_DATA_WIDTH	<=	15;
				O_SLV15T0_AC_HUFFMAN	<=	X"FF84";
			elsif(I_SLV3T0_LENGTH_SIZE = "0001" and I_INT0T10_DATA_WIDTH = 7)then
				O_INT0T15_DATA_WIDTH	<=	15;
				O_SLV15T0_AC_HUFFMAN	<=	X"FF85";
			elsif(I_SLV3T0_LENGTH_SIZE = "0001" and I_INT0T10_DATA_WIDTH = 8)then
				O_INT0T15_DATA_WIDTH	<=	15;
				O_SLV15T0_AC_HUFFMAN	<=	X"FF86";
			elsif(I_SLV3T0_LENGTH_SIZE = "0001" and I_INT0T10_DATA_WIDTH = 9)then
				O_INT0T15_DATA_WIDTH	<=	15;
				O_SLV15T0_AC_HUFFMAN	<=	X"FF87";
			elsif(I_SLV3T0_LENGTH_SIZE = "0001" and I_INT0T10_DATA_WIDTH = 10)then
				O_INT0T15_DATA_WIDTH	<=	15;
				O_SLV15T0_AC_HUFFMAN	<=	X"FF88";
			--==I_SLV3T0_LENGTH_SIZE = "0010"
			elsif(I_SLV3T0_LENGTH_SIZE = "0010" and I_INT0T10_DATA_WIDTH = 1)then
				O_INT0T15_DATA_WIDTH	<=	4;
				O_SLV15T0_AC_HUFFMAN	<=	X"001C";
			elsif(I_SLV3T0_LENGTH_SIZE = "0010" and I_INT0T10_DATA_WIDTH = 2)then
				O_INT0T15_DATA_WIDTH	<=	7;
				O_SLV15T0_AC_HUFFMAN	<=	X"00F9";
			elsif(I_SLV3T0_LENGTH_SIZE = "0010" and I_INT0T10_DATA_WIDTH = 3)then
				O_INT0T15_DATA_WIDTH	<=	9;
				O_SLV15T0_AC_HUFFMAN	<=	X"03F7";
			elsif(I_SLV3T0_LENGTH_SIZE = "0010" and I_INT0T10_DATA_WIDTH = 4)then
				O_INT0T15_DATA_WIDTH	<=	11;
				O_SLV15T0_AC_HUFFMAN	<=	X"0FF4";
			elsif(I_SLV3T0_LENGTH_SIZE = "0010" and I_INT0T10_DATA_WIDTH = 5)then
				O_INT0T15_DATA_WIDTH	<=	15;
				O_SLV15T0_AC_HUFFMAN	<=	X"FF89";
			elsif(I_SLV3T0_LENGTH_SIZE = "0010" and I_INT0T10_DATA_WIDTH = 6)then
				O_INT0T15_DATA_WIDTH	<=	15;
				O_SLV15T0_AC_HUFFMAN	<=	X"FF8A";
			elsif(I_SLV3T0_LENGTH_SIZE = "0010" and I_INT0T10_DATA_WIDTH = 7)then
				O_INT0T15_DATA_WIDTH	<=	15;
				O_SLV15T0_AC_HUFFMAN	<=	X"FF8B";
			elsif(I_SLV3T0_LENGTH_SIZE = "0010" and I_INT0T10_DATA_WIDTH = 8)then
				O_INT0T15_DATA_WIDTH	<=	15;
				O_SLV15T0_AC_HUFFMAN	<=	X"FF8C";
			elsif(I_SLV3T0_LENGTH_SIZE = "0010" and I_INT0T10_DATA_WIDTH = 9)then
				O_INT0T15_DATA_WIDTH	<=	15;
				O_SLV15T0_AC_HUFFMAN	<=	X"FF8D";
			elsif(I_SLV3T0_LENGTH_SIZE = "0010" and I_INT0T10_DATA_WIDTH = 10)then
				O_INT0T15_DATA_WIDTH	<=	15;
				O_SLV15T0_AC_HUFFMAN	<=	X"FF8E";
			--==I_SLV3T0_LENGTH_SIZE = "0011"
			elsif(I_SLV3T0_LENGTH_SIZE = "0011" and I_INT0T10_DATA_WIDTH = 1)then
				O_INT0T15_DATA_WIDTH	<=	5;
				O_SLV15T0_AC_HUFFMAN	<=	X"003A";
			elsif(I_SLV3T0_LENGTH_SIZE = "0011" and I_INT0T10_DATA_WIDTH = 2)then
				O_INT0T15_DATA_WIDTH	<=	8;
				O_SLV15T0_AC_HUFFMAN	<=	X"01F7";
			elsif(I_SLV3T0_LENGTH_SIZE = "0011" and I_INT0T10_DATA_WIDTH = 3)then
				O_INT0T15_DATA_WIDTH	<=	11;
				O_SLV15T0_AC_HUFFMAN	<=	X"0FF5";
			elsif(I_SLV3T0_LENGTH_SIZE = "0011" and I_INT0T10_DATA_WIDTH = 4)then
				O_INT0T15_DATA_WIDTH	<=	15;
				O_SLV15T0_AC_HUFFMAN	<=	X"FF8F";
			elsif(I_SLV3T0_LENGTH_SIZE = "0011" and I_INT0T10_DATA_WIDTH = 5)then
				O_INT0T15_DATA_WIDTH	<=	15;
				O_SLV15T0_AC_HUFFMAN	<=	X"FF90";
			elsif(I_SLV3T0_LENGTH_SIZE = "0011" and I_INT0T10_DATA_WIDTH = 6)then
				O_INT0T15_DATA_WIDTH	<=	15;
				O_SLV15T0_AC_HUFFMAN	<=	X"FF91";
			elsif(I_SLV3T0_LENGTH_SIZE = "0011" and I_INT0T10_DATA_WIDTH = 7)then
				O_INT0T15_DATA_WIDTH	<=	15;
				O_SLV15T0_AC_HUFFMAN	<=	X"FF92";
			elsif(I_SLV3T0_LENGTH_SIZE = "0011" and I_INT0T10_DATA_WIDTH = 8)then
				O_INT0T15_DATA_WIDTH	<=	15;
				O_SLV15T0_AC_HUFFMAN	<=	X"FF93";
			elsif(I_SLV3T0_LENGTH_SIZE = "0011" and I_INT0T10_DATA_WIDTH = 9)then
				O_INT0T15_DATA_WIDTH	<=	15;
				O_SLV15T0_AC_HUFFMAN	<=	X"FF94";
			elsif(I_SLV3T0_LENGTH_SIZE = "0011" and I_INT0T10_DATA_WIDTH = 10)then
				O_INT0T15_DATA_WIDTH	<=	15;
				O_SLV15T0_AC_HUFFMAN	<=	X"FF95";
			--==I_SLV3T0_LENGTH_SIZE = "0100"
			elsif(I_SLV3T0_LENGTH_SIZE = "0100" and I_INT0T10_DATA_WIDTH = 1)then
				O_INT0T15_DATA_WIDTH	<=	5;
				O_SLV15T0_AC_HUFFMAN	<=	X"003B";
			elsif(I_SLV3T0_LENGTH_SIZE = "0100" and I_INT0T10_DATA_WIDTH = 2)then
				O_INT0T15_DATA_WIDTH	<=	9;
				O_SLV15T0_AC_HUFFMAN	<=	X"03F8";
			elsif(I_SLV3T0_LENGTH_SIZE = "0100" and I_INT0T10_DATA_WIDTH = 3)then
				O_INT0T15_DATA_WIDTH	<=	15;
				O_SLV15T0_AC_HUFFMAN	<=	X"FF96";
			elsif(I_SLV3T0_LENGTH_SIZE = "0100" and I_INT0T10_DATA_WIDTH = 4)then
				O_INT0T15_DATA_WIDTH	<=	15;
				O_SLV15T0_AC_HUFFMAN	<=	X"FF97";
			elsif(I_SLV3T0_LENGTH_SIZE = "0100" and I_INT0T10_DATA_WIDTH = 5)then
				O_INT0T15_DATA_WIDTH	<=	15;
				O_SLV15T0_AC_HUFFMAN	<=	X"FF98";
			elsif(I_SLV3T0_LENGTH_SIZE = "0100" and I_INT0T10_DATA_WIDTH = 6)then
				O_INT0T15_DATA_WIDTH	<=	15;
				O_SLV15T0_AC_HUFFMAN	<=	X"FF99";
			elsif(I_SLV3T0_LENGTH_SIZE = "0100" and I_INT0T10_DATA_WIDTH = 7)then
				O_INT0T15_DATA_WIDTH	<=	15;
				O_SLV15T0_AC_HUFFMAN	<=	X"FF9A";
			elsif(I_SLV3T0_LENGTH_SIZE = "0100" and I_INT0T10_DATA_WIDTH = 8)then
				O_INT0T15_DATA_WIDTH	<=	15;
				O_SLV15T0_AC_HUFFMAN	<=	X"FF9B";
			elsif(I_SLV3T0_LENGTH_SIZE = "0100" and I_INT0T10_DATA_WIDTH = 9)then
				O_INT0T15_DATA_WIDTH	<=	15;
				O_SLV15T0_AC_HUFFMAN	<=	X"FF9C";
			elsif(I_SLV3T0_LENGTH_SIZE = "0100" and I_INT0T10_DATA_WIDTH = 10)then
				O_INT0T15_DATA_WIDTH	<=	15;
				O_SLV15T0_AC_HUFFMAN	<=	X"FF9D";
			--==I_SLV3T0_LENGTH_SIZE = "0101"
			elsif(I_SLV3T0_LENGTH_SIZE = "0101" and I_INT0T10_DATA_WIDTH = 1)then
				O_INT0T15_DATA_WIDTH	<=	6;
				O_SLV15T0_AC_HUFFMAN	<=	X"007A";
			elsif(I_SLV3T0_LENGTH_SIZE = "0101" and I_INT0T10_DATA_WIDTH = 2)then
				O_INT0T15_DATA_WIDTH	<=	10;
				O_SLV15T0_AC_HUFFMAN	<=	X"07F7";
			elsif(I_SLV3T0_LENGTH_SIZE = "0101" and I_INT0T10_DATA_WIDTH = 3)then
				O_INT0T15_DATA_WIDTH	<=	15;
				O_SLV15T0_AC_HUFFMAN	<=	X"FF9E";
			elsif(I_SLV3T0_LENGTH_SIZE = "0101" and I_INT0T10_DATA_WIDTH = 4)then
				O_INT0T15_DATA_WIDTH	<=	15;
				O_SLV15T0_AC_HUFFMAN	<=	X"FF9F";
			elsif(I_SLV3T0_LENGTH_SIZE = "0101" and I_INT0T10_DATA_WIDTH = 5)then
				O_INT0T15_DATA_WIDTH	<=	15;
				O_SLV15T0_AC_HUFFMAN	<=	X"FFA0";
			elsif(I_SLV3T0_LENGTH_SIZE = "0101" and I_INT0T10_DATA_WIDTH = 6)then
				O_INT0T15_DATA_WIDTH	<=	15;
				O_SLV15T0_AC_HUFFMAN	<=	X"FFA1";
			elsif(I_SLV3T0_LENGTH_SIZE = "0101" and I_INT0T10_DATA_WIDTH = 7)then
				O_INT0T15_DATA_WIDTH	<=	15;
				O_SLV15T0_AC_HUFFMAN	<=	X"FFA2";
			elsif(I_SLV3T0_LENGTH_SIZE = "0101" and I_INT0T10_DATA_WIDTH = 8)then
				O_INT0T15_DATA_WIDTH	<=	15;
				O_SLV15T0_AC_HUFFMAN	<=	X"FFA3";
			elsif(I_SLV3T0_LENGTH_SIZE = "0101" and I_INT0T10_DATA_WIDTH = 9)then
				O_INT0T15_DATA_WIDTH	<=	15;
				O_SLV15T0_AC_HUFFMAN	<=	X"FFA4";
			elsif(I_SLV3T0_LENGTH_SIZE = "0101" and I_INT0T10_DATA_WIDTH = 10)then
				O_INT0T15_DATA_WIDTH	<=	15;
				O_SLV15T0_AC_HUFFMAN	<=	X"FFA5";
			--==I_SLV3T0_LENGTH_SIZE = "0110"
			elsif(I_SLV3T0_LENGTH_SIZE = "0110" and I_INT0T10_DATA_WIDTH = 1)then
				O_INT0T15_DATA_WIDTH	<=	6;
				O_SLV15T0_AC_HUFFMAN	<=	X"007B";
			elsif(I_SLV3T0_LENGTH_SIZE = "0110" and I_INT0T10_DATA_WIDTH = 2)then
				O_INT0T15_DATA_WIDTH	<=	11;
				O_SLV15T0_AC_HUFFMAN	<=	X"0FF6";
			elsif(I_SLV3T0_LENGTH_SIZE = "0110" and I_INT0T10_DATA_WIDTH = 3)then
				O_INT0T15_DATA_WIDTH	<=	15;
				O_SLV15T0_AC_HUFFMAN	<=	X"FFA6";
			elsif(I_SLV3T0_LENGTH_SIZE = "0110" and I_INT0T10_DATA_WIDTH = 4)then
				O_INT0T15_DATA_WIDTH	<=	15;
				O_SLV15T0_AC_HUFFMAN	<=	X"FFA7";
			elsif(I_SLV3T0_LENGTH_SIZE = "0110" and I_INT0T10_DATA_WIDTH = 5)then
				O_INT0T15_DATA_WIDTH	<=	15;
				O_SLV15T0_AC_HUFFMAN	<=	X"FFA8";
			elsif(I_SLV3T0_LENGTH_SIZE = "0110" and I_INT0T10_DATA_WIDTH = 6)then
				O_INT0T15_DATA_WIDTH	<=	15;
				O_SLV15T0_AC_HUFFMAN	<=	X"FFA9";
			elsif(I_SLV3T0_LENGTH_SIZE = "0110" and I_INT0T10_DATA_WIDTH = 7)then
				O_INT0T15_DATA_WIDTH	<=	15;
				O_SLV15T0_AC_HUFFMAN	<=	X"FFAA";
			elsif(I_SLV3T0_LENGTH_SIZE = "0110" and I_INT0T10_DATA_WIDTH = 8)then
				O_INT0T15_DATA_WIDTH	<=	15;
				O_SLV15T0_AC_HUFFMAN	<=	X"FFAB";
			elsif(I_SLV3T0_LENGTH_SIZE = "0110" and I_INT0T10_DATA_WIDTH = 9)then
				O_INT0T15_DATA_WIDTH	<=	15;
				O_SLV15T0_AC_HUFFMAN	<=	X"FFAC";
			elsif(I_SLV3T0_LENGTH_SIZE = "0110" and I_INT0T10_DATA_WIDTH = 10)then
				O_INT0T15_DATA_WIDTH	<=	15;
				O_SLV15T0_AC_HUFFMAN	<=	X"FFAD";
			--==I_SLV3T0_LENGTH_SIZE = "0111"
			elsif(I_SLV3T0_LENGTH_SIZE = "0111" and I_INT0T10_DATA_WIDTH = 1)then
				O_INT0T15_DATA_WIDTH	<=	7;
				O_SLV15T0_AC_HUFFMAN	<=	X"00FA";
			elsif(I_SLV3T0_LENGTH_SIZE = "0111" and I_INT0T10_DATA_WIDTH = 2)then
				O_INT0T15_DATA_WIDTH	<=	11;
				O_SLV15T0_AC_HUFFMAN	<=	X"0FF7";
			elsif(I_SLV3T0_LENGTH_SIZE = "0111" and I_INT0T10_DATA_WIDTH = 3)then
				O_INT0T15_DATA_WIDTH	<=	15;
				O_SLV15T0_AC_HUFFMAN	<=	X"FFAE";
			elsif(I_SLV3T0_LENGTH_SIZE = "0111" and I_INT0T10_DATA_WIDTH = 4)then
				O_INT0T15_DATA_WIDTH	<=	15;
				O_SLV15T0_AC_HUFFMAN	<=	X"FFAF";
			elsif(I_SLV3T0_LENGTH_SIZE = "0111" and I_INT0T10_DATA_WIDTH = 5)then
				O_INT0T15_DATA_WIDTH	<=	15;
				O_SLV15T0_AC_HUFFMAN	<=	X"FFB0";
			elsif(I_SLV3T0_LENGTH_SIZE = "0111" and I_INT0T10_DATA_WIDTH = 6)then
				O_INT0T15_DATA_WIDTH	<=	15;
				O_SLV15T0_AC_HUFFMAN	<=	X"FFB1";
			elsif(I_SLV3T0_LENGTH_SIZE = "0111" and I_INT0T10_DATA_WIDTH = 7)then
				O_INT0T15_DATA_WIDTH	<=	15;
				O_SLV15T0_AC_HUFFMAN	<=	X"FFB2";
			elsif(I_SLV3T0_LENGTH_SIZE = "0111" and I_INT0T10_DATA_WIDTH = 8)then
				O_INT0T15_DATA_WIDTH	<=	15;
				O_SLV15T0_AC_HUFFMAN	<=	X"FFB3";
			elsif(I_SLV3T0_LENGTH_SIZE = "0111" and I_INT0T10_DATA_WIDTH = 9)then
				O_INT0T15_DATA_WIDTH	<=	15;
				O_SLV15T0_AC_HUFFMAN	<=	X"FFB4";
			elsif(I_SLV3T0_LENGTH_SIZE = "0111" and I_INT0T10_DATA_WIDTH = 10)then
				O_INT0T15_DATA_WIDTH	<=	15;
				O_SLV15T0_AC_HUFFMAN	<=	X"FFB5";
			--==I_SLV3T0_LENGTH_SIZE = "1000"
			elsif(I_SLV3T0_LENGTH_SIZE = "1000" and I_INT0T10_DATA_WIDTH = 1)then
				O_INT0T15_DATA_WIDTH	<=	8;
				O_SLV15T0_AC_HUFFMAN	<=	X"01F8";
			elsif(I_SLV3T0_LENGTH_SIZE = "1000" and I_INT0T10_DATA_WIDTH = 2)then
				O_INT0T15_DATA_WIDTH	<=	14;
				O_SLV15T0_AC_HUFFMAN	<=	X"7FC0";
			elsif(I_SLV3T0_LENGTH_SIZE = "1000" and I_INT0T10_DATA_WIDTH = 3)then
				O_INT0T15_DATA_WIDTH	<=	15;
				O_SLV15T0_AC_HUFFMAN	<=	X"FFB6";
			elsif(I_SLV3T0_LENGTH_SIZE = "1000" and I_INT0T10_DATA_WIDTH = 4)then
				O_INT0T15_DATA_WIDTH	<=	15;
				O_SLV15T0_AC_HUFFMAN	<=	X"FFB7";
			elsif(I_SLV3T0_LENGTH_SIZE = "1000" and I_INT0T10_DATA_WIDTH = 5)then
				O_INT0T15_DATA_WIDTH	<=	15;
				O_SLV15T0_AC_HUFFMAN	<=	X"FFB8";
			elsif(I_SLV3T0_LENGTH_SIZE = "1000" and I_INT0T10_DATA_WIDTH = 6)then
				O_INT0T15_DATA_WIDTH	<=	15;
				O_SLV15T0_AC_HUFFMAN	<=	X"FFB9";
			elsif(I_SLV3T0_LENGTH_SIZE = "1000" and I_INT0T10_DATA_WIDTH = 7)then
				O_INT0T15_DATA_WIDTH	<=	15;
				O_SLV15T0_AC_HUFFMAN	<=	X"FFBA";
			elsif(I_SLV3T0_LENGTH_SIZE = "1000" and I_INT0T10_DATA_WIDTH = 8)then
				O_INT0T15_DATA_WIDTH	<=	15;
				O_SLV15T0_AC_HUFFMAN	<=	X"FFBB";
			elsif(I_SLV3T0_LENGTH_SIZE = "1000" and I_INT0T10_DATA_WIDTH = 9)then
				O_INT0T15_DATA_WIDTH	<=	15;
				O_SLV15T0_AC_HUFFMAN	<=	X"FFBC";
			elsif(I_SLV3T0_LENGTH_SIZE = "1000" and I_INT0T10_DATA_WIDTH = 10)then
				O_INT0T15_DATA_WIDTH	<=	15;
				O_SLV15T0_AC_HUFFMAN	<=	X"FFBD";
			--==I_SLV3T0_LENGTH_SIZE = "1001"
			elsif(I_SLV3T0_LENGTH_SIZE = "1001" and I_INT0T10_DATA_WIDTH = 1)then
				O_INT0T15_DATA_WIDTH	<=	8;
				O_SLV15T0_AC_HUFFMAN	<=	X"01F9";
			elsif(I_SLV3T0_LENGTH_SIZE = "1001" and I_INT0T10_DATA_WIDTH = 2)then
				O_INT0T15_DATA_WIDTH	<=	15;
				O_SLV15T0_AC_HUFFMAN	<=	X"FFBE";
			elsif(I_SLV3T0_LENGTH_SIZE = "1001" and I_INT0T10_DATA_WIDTH = 3)then
				O_INT0T15_DATA_WIDTH	<=	15;
				O_SLV15T0_AC_HUFFMAN	<=	X"FFBF";
			elsif(I_SLV3T0_LENGTH_SIZE = "1001" and I_INT0T10_DATA_WIDTH = 4)then
				O_INT0T15_DATA_WIDTH	<=	15;
				O_SLV15T0_AC_HUFFMAN	<=	X"FFC0";
			elsif(I_SLV3T0_LENGTH_SIZE = "1001" and I_INT0T10_DATA_WIDTH = 5)then
				O_INT0T15_DATA_WIDTH	<=	15;
				O_SLV15T0_AC_HUFFMAN	<=	X"FFC1";
			elsif(I_SLV3T0_LENGTH_SIZE = "1001" and I_INT0T10_DATA_WIDTH = 6)then
				O_INT0T15_DATA_WIDTH	<=	15;
				O_SLV15T0_AC_HUFFMAN	<=	X"FFC2";
			elsif(I_SLV3T0_LENGTH_SIZE = "1001" and I_INT0T10_DATA_WIDTH = 7)then
				O_INT0T15_DATA_WIDTH	<=	15;
				O_SLV15T0_AC_HUFFMAN	<=	X"FFC3";
			elsif(I_SLV3T0_LENGTH_SIZE = "1001" and I_INT0T10_DATA_WIDTH = 8)then
				O_INT0T15_DATA_WIDTH	<=	15;
				O_SLV15T0_AC_HUFFMAN	<=	X"FFC4";
			elsif(I_SLV3T0_LENGTH_SIZE = "1001" and I_INT0T10_DATA_WIDTH = 9)then
				O_INT0T15_DATA_WIDTH	<=	15;
				O_SLV15T0_AC_HUFFMAN	<=	X"FFC5";
			elsif(I_SLV3T0_LENGTH_SIZE = "1001" and I_INT0T10_DATA_WIDTH = 10)then
				O_INT0T15_DATA_WIDTH	<=	15;
				O_SLV15T0_AC_HUFFMAN	<=	X"FFC6";
			--==I_SLV3T0_LENGTH_SIZE = "1010"
			elsif(I_SLV3T0_LENGTH_SIZE = "1010" and I_INT0T10_DATA_WIDTH = 1)then
				O_INT0T15_DATA_WIDTH	<=	8;
				O_SLV15T0_AC_HUFFMAN	<=	X"01FA";
			elsif(I_SLV3T0_LENGTH_SIZE = "1010" and I_INT0T10_DATA_WIDTH = 2)then
				O_INT0T15_DATA_WIDTH	<=	15;
				O_SLV15T0_AC_HUFFMAN	<=	X"FFC7";
			elsif(I_SLV3T0_LENGTH_SIZE = "1010" and I_INT0T10_DATA_WIDTH = 3)then
				O_INT0T15_DATA_WIDTH	<=	15;
				O_SLV15T0_AC_HUFFMAN	<=	X"FFC8";
			elsif(I_SLV3T0_LENGTH_SIZE = "1010" and I_INT0T10_DATA_WIDTH = 4)then
				O_INT0T15_DATA_WIDTH	<=	15;
				O_SLV15T0_AC_HUFFMAN	<=	X"FFC9";
			elsif(I_SLV3T0_LENGTH_SIZE = "1010" and I_INT0T10_DATA_WIDTH = 5)then
				O_INT0T15_DATA_WIDTH	<=	15;
				O_SLV15T0_AC_HUFFMAN	<=	X"FFCA";
			elsif(I_SLV3T0_LENGTH_SIZE = "1010" and I_INT0T10_DATA_WIDTH = 6)then
				O_INT0T15_DATA_WIDTH	<=	15;
				O_SLV15T0_AC_HUFFMAN	<=	X"FFCB";
			elsif(I_SLV3T0_LENGTH_SIZE = "1010" and I_INT0T10_DATA_WIDTH = 7)then
				O_INT0T15_DATA_WIDTH	<=	15;
				O_SLV15T0_AC_HUFFMAN	<=	X"FFCC";
			elsif(I_SLV3T0_LENGTH_SIZE = "1010" and I_INT0T10_DATA_WIDTH = 8)then
				O_INT0T15_DATA_WIDTH	<=	15;
				O_SLV15T0_AC_HUFFMAN	<=	X"FFCD";
			elsif(I_SLV3T0_LENGTH_SIZE = "1010" and I_INT0T10_DATA_WIDTH = 9)then
				O_INT0T15_DATA_WIDTH	<=	15;
				O_SLV15T0_AC_HUFFMAN	<=	X"FFCE";
			elsif(I_SLV3T0_LENGTH_SIZE = "1010" and I_INT0T10_DATA_WIDTH = 10)then
				O_INT0T15_DATA_WIDTH	<=	15;
				O_SLV15T0_AC_HUFFMAN	<=	X"FFCF";
			--==I_SLV3T0_LENGTH_SIZE = "1011"
			elsif(I_SLV3T0_LENGTH_SIZE = "1011" and I_INT0T10_DATA_WIDTH = 1)then
				O_INT0T15_DATA_WIDTH	<=	9;
				O_SLV15T0_AC_HUFFMAN	<=	X"03F9";
			elsif(I_SLV3T0_LENGTH_SIZE = "1011" and I_INT0T10_DATA_WIDTH = 2)then
				O_INT0T15_DATA_WIDTH	<=	15;
				O_SLV15T0_AC_HUFFMAN	<=	X"FFD0";
			elsif(I_SLV3T0_LENGTH_SIZE = "1011" and I_INT0T10_DATA_WIDTH = 3)then
				O_INT0T15_DATA_WIDTH	<=	15;
				O_SLV15T0_AC_HUFFMAN	<=	X"FFD1";
			elsif(I_SLV3T0_LENGTH_SIZE = "1011" and I_INT0T10_DATA_WIDTH = 4)then
				O_INT0T15_DATA_WIDTH	<=	15;
				O_SLV15T0_AC_HUFFMAN	<=	X"FFD2";
			elsif(I_SLV3T0_LENGTH_SIZE = "1011" and I_INT0T10_DATA_WIDTH = 5)then
				O_INT0T15_DATA_WIDTH	<=	15;
				O_SLV15T0_AC_HUFFMAN	<=	X"FFD3";
			elsif(I_SLV3T0_LENGTH_SIZE = "1011" and I_INT0T10_DATA_WIDTH = 6)then
				O_INT0T15_DATA_WIDTH	<=	15;
				O_SLV15T0_AC_HUFFMAN	<=	X"FFD4";
			elsif(I_SLV3T0_LENGTH_SIZE = "1011" and I_INT0T10_DATA_WIDTH = 7)then
				O_INT0T15_DATA_WIDTH	<=	15;
				O_SLV15T0_AC_HUFFMAN	<=	X"FFD5";
			elsif(I_SLV3T0_LENGTH_SIZE = "1011" and I_INT0T10_DATA_WIDTH = 8)then
				O_INT0T15_DATA_WIDTH	<=	15;
				O_SLV15T0_AC_HUFFMAN	<=	X"FFD6";
			elsif(I_SLV3T0_LENGTH_SIZE = "1011" and I_INT0T10_DATA_WIDTH = 9)then
				O_INT0T15_DATA_WIDTH	<=	15;
				O_SLV15T0_AC_HUFFMAN	<=	X"FFD7";
			elsif(I_SLV3T0_LENGTH_SIZE = "1011" and I_INT0T10_DATA_WIDTH = 10)then
				O_INT0T15_DATA_WIDTH	<=	15;
				O_SLV15T0_AC_HUFFMAN	<=	X"FFD8";
			--==I_SLV3T0_LENGTH_SIZE = "1100"
			elsif(I_SLV3T0_LENGTH_SIZE = "1100" and I_INT0T10_DATA_WIDTH = 1)then
				O_INT0T15_DATA_WIDTH	<=	9;
				O_SLV15T0_AC_HUFFMAN	<=	X"03FA";
			elsif(I_SLV3T0_LENGTH_SIZE = "1100" and I_INT0T10_DATA_WIDTH = 2)then
				O_INT0T15_DATA_WIDTH	<=	15;
				O_SLV15T0_AC_HUFFMAN	<=	X"FFD9";
			elsif(I_SLV3T0_LENGTH_SIZE = "1100" and I_INT0T10_DATA_WIDTH = 3)then
				O_INT0T15_DATA_WIDTH	<=	15;
				O_SLV15T0_AC_HUFFMAN	<=	X"FFDA";
			elsif(I_SLV3T0_LENGTH_SIZE = "1100" and I_INT0T10_DATA_WIDTH = 4)then
				O_INT0T15_DATA_WIDTH	<=	15;
				O_SLV15T0_AC_HUFFMAN	<=	X"FFDB";
			elsif(I_SLV3T0_LENGTH_SIZE = "1100" and I_INT0T10_DATA_WIDTH = 5)then
				O_INT0T15_DATA_WIDTH	<=	15;
				O_SLV15T0_AC_HUFFMAN	<=	X"FFDC";
			elsif(I_SLV3T0_LENGTH_SIZE = "1100" and I_INT0T10_DATA_WIDTH = 6)then
				O_INT0T15_DATA_WIDTH	<=	15;
				O_SLV15T0_AC_HUFFMAN	<=	X"FFDD";
			elsif(I_SLV3T0_LENGTH_SIZE = "1100" and I_INT0T10_DATA_WIDTH = 7)then
				O_INT0T15_DATA_WIDTH	<=	15;
				O_SLV15T0_AC_HUFFMAN	<=	X"FFDE";
			elsif(I_SLV3T0_LENGTH_SIZE = "1100" and I_INT0T10_DATA_WIDTH = 8)then
				O_INT0T15_DATA_WIDTH	<=	15;
				O_SLV15T0_AC_HUFFMAN	<=	X"FFDF";
			elsif(I_SLV3T0_LENGTH_SIZE = "1100" and I_INT0T10_DATA_WIDTH = 9)then
				O_INT0T15_DATA_WIDTH	<=	15;
				O_SLV15T0_AC_HUFFMAN	<=	X"FFE0";
			elsif(I_SLV3T0_LENGTH_SIZE = "1100" and I_INT0T10_DATA_WIDTH = 10)then
				O_INT0T15_DATA_WIDTH	<=	15;
				O_SLV15T0_AC_HUFFMAN	<=	X"FFE1";
			--==I_SLV3T0_LENGTH_SIZE = "1101"
			elsif(I_SLV3T0_LENGTH_SIZE = "1101" and I_INT0T10_DATA_WIDTH = 1)then
				O_INT0T15_DATA_WIDTH	<=	10;
				O_SLV15T0_AC_HUFFMAN	<=	X"07F8";
			elsif(I_SLV3T0_LENGTH_SIZE = "1101" and I_INT0T10_DATA_WIDTH = 2)then
				O_INT0T15_DATA_WIDTH	<=	15;
				O_SLV15T0_AC_HUFFMAN	<=	X"FFE2";
			elsif(I_SLV3T0_LENGTH_SIZE = "1101" and I_INT0T10_DATA_WIDTH = 3)then
				O_INT0T15_DATA_WIDTH	<=	15;
				O_SLV15T0_AC_HUFFMAN	<=	X"FFE3";
			elsif(I_SLV3T0_LENGTH_SIZE = "1101" and I_INT0T10_DATA_WIDTH = 4)then
				O_INT0T15_DATA_WIDTH	<=	15;
				O_SLV15T0_AC_HUFFMAN	<=	X"FFE4";
			elsif(I_SLV3T0_LENGTH_SIZE = "1101" and I_INT0T10_DATA_WIDTH = 5)then
				O_INT0T15_DATA_WIDTH	<=	15;
				O_SLV15T0_AC_HUFFMAN	<=	X"FFE5";
			elsif(I_SLV3T0_LENGTH_SIZE = "1101" and I_INT0T10_DATA_WIDTH = 6)then
				O_INT0T15_DATA_WIDTH	<=	15;
				O_SLV15T0_AC_HUFFMAN	<=	X"FFE6";
			elsif(I_SLV3T0_LENGTH_SIZE = "1101" and I_INT0T10_DATA_WIDTH = 7)then
				O_INT0T15_DATA_WIDTH	<=	15;
				O_SLV15T0_AC_HUFFMAN	<=	X"FFE7";
			elsif(I_SLV3T0_LENGTH_SIZE = "1101" and I_INT0T10_DATA_WIDTH = 8)then
				O_INT0T15_DATA_WIDTH	<=	15;
				O_SLV15T0_AC_HUFFMAN	<=	X"FFE8";
			elsif(I_SLV3T0_LENGTH_SIZE = "1101" and I_INT0T10_DATA_WIDTH = 9)then
				O_INT0T15_DATA_WIDTH	<=	15;
				O_SLV15T0_AC_HUFFMAN	<=	X"FFE9";
			elsif(I_SLV3T0_LENGTH_SIZE = "1101" and I_INT0T10_DATA_WIDTH = 10)then
				O_INT0T15_DATA_WIDTH	<=	15;
				O_SLV15T0_AC_HUFFMAN	<=	X"FFEA";
			--==I_SLV3T0_LENGTH_SIZE = "1110"
			elsif(I_SLV3T0_LENGTH_SIZE = "1110" and I_INT0T10_DATA_WIDTH = 1)then
				O_INT0T15_DATA_WIDTH	<=	15;
				O_SLV15T0_AC_HUFFMAN	<=	X"FFEB";
			elsif(I_SLV3T0_LENGTH_SIZE = "1110" and I_INT0T10_DATA_WIDTH = 2)then
				O_INT0T15_DATA_WIDTH	<=	15;
				O_SLV15T0_AC_HUFFMAN	<=	X"FFEC";
			elsif(I_SLV3T0_LENGTH_SIZE = "1110" and I_INT0T10_DATA_WIDTH = 3)then
				O_INT0T15_DATA_WIDTH	<=	15;
				O_SLV15T0_AC_HUFFMAN	<=	X"FFED";
			elsif(I_SLV3T0_LENGTH_SIZE = "1110" and I_INT0T10_DATA_WIDTH = 4)then
				O_INT0T15_DATA_WIDTH	<=	15;
				O_SLV15T0_AC_HUFFMAN	<=	X"FFEE";
			elsif(I_SLV3T0_LENGTH_SIZE = "1110" and I_INT0T10_DATA_WIDTH = 5)then
				O_INT0T15_DATA_WIDTH	<=	15;
				O_SLV15T0_AC_HUFFMAN	<=	X"FFEF";
			elsif(I_SLV3T0_LENGTH_SIZE = "1110" and I_INT0T10_DATA_WIDTH = 6)then
				O_INT0T15_DATA_WIDTH	<=	15;
				O_SLV15T0_AC_HUFFMAN	<=	X"FFF0";
			elsif(I_SLV3T0_LENGTH_SIZE = "1110" and I_INT0T10_DATA_WIDTH = 7)then
				O_INT0T15_DATA_WIDTH	<=	15;
				O_SLV15T0_AC_HUFFMAN	<=	X"FFF1";
			elsif(I_SLV3T0_LENGTH_SIZE = "1110" and I_INT0T10_DATA_WIDTH = 8)then
				O_INT0T15_DATA_WIDTH	<=	15;
				O_SLV15T0_AC_HUFFMAN	<=	X"FFF2";
			elsif(I_SLV3T0_LENGTH_SIZE = "1110" and I_INT0T10_DATA_WIDTH = 9)then
				O_INT0T15_DATA_WIDTH	<=	15;
				O_SLV15T0_AC_HUFFMAN	<=	X"FFF3";
			elsif(I_SLV3T0_LENGTH_SIZE = "1110" and I_INT0T10_DATA_WIDTH = 10)then
				O_INT0T15_DATA_WIDTH	<=	15;
				O_SLV15T0_AC_HUFFMAN	<=	X"FFF4";
			--==I_SLV3T0_LENGTH_SIZE = "1111"
			elsif(I_SLV3T0_LENGTH_SIZE = "1111" and I_INT0T10_DATA_WIDTH = 0)then
				O_INT0T15_DATA_WIDTH	<=	10;
				O_SLV15T0_AC_HUFFMAN	<=	X"07F9";
			elsif(I_SLV3T0_LENGTH_SIZE = "1111" and I_INT0T10_DATA_WIDTH = 1)then
				O_INT0T15_DATA_WIDTH	<=	15;
				O_SLV15T0_AC_HUFFMAN	<=	X"FFF5";
			elsif(I_SLV3T0_LENGTH_SIZE = "1111" and I_INT0T10_DATA_WIDTH = 2)then
				O_INT0T15_DATA_WIDTH	<=	15;
				O_SLV15T0_AC_HUFFMAN	<=	X"FFF6";
			elsif(I_SLV3T0_LENGTH_SIZE = "1111" and I_INT0T10_DATA_WIDTH = 3)then
				O_INT0T15_DATA_WIDTH	<=	15;
				O_SLV15T0_AC_HUFFMAN	<=	X"FFF7";
			elsif(I_SLV3T0_LENGTH_SIZE = "1111" and I_INT0T10_DATA_WIDTH = 4)then
				O_INT0T15_DATA_WIDTH	<=	15;
				O_SLV15T0_AC_HUFFMAN	<=	X"FFF8";
			elsif(I_SLV3T0_LENGTH_SIZE = "1111" and I_INT0T10_DATA_WIDTH = 5)then
				O_INT0T15_DATA_WIDTH	<=	15;
				O_SLV15T0_AC_HUFFMAN	<=	X"FFF9";
			elsif(I_SLV3T0_LENGTH_SIZE = "1111" and I_INT0T10_DATA_WIDTH = 6)then
				O_INT0T15_DATA_WIDTH	<=	15;
				O_SLV15T0_AC_HUFFMAN	<=	X"FFFA";
			elsif(I_SLV3T0_LENGTH_SIZE = "1111" and I_INT0T10_DATA_WIDTH = 7)then
				O_INT0T15_DATA_WIDTH	<=	15;
				O_SLV15T0_AC_HUFFMAN	<=	X"FFFB";
			elsif(I_SLV3T0_LENGTH_SIZE = "1111" and I_INT0T10_DATA_WIDTH = 8)then
				O_INT0T15_DATA_WIDTH	<=	15;
				O_SLV15T0_AC_HUFFMAN	<=	X"FFFC";
			elsif(I_SLV3T0_LENGTH_SIZE = "1111" and I_INT0T10_DATA_WIDTH = 9)then
				O_INT0T15_DATA_WIDTH	<=	15;
				O_SLV15T0_AC_HUFFMAN	<=	X"FFFD";
			elsif(I_SLV3T0_LENGTH_SIZE = "1111" and I_INT0T10_DATA_WIDTH = 10)then
				O_INT0T15_DATA_WIDTH	<=	15;
				O_SLV15T0_AC_HUFFMAN	<=	X"FFFE";
			else
				O_INT0T15_DATA_WIDTH	<=	0;
				O_SLV15T0_AC_HUFFMAN	<=	(others=>'0');
			end if;
		end if;
	end process;

end Behavioral;

