------------------------------------------------------------
-- Product     : JPEG_ENCODER v1.1                       --
-- Module      : HUFFMAN_ENCODER_PROCESS v1.1             --
-- Last Update : 2011/04/20                               --
--                                                        --
-- Engineer    : Takuya Katayama                          --
-- Mail        : pajamas@hotmail.co.jp                    --
--                                                        --
-- Copyright (C) 2011 Takuya Katayama All Rights Reserved.--
------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

entity LUMINANCE_DC_ROM is
port(	
		I_SL_CLK					:	in		std_logic;
		I_INT0T11_DATA_WIDTH	:	in		integer range 0 to 11;
		O_SLV8T0_DC_HUFFMAN	:	out	std_logic_vector(8 downto 0);
		O_INT0T8_DATA_WIDTH	:	out	integer range 0 to 8
);
end LUMINANCE_DC_ROM;

architecture Behavioral of LUMINANCE_DC_ROM is

begin

process(I_SL_CLK)
begin
	if(I_SL_CLK'event and I_SL_CLK='1')then
		if(I_INT0T11_DATA_WIDTH=11)then
			O_SLV8T0_DC_HUFFMAN	<=	"111111110";
			O_INT0T8_DATA_WIDTH	<=	8;
		elsif(I_INT0T11_DATA_WIDTH=10)then
			O_SLV8T0_DC_HUFFMAN	<=	"011111110";
			O_INT0T8_DATA_WIDTH	<=	7;
		elsif(I_INT0T11_DATA_WIDTH=9)then
			O_SLV8T0_DC_HUFFMAN	<=	"001111110";
			O_INT0T8_DATA_WIDTH	<=	6;
		elsif(I_INT0T11_DATA_WIDTH=8)then
			O_SLV8T0_DC_HUFFMAN	<=	"000111110";
			O_INT0T8_DATA_WIDTH	<=	5;
		elsif(I_INT0T11_DATA_WIDTH=7)then
			O_SLV8T0_DC_HUFFMAN	<=	"000011110";
			O_INT0T8_DATA_WIDTH	<=	4;
		elsif(I_INT0T11_DATA_WIDTH=6)then
			O_SLV8T0_DC_HUFFMAN	<=	"000001110";
			O_INT0T8_DATA_WIDTH	<=	3;
		elsif(I_INT0T11_DATA_WIDTH=5)then
			O_SLV8T0_DC_HUFFMAN	<=	"000000110";
			O_INT0T8_DATA_WIDTH	<=	2;
		elsif(I_INT0T11_DATA_WIDTH=4)then
			O_SLV8T0_DC_HUFFMAN	<=	"000000101";
			O_INT0T8_DATA_WIDTH	<=	2;
		elsif(I_INT0T11_DATA_WIDTH=3)then
			O_SLV8T0_DC_HUFFMAN	<=	"000000100";
			O_INT0T8_DATA_WIDTH	<=	2;
		elsif(I_INT0T11_DATA_WIDTH=2)then
			O_SLV8T0_DC_HUFFMAN	<=	"000000011";
			O_INT0T8_DATA_WIDTH	<=	2;
		elsif(I_INT0T11_DATA_WIDTH=1)then
			O_SLV8T0_DC_HUFFMAN	<=	"000000010";
			O_INT0T8_DATA_WIDTH	<=	2;
		elsif(I_INT0T11_DATA_WIDTH=0)then
			O_SLV8T0_DC_HUFFMAN	<=	"000000000";
			O_INT0T8_DATA_WIDTH	<=	1;
		end if;
	end if;
end process;


end Behavioral;

