------------------------------------------------------------
-- Product     : JPEG_ENCODER v1.1                       --
-- Module      : HUFFMAN_ENCODER_PROCESS v1.1             --
-- Last Update : 2011/04/20                               --
--                                                        --
-- Engineer    : Takuya Katayama                          --
-- Mail        : pajamas@hotmail.co.jp                    --
--                                                        --
-- Copyright (C) 2011 Takuya Katayama All Rights Reserved.--
------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

entity RUNLENGTH is
port(
		I_SL_CLK						:	in		std_logic;
		I_SL_BLOCK_START			:	in		std_logic;
		I_SL_BLOCK_END				:	in		std_logic;
		I_SL_DATA_ENABLE			:	in		std_logic;
		I_SLV11T0_DATA				:	in		std_logic_vector(11 downto 0);		
		O_SL_BLOCK_START			:	out	std_logic;
		O_SL_BLOCK_END				:	out	std_logic;
		O_SL_DATA_ENABLE			:	out	std_logic;
		O_SLV3T0_LENGTH_SIZE		:	out	std_logic_vector(3 downto 0);
		O_SLV11T0_DATA				:	out	std_logic_vector(11 downto 0)
);
end RUNLENGTH;

architecture Behavioral of RUNLENGTH is

signal	sig_slv11t0_data		:	std_logic_vector(11 downto 0):=(others=>'0');
signal	sig_sl_data_enable	:	std_logic:='0';
signal	sig_sl_block_start	:	std_logic:='0';
signal	sig_sl_block_end		:	std_logic:='0';
signal	sig_slv3t0_size		:	std_logic_vector(3 downto 0):=(others=>'0');

signal	sig_sl_block_start_01c_dff	:	std_logic:='0';
signal	sig_sl_block_end_01c_dff	:	std_logic:='0';

signal	sig_sl_zrl				:	std_logic:='0';

begin

process(I_SL_CLK)
begin
	if(I_SL_CLK'event and I_SL_CLK='1')then
		sig_slv11t0_data		<=	I_SLV11T0_DATA;
		sig_sl_data_enable	<=	I_SL_DATA_ENABLE;
		sig_sl_block_start	<=	I_SL_BLOCK_START;
		sig_sl_block_end		<=	I_SL_BLOCK_END;
	end if;
end process;

process(I_SL_CLK)
begin
	if(I_SL_CLK'event and I_SL_CLK='1')then
		sig_sl_block_start_01c_dff	<=	sig_sl_block_start;
		sig_sl_block_end_01c_dff	<=	sig_sl_block_end;
	end if;
end process;

		O_SL_BLOCK_START				<=	sig_sl_block_start_01c_dff;
		O_SL_BLOCK_END					<=	sig_sl_block_end_01c_dff;


--process(I_SL_CLK)
--begin
--	if(I_SL_CLK'event and I_SL_CLK='1')then
--		if(I_SL_DATA_ENABLE='1'	or	sig_sl_data_enable='1')then--͗LȁH
--			if(sig_sl_zrl='1')then--zero_runlength
--				sig_sl_zrl				<=	'0';
--				O_SL_DATA_ENABLE		<=	'1';
--				O_SLV3T0_LENGTH_SIZE	<=	"0000";
--				O_SLV11T0_DATA			<=	sig_slv11t0_data;		
--				if(I_SLV11T0_DATA="000000000000")then--ZRL̎0ĂȂ玟0ׂ̈ɒlZbg
--					sig_slv3t0_size		<="0001";
--				else--ĂȂȂ
--					sig_slv3t0_size		<="0000";
--				end if;
--			elsif(sig_sl_block_end='1')then--ubN̈ԍŌゾꍇ
--				O_SL_DATA_ENABLE		<=	'1';
----				O_SLV3T0_LENGTH_SIZE	<=	sig_slv3t0_size;
----				sig_slv3t0_size		<=	"0000";
--				O_SLV11T0_DATA			<=	sig_slv11t0_data;
----test DC0̏ꍇAOXlȂ@̌͂ɂ邩Ȃ̂ňꕔ폜Ă܂
----				if(I_SLV11T0_DATA="000000000000")then--ubN̈ԍŌ̎0ĂȂ玟̃ubNׂ̈ɒlZbg
----					sig_slv3t0_size		<="0001";
----				else--ĂȂȂ
--					sig_slv3t0_size		<="0000";--̃ubN̂߂ɃZbgH
----				end if;
----test end
--				if(sig_slv11t0_data="000000000000")then--ubN̈ԍŌオ0Ȃ΁AEOBo͂
--					O_SLV3T0_LENGTH_SIZE	<=	"0000";
--				else--ubN̈ԍŌオ0łȂȂ΁AEOB͏o͂Ȃ(JPEG̎dlƂĂ肤)
--					O_SLV3T0_LENGTH_SIZE	<=	sig_slv3t0_size;
--				end if;
----EOB̂ŉiɕKvȂXe[g
----			elsif(I_SL_BLOCK_START='1' and sig_sl_block_end_01c_dff='1' and I_SLV11T0_DATA="000000000000")then--܃ubNAEEE̎,0ꍇ̃X^[g
----				O_SL_DATA_ENABLE		<=	'1';
----				O_SLV3T0_LENGTH_SIZE	<=	sig_slv3t0_size;
----				sig_slv3t0_size		<="0001";
----				O_SLV11T0_DATA			<=	sig_slv11t0_data;
----			elsif(I_SL_BLOCK_START='1' and sig_sl_block_end_01c_dff='1')then--܃ubNAEEE̎,0ȊOꍇ̃X^[g
----				O_SL_DATA_ENABLE		<=	'1';
----				O_SLV3T0_LENGTH_SIZE	<=	sig_slv3t0_size;
----				sig_slv3t0_size		<="0000";
----				O_SLV11T0_DATA			<=	sig_slv11t0_data;
----܂ŁB
--			elsif(I_SL_BLOCK_START='1' and sig_sl_block_end_01c_dff='0' and I_SLV11T0_DATA="000000000000")then--ԍŏ0̏ꍇ
--				O_SL_DATA_ENABLE		<=	'0';
--				sig_slv3t0_size		<="0001";
--				O_SLV3T0_LENGTH_SIZE	<=	sig_slv3t0_size;
--				O_SLV11T0_DATA			<=	sig_slv11t0_data;
--			elsif(I_SL_BLOCK_START='1' and sig_sl_block_end_01c_dff='0')then--ԍŏ0ȊȌꍇ
--				O_SL_DATA_ENABLE		<=	'0';
--				sig_slv3t0_size		<="0000";
--				O_SLV3T0_LENGTH_SIZE	<=	sig_slv3t0_size;
--				O_SLV11T0_DATA			<=	sig_slv11t0_data;
--			elsif(I_SLV11T0_DATA="000000000000")then--ubN̐擪ƂƂ֌WȂA0ꍇ
--				if(I_SLV11T0_DATA=sig_slv11t0_data)then--O0Ăꍇ
--					if(sig_slv3t0_size	=	"1111")then--JEgłȂBZRLtOƃp[[^ZbgB
--						O_SL_DATA_ENABLE		<=	'0';
--						sig_sl_zrl				<=	'1';
--						O_SLV3T0_LENGTH_SIZE	<=	sig_slv3t0_size;
--						sig_slv3t0_size		<=	"0000";
--					elsif(sig_sl_block_end='0' and sig_sl_zrl='0')then--0AĂ邪ubNGhłȂAZRLłȂ
--						O_SL_DATA_ENABLE		<=	'0';
--						O_SLV3T0_LENGTH_SIZE	<=	sig_slv3t0_size;
--						sig_slv3t0_size		<=	sig_slv3t0_size	+	1;	
--					elsif(sig_sl_block_end='1')then--ubNGhꍇ
--						O_SL_DATA_ENABLE		<=	'1';
--						O_SLV3T0_LENGTH_SIZE	<=	sig_slv3t0_size;
--						sig_slv3t0_size		<=	"0000";
--						O_SLV11T0_DATA			<=	sig_slv11t0_data;
--					end if;
----EOBdroeXg
--				elsif(sig_sl_data_enable='0')then--ubNGhƃX^[g̏̂͂
--					O_SL_DATA_ENABLE		<=	'0';
--					O_SLV3T0_LENGTH_SIZE	<=	sig_slv3t0_size;
--					sig_slv3t0_size		<=	"0001";
--					O_SLV11T0_DATA			<=	sig_slv11t0_data;
----EOBdroeXgend
--				else--0O0ł͂Ȃꍇ
--					O_SL_DATA_ENABLE		<=	'1';
--					O_SLV3T0_LENGTH_SIZE	<=	sig_slv3t0_size;
--					sig_slv3t0_size		<=	"0001";
--					O_SLV11T0_DATA			<=	sig_slv11t0_data;
--				end if;
----			elsif(sig_slv11t0_data="000000000000" and sig_slv3t0_size="1111")then--傤ZRLɂȂꍇ
----				O_SL_DATA_ENABLE		<=	'0';
----				O_SLV3T0_LENGTH_SIZE	<=	sig_slv3t0_size;
----				sig_slv3t0_size		<=	"0000";
----				sig_sl_zrl				<=	'1';
--			elsif(sig_slv11t0_data	=	"000000000000")then--0ȊOAŌ̃JEgAbv͂ȂẮB
--				O_SL_DATA_ENABLE		<=	'0';
--				O_SLV3T0_LENGTH_SIZE	<=	sig_slv3t0_size;
----				sig_slv3t0_size		<=	"0000";
----				sig_slv3t0_size		<=	sig_slv3t0_size + 1;
--				O_SLV11T0_DATA			<=	sig_slv11t0_data;
--			elsif(sig_slv3t0_size	>	"0000")then--0ȊO̎A0̘AcĂȂAo͂ȂƁB
--				O_SL_DATA_ENABLE		<=	'1';
--				O_SLV3T0_LENGTH_SIZE	<=	sig_slv3t0_size;
--				sig_slv3t0_size		<=	"0000";
--				O_SLV11T0_DATA			<=	sig_slv11t0_data;
--			else--0ȊȌꍇ
--				O_SL_DATA_ENABLE		<=	'1';
--				O_SLV3T0_LENGTH_SIZE	<=	sig_slv3t0_size;
--				sig_slv3t0_size		<=	"0000";
--				O_SLV11T0_DATA			<=	sig_slv11t0_data;
--			end if;
--		else--Lf[^ĂȂꍇ
--			O_SL_DATA_ENABLE		<=	'0';
--			O_SLV3T0_LENGTH_SIZE	<=	sig_slv3t0_size;
--			O_SLV11T0_DATA			<=	sig_slv11t0_data;		
--		end if;
--	end if;
--end process;


--G߁A\ύXA
--ȉX^[g

process(I_SL_CLK)
begin
	if(I_SL_CLK'event and I_SL_CLK='1')then
		if(sig_sl_data_enable='1')then--͗LȁH
--ubN̈ԍŏ̏ꍇ
			if(sig_sl_block_start='1')then
				if(sig_slv11t0_data="000000000000")then--ԍŏ0̏ꍇ
					O_SL_DATA_ENABLE		<=	'0';
					sig_slv3t0_size		<="0001";
					O_SLV3T0_LENGTH_SIZE	<=	"0000";
					O_SLV11T0_DATA			<=	sig_slv11t0_data;
				else--ԍŏ0łȂꍇ
					O_SL_DATA_ENABLE		<=	'1';
					sig_slv3t0_size		<="0000";
					O_SLV3T0_LENGTH_SIZE	<=	"0000";
					O_SLV11T0_DATA			<=	sig_slv11t0_data;
				end if;
--ubN̈ԍŌゾꍇ
			elsif(sig_sl_block_end='1')then
				O_SL_DATA_ENABLE		<=	'1';
				O_SLV11T0_DATA			<=	sig_slv11t0_data;
				sig_slv3t0_size		<="0000";
				if(sig_slv11t0_data="000000000000")then--ubN̈ԍŌオ0Ȃ΁AEOBo͂
					O_SLV3T0_LENGTH_SIZE	<=	"0000";
				else--ubN̈ԍŌオ0łȂȂ΁AEOB͏o͂Ȃ(JPEG̎dlƂĂ肤)
					O_SLV3T0_LENGTH_SIZE	<=	sig_slv3t0_size;
				end if;	
--ubN̓ȑꍇ@0̏ꍇ
			elsif(sig_slv11t0_data="000000000000")then
				if(sig_slv3t0_size	=	"1111")then--[OX̏ꍇ
					O_SL_DATA_ENABLE		<=	'1';
					sig_slv3t0_size		<=	"0000";
					O_SLV3T0_LENGTH_SIZE	<=	sig_slv3t0_size;
					O_SLV11T0_DATA			<=	sig_slv11t0_data;		
				else--[OXłȂꍇ
					O_SL_DATA_ENABLE		<=	'0';
					O_SLV3T0_LENGTH_SIZE	<=	sig_slv3t0_size;
					sig_slv3t0_size		<=	sig_slv3t0_size	+	1;
					O_SLV11T0_DATA			<=	sig_slv11t0_data;
				end if;
--ubN̓ȑꍇ@0ȊȌꍇ
			else
				O_SL_DATA_ENABLE		<=	'1';
				O_SLV3T0_LENGTH_SIZE	<=	sig_slv3t0_size;
				sig_slv3t0_size		<=	"0000";
				O_SLV11T0_DATA			<=	sig_slv11t0_data;
			end if;
		else--Lf[^ĂȂꍇ
			O_SL_DATA_ENABLE		<=	'0';
			sig_slv3t0_size		<=	"0000";
			O_SLV3T0_LENGTH_SIZE	<=	"0000";
			O_SLV11T0_DATA			<=	"000000000000";		
		end if;
	end if;
end process;

end Behavioral;