----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date:    20:05:17 05/18/2010 
-- Design Name: 
-- Module Name:    DCT_8POINT_1 - Behavioral 
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: 
--
-- Dependencies:  19CLK
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

---- Uncomment the following library declaration if instantiating
---- any Xilinx primitives in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity IDCT_8POINT_1 is
port(	I_SL_CLK			:	in		std_logic;
		I_SL_RESET		:	in		std_logic;
		I_SL_START		:	in		std_logic;
		I_SLV11T0_DATA	:	in		std_logic_vector(11 downto 0);
		O_SL_START		:	out	std_logic;
		O_SLV11T0_DATA	:	out	std_logic_vector(11 downto 0)
);
end IDCT_8POINT_1;

architecture Behavioral of IDCT_8POINT_1 is

component IDCT_POINT1
	port(
			I_SL_CLK					:	in		std_logic;
			I_SLV11T0_DATA			:	in		std_logic_vector(11 downto 0);
			I_SLV11T0_IDCT_VALUE	:	in		std_logic_vector(11 downto 0);
			I_SL_IDCT_VALUE_FLAG	:	in		std_logic;
			O_SLV11T0_DATA			:	out	std_logic_vector(11 downto 0)
	);
end component;

constant	con_start_flag_delay_int			:	integer:=17;--̃ubN̒xʂ͍̒l{2
signal	sig_slv31t0_start_flag_shift_reg	:	std_logic_vector(31 downto 0);
                                                                                 
signal	sig_slv11t0_data			:	std_logic_vector(11 downto 0);
signal	sig_slv11t0_data_f		:	std_logic_vector(11 downto 0);

signal	sig_slv2t0_count			:	std_logic_vector(2 downto 0):="000";
signal	sig_slv2t0_count_d01		:	std_logic_vector(2 downto 0):="000";
signal	sig_slv2t0_count_d02		:	std_logic_vector(2 downto 0):="000";
signal	sig_slv2t0_count_d03		:	std_logic_vector(2 downto 0):="000";
signal	sig_slv2t0_count_d04		:	std_logic_vector(2 downto 0):="000";
signal	sig_slv2t0_count_d05		:	std_logic_vector(2 downto 0):="000";
signal	sig_slv2t0_count_d06		:	std_logic_vector(2 downto 0):="000";
signal	sig_slv2t0_count_d07		:	std_logic_vector(2 downto 0):="000";
signal	sig_slv2t0_count_d08		:	std_logic_vector(2 downto 0):="000";
signal	sig_slv2t0_count_d09		:	std_logic_vector(2 downto 0):="000";
signal	sig_slv2t0_count_d10		:	std_logic_vector(2 downto 0):="000";
signal	sig_slv2t0_count_d11		:	std_logic_vector(2 downto 0):="000";
signal	sig_slv2t0_count_d12		:	std_logic_vector(2 downto 0):="000";
signal	sig_slv2t0_count_d13		:	std_logic_vector(2 downto 0):="000";
signal	sig_slv2t0_count_d14		:	std_logic_vector(2 downto 0):="000";
signal	sig_slv2t0_count_d15		:	std_logic_vector(2 downto 0):="000";
signal	sig_slv2t0_count_d16		:	std_logic_vector(2 downto 0):="000";
signal	sig_slv2t0_count_d17		:	std_logic_vector(2 downto 0):="000";

signal	sig_slv11t0_idct_value1	:	std_logic_vector(11 downto 0):="000000000000";
signal	sig_slv11t0_idct_value2	:	std_logic_vector(11 downto 0):="000000000000";
signal	sig_slv11t0_idct_value3	:	std_logic_vector(11 downto 0):="000000000000";
signal	sig_slv11t0_idct_value4	:	std_logic_vector(11 downto 0):="000000000000";
signal	sig_slv11t0_idct_value5	:	std_logic_vector(11 downto 0):="000000000000";
signal	sig_slv11t0_idct_value6	:	std_logic_vector(11 downto 0):="000000000000";
signal	sig_slv11t0_idct_value7	:	std_logic_vector(11 downto 0):="000000000000";
signal	sig_slv11t0_idct_value8	:	std_logic_vector(11 downto 0):="000000000000";
signal	sig_sl_idct_value1_flag	:	std_logic:='0';
signal	sig_sl_idct_value2_flag	:	std_logic:='0';
signal	sig_sl_idct_value3_flag	:	std_logic:='0';
signal	sig_sl_idct_value4_flag	:	std_logic:='0';
signal	sig_sl_idct_value5_flag	:	std_logic:='0';
signal	sig_sl_idct_value6_flag	:	std_logic:='0';
signal	sig_sl_idct_value7_flag	:	std_logic:='0';
signal	sig_sl_idct_value8_flag	:	std_logic:='0';

signal	sig_slv11t0_idct_point1_1	:	std_logic_vector(11 downto 0);

signal	sig_slv11t0_idct_point2_1	:	std_logic_vector(11 downto 0);
signal	sig_slv11t0_idct_point2_2	:	std_logic_vector(11 downto 0);

signal	sig_slv11t0_idct_point3_1	:	std_logic_vector(11 downto 0);
signal	sig_slv11t0_idct_point3_2	:	std_logic_vector(11 downto 0);
signal	sig_slv11t0_idct_point3_3	:	std_logic_vector(11 downto 0);

signal	sig_slv11t0_idct_point4_1	:	std_logic_vector(11 downto 0);
signal	sig_slv11t0_idct_point4_2	:	std_logic_vector(11 downto 0);
signal	sig_slv11t0_idct_point4_3	:	std_logic_vector(11 downto 0);
signal	sig_slv11t0_idct_point4_4	:	std_logic_vector(11 downto 0);

signal	sig_slv11t0_idct_point5_1	:	std_logic_vector(11 downto 0);
signal	sig_slv11t0_idct_point5_2	:	std_logic_vector(11 downto 0);
signal	sig_slv11t0_idct_point5_3	:	std_logic_vector(11 downto 0);
signal	sig_slv11t0_idct_point5_4	:	std_logic_vector(11 downto 0);
signal	sig_slv11t0_idct_point5_5	:	std_logic_vector(11 downto 0);
                                                   
signal	sig_slv11t0_idct_point6_1	:	std_logic_vector(11 downto 0);
signal	sig_slv11t0_idct_point6_2	:	std_logic_vector(11 downto 0);
signal	sig_slv11t0_idct_point6_3	:	std_logic_vector(11 downto 0);
signal	sig_slv11t0_idct_point6_4	:	std_logic_vector(11 downto 0);
signal	sig_slv11t0_idct_point6_5	:	std_logic_vector(11 downto 0);
signal	sig_slv11t0_idct_point6_6	:	std_logic_vector(11 downto 0);

signal	sig_slv11t0_idct_point7_1	:	std_logic_vector(11 downto 0);
signal	sig_slv11t0_idct_point7_2	:	std_logic_vector(11 downto 0);
signal	sig_slv11t0_idct_point7_3	:	std_logic_vector(11 downto 0);
signal	sig_slv11t0_idct_point7_4	:	std_logic_vector(11 downto 0);
signal	sig_slv11t0_idct_point7_5	:	std_logic_vector(11 downto 0);
signal	sig_slv11t0_idct_point7_6	:	std_logic_vector(11 downto 0);
signal	sig_slv11t0_idct_point7_7	:	std_logic_vector(11 downto 0);
                                                   
signal	sig_slv11t0_idct_point8_1	:	std_logic_vector(11 downto 0);
signal	sig_slv11t0_idct_point8_2	:	std_logic_vector(11 downto 0);
signal	sig_slv11t0_idct_point8_3	:	std_logic_vector(11 downto 0);
signal	sig_slv11t0_idct_point8_4	:	std_logic_vector(11 downto 0);
signal	sig_slv11t0_idct_point8_5	:	std_logic_vector(11 downto 0);
signal	sig_slv11t0_idct_point8_6	:	std_logic_vector(11 downto 0);
signal	sig_slv11t0_idct_point8_7	:	std_logic_vector(11 downto 0);
signal	sig_slv11t0_idct_point8_8	:	std_logic_vector(11 downto 0);
                                                   
begin

process(I_SL_CLK)
begin
	if(I_SL_CLK'event and I_SL_CLK='1')then
			sig_slv31t0_start_flag_shift_reg(31 downto 1)	<=	sig_slv31t0_start_flag_shift_reg(30 downto 1)	&	I_SL_START;
			O_SL_START	<=	sig_slv31t0_start_flag_shift_reg(con_start_flag_delay_int);
	end if;
end process;

--擪DCTďZpCvC
process(I_SL_CLK)
begin
	if(I_SL_CLK'event and I_SL_CLK='1')then
		if(I_SL_START='1' or sig_slv2t0_count="111")then
			sig_slv2t0_count	<=	"000";
		else
			sig_slv2t0_count	<=	sig_slv2t0_count	+	'1';
		end if;
	end if;
end process;

--DCTWĂяo܂ŁA҂
process(I_SL_CLK)
begin
	if(I_SL_CLK'event and I_SL_CLK='1')then
		sig_slv11t0_data_f	<=	I_SLV11T0_DATA;
		sig_slv11t0_data		<=	sig_slv11t0_data_f;
	end if;
end process;

----DCŤŒlvZʕ\(؎̂)
--process(I_SL_CLK)
--begin
--	if(I_SL_CLK'event and I_SL_CLK='1')then
--		if(sig_slv2t0_count="000")then
--			sig_slv11t0_dct_value1	<=	"010110101000";
--			sig_slv11t0_dct_value2	<=	"011111011000";
--			sig_slv11t0_dct_value3	<=	"011101100100";
--			sig_slv11t0_dct_value4	<=	"011010100110";
--			sig_slv11t0_dct_value5	<=	"010110101000";
--			sig_slv11t0_dct_value6	<=	"010001110001";
--			sig_slv11t0_dct_value7	<=	"001100001111";
--			sig_slv11t0_dct_value8	<=	"000110001111";
--			sig_sl_dct_value1_flag	<=	'0';
--			sig_sl_dct_value2_flag	<=	'0';
--			sig_sl_dct_value3_flag	<=	'0';
--			sig_sl_dct_value4_flag	<=	'0';
--			sig_sl_dct_value5_flag	<=	'0';
--			sig_sl_dct_value6_flag	<=	'0';
--			sig_sl_dct_value7_flag	<=	'0';
--			sig_sl_dct_value8_flag	<=	'0';
--		elsif(sig_slv2t0_count="001")then
--			sig_slv11t0_dct_value1	<=	"010110101000";
--			sig_slv11t0_dct_value2	<=	"011010100110";
--			sig_slv11t0_dct_value3	<=	"001100001111";
--			sig_slv11t0_dct_value4	<=	"000110001111";
--			sig_slv11t0_dct_value5	<=	"010110101000";
--			sig_slv11t0_dct_value6	<=	"011111011000";
--			sig_slv11t0_dct_value7	<=	"011101100100";
--			sig_slv11t0_dct_value8	<=	"010001110001";
--			sig_sl_dct_value1_flag	<=	'0';
--			sig_sl_dct_value2_flag	<=	'0';
--			sig_sl_dct_value3_flag	<=	'0';
--			sig_sl_dct_value4_flag	<=	'1';
--			sig_sl_dct_value5_flag	<=	'1';
--			sig_sl_dct_value6_flag	<=	'1';
--			sig_sl_dct_value7_flag	<=	'1';
--			sig_sl_dct_value8_flag	<=	'1';
--		elsif(sig_slv2t0_count="010")then
--			sig_slv11t0_dct_value1	<=	"010110101000";
--			sig_slv11t0_dct_value2	<=	"010001110001";
--			sig_slv11t0_dct_value3	<=	"001100001111";
--			sig_slv11t0_dct_value4	<=	"011111011000";
--			sig_slv11t0_dct_value5	<=	"010110101000";
--			sig_slv11t0_dct_value6	<=	"000110001111";
--			sig_slv11t0_dct_value7	<=	"011101100100";
--			sig_slv11t0_dct_value8	<=	"011010100110";
--			sig_sl_dct_value1_flag	<=	'0';
--			sig_sl_dct_value2_flag	<=	'0';
--			sig_sl_dct_value3_flag	<=	'1';
--			sig_sl_dct_value4_flag	<=	'1';
--			sig_sl_dct_value5_flag	<=	'1';
--			sig_sl_dct_value6_flag	<=	'0';
--			sig_sl_dct_value7_flag	<=	'0';
--			sig_sl_dct_value8_flag	<=	'0';
--		elsif(sig_slv2t0_count="011")then
--			sig_slv11t0_dct_value1	<=	"010110101000";
--			sig_slv11t0_dct_value2	<=	"000110001111";
--			sig_slv11t0_dct_value3	<=	"011101100100";
--			sig_slv11t0_dct_value4	<=	"010001110001";
--			sig_slv11t0_dct_value5	<=	"010110101000";
--			sig_slv11t0_dct_value6	<=	"011010100110";
--			sig_slv11t0_dct_value7	<=	"001100001111";
--			sig_slv11t0_dct_value8	<=	"011111011000";
--			sig_sl_dct_value1_flag	<=	'0';
--			sig_sl_dct_value2_flag	<=	'0';
--			sig_sl_dct_value3_flag	<=	'1';
--			sig_sl_dct_value4_flag	<=	'1';
--			sig_sl_dct_value5_flag	<=	'0';
--			sig_sl_dct_value6_flag	<=	'0';
--			sig_sl_dct_value7_flag	<=	'1';
--			sig_sl_dct_value8_flag	<=	'1';
--		elsif(sig_slv2t0_count="100")then
--			sig_slv11t0_dct_value1	<=	"010110101000";
--			sig_slv11t0_dct_value2	<=	"000110001111";
--			sig_slv11t0_dct_value3	<=	"011101100100";
--			sig_slv11t0_dct_value4	<=	"010001110001";
--			sig_slv11t0_dct_value5	<=	"010110101000";
--			sig_slv11t0_dct_value6	<=	"011010100110";
--			sig_slv11t0_dct_value7	<=	"001100001111";
--			sig_slv11t0_dct_value8	<=	"011111011000";
--			sig_sl_dct_value1_flag	<=	'0';
--			sig_sl_dct_value2_flag	<=	'1';
--			sig_sl_dct_value3_flag	<=	'1';
--			sig_sl_dct_value4_flag	<=	'0';
--			sig_sl_dct_value5_flag	<=	'0';
--			sig_sl_dct_value6_flag	<=	'1';
--			sig_sl_dct_value7_flag	<=	'1';
--			sig_sl_dct_value8_flag	<=	'0';
--		elsif(sig_slv2t0_count="101")then
--			sig_slv11t0_dct_value1	<=	"010110101000";
--			sig_slv11t0_dct_value2	<=	"010001110001";
--			sig_slv11t0_dct_value3	<=	"001100001111";
--			sig_slv11t0_dct_value4	<=	"011111011000";
--			sig_slv11t0_dct_value5	<=	"010110101000";
--			sig_slv11t0_dct_value6	<=	"000110001111";
--			sig_slv11t0_dct_value7	<=	"011101100100";
--			sig_slv11t0_dct_value8	<=	"011010100110";
--			sig_sl_dct_value1_flag	<=	'0';
--			sig_sl_dct_value2_flag	<=	'1';
--			sig_sl_dct_value3_flag	<=	'1';
--			sig_sl_dct_value4_flag	<=	'0';
--			sig_sl_dct_value5_flag	<=	'1';
--			sig_sl_dct_value6_flag	<=	'1';
--			sig_sl_dct_value7_flag	<=	'0';
--			sig_sl_dct_value8_flag	<=	'1';
--		elsif(sig_slv2t0_count="110")then
--			sig_slv11t0_dct_value1	<=	"010110101000";
--			sig_slv11t0_dct_value2	<=	"011010100110";
--			sig_slv11t0_dct_value3	<=	"001100001111";
--			sig_slv11t0_dct_value4	<=	"000110001111";
--			sig_slv11t0_dct_value5	<=	"010110101000";
--			sig_slv11t0_dct_value6	<=	"011111011000";
--			sig_slv11t0_dct_value7	<=	"011101100100";
--			sig_slv11t0_dct_value8	<=	"010001110001";
--			sig_sl_dct_value1_flag	<=	'0';
--			sig_sl_dct_value2_flag	<=	'1';
--			sig_sl_dct_value3_flag	<=	'0';
--			sig_sl_dct_value4_flag	<=	'0';
--			sig_sl_dct_value5_flag	<=	'1';
--			sig_sl_dct_value6_flag	<=	'0';
--			sig_sl_dct_value7_flag	<=	'1';
--			sig_sl_dct_value8_flag	<=	'0';
--		elsif(sig_slv2t0_count="111")then
--			sig_slv11t0_dct_value1	<=	"010110101000";
--			sig_slv11t0_dct_value2	<=	"011111011000";
--			sig_slv11t0_dct_value3	<=	"011101100100";
--			sig_slv11t0_dct_value4	<=	"011010100110";
--			sig_slv11t0_dct_value5	<=	"010110101000";
--			sig_slv11t0_dct_value6	<=	"010001110001";
--			sig_slv11t0_dct_value7	<=	"001100001111";
--			sig_slv11t0_dct_value8	<=	"000110001111";
--			sig_sl_dct_value1_flag	<=	'0';
--			sig_sl_dct_value2_flag	<=	'1';
--			sig_sl_dct_value3_flag	<=	'0';
--			sig_sl_dct_value4_flag	<=	'1';
--			sig_sl_dct_value5_flag	<=	'0';
--			sig_sl_dct_value6_flag	<=	'1';
--			sig_sl_dct_value7_flag	<=	'0';
--			sig_sl_dct_value8_flag	<=	'1';
--		end if;
--	end if;
--end process;


--IDCŤŒlvZʕ\(ľܓ)
process(I_SL_CLK)
begin
	if(I_SL_CLK'event and I_SL_CLK='1')then
		if(sig_slv2t0_count="000")then
			sig_slv11t0_idct_value1	<=	"010110101000";
			sig_slv11t0_idct_value2	<=	"010110101000";
			sig_slv11t0_idct_value3	<=	"010110101000";
			sig_slv11t0_idct_value4	<=	"010110101000";
			sig_slv11t0_idct_value5	<=	"010110101000";
			sig_slv11t0_idct_value6	<=	"010110101000";
			sig_slv11t0_idct_value7	<=	"010110101000";
			sig_slv11t0_idct_value8	<=	"010110101000";
			sig_sl_idct_value1_flag	<=	'0';
			sig_sl_idct_value2_flag	<=	'0';
			sig_sl_idct_value3_flag	<=	'0';
			sig_sl_idct_value4_flag	<=	'0';
			sig_sl_idct_value5_flag	<=	'0';
			sig_sl_idct_value6_flag	<=	'0';
			sig_sl_idct_value7_flag	<=	'0';
			sig_sl_idct_value8_flag	<=	'0';
		elsif(sig_slv2t0_count="001")then
			sig_slv11t0_idct_value1	<=	"011111011001";
			sig_slv11t0_idct_value2	<=	"011010100111";
			sig_slv11t0_idct_value3	<=	"010001110010";
			sig_slv11t0_idct_value4	<=	"000110010000";
			sig_slv11t0_idct_value5	<=	"000110010000";
			sig_slv11t0_idct_value6	<=	"010001110010";
			sig_slv11t0_idct_value7	<=	"011010100111";
			sig_slv11t0_idct_value8	<=	"011111011001";
			sig_sl_idct_value1_flag	<=	'0';
			sig_sl_idct_value2_flag	<=	'0';
			sig_sl_idct_value3_flag	<=	'0';
			sig_sl_idct_value4_flag	<=	'0';
			sig_sl_idct_value5_flag	<=	'1';
			sig_sl_idct_value6_flag	<=	'1';
			sig_sl_idct_value7_flag	<=	'1';
			sig_sl_idct_value8_flag	<=	'1';
		elsif(sig_slv2t0_count="010")then
			sig_slv11t0_idct_value1	<=	"011101100100";
			sig_slv11t0_idct_value2	<=	"001100010000";
			sig_slv11t0_idct_value3	<=	"001100010000";
			sig_slv11t0_idct_value4	<=	"011101100100";
			sig_slv11t0_idct_value5	<=	"011101100100";
			sig_slv11t0_idct_value6	<=	"001100010000";
			sig_slv11t0_idct_value7	<=	"001100010000";
			sig_slv11t0_idct_value8	<=	"011101100100";
			sig_sl_idct_value1_flag	<=	'0';
			sig_sl_idct_value2_flag	<=	'0';
			sig_sl_idct_value3_flag	<=	'1';
			sig_sl_idct_value4_flag	<=	'1';
			sig_sl_idct_value5_flag	<=	'1';
			sig_sl_idct_value6_flag	<=	'1';
			sig_sl_idct_value7_flag	<=	'0';
			sig_sl_idct_value8_flag	<=	'0';
		elsif(sig_slv2t0_count="011")then
			sig_slv11t0_idct_value1	<=	"011010100111";
			sig_slv11t0_idct_value2	<=	"000110010000";
			sig_slv11t0_idct_value3	<=	"011111011001";
			sig_slv11t0_idct_value4	<=	"010001110010";
			sig_slv11t0_idct_value5	<=	"010001110010";
			sig_slv11t0_idct_value6	<=	"011111011001";
			sig_slv11t0_idct_value7	<=	"000110010000";
			sig_slv11t0_idct_value8	<=	"011010100111";
			sig_sl_idct_value1_flag	<=	'0';
			sig_sl_idct_value2_flag	<=	'1';
			sig_sl_idct_value3_flag	<=	'1';
			sig_sl_idct_value4_flag	<=	'1';
			sig_sl_idct_value5_flag	<=	'0';
			sig_sl_idct_value6_flag	<=	'0';
			sig_sl_idct_value7_flag	<=	'0';
			sig_sl_idct_value8_flag	<=	'1';
			elsif(sig_slv2t0_count="100")then
			sig_slv11t0_idct_value1	<=	"010110101000";
			sig_slv11t0_idct_value2	<=	"010110101000";
			sig_slv11t0_idct_value3	<=	"010110101000";
			sig_slv11t0_idct_value4	<=	"010110101000";
			sig_slv11t0_idct_value5	<=	"010110101000";
			sig_slv11t0_idct_value6	<=	"010110101000";
			sig_slv11t0_idct_value7	<=	"010110101000";
			sig_slv11t0_idct_value8	<=	"010110101000";
			sig_sl_idct_value1_flag	<=	'0';
			sig_sl_idct_value2_flag	<=	'1';
			sig_sl_idct_value3_flag	<=	'1';
			sig_sl_idct_value4_flag	<=	'0';
			sig_sl_idct_value5_flag	<=	'0';
			sig_sl_idct_value6_flag	<=	'1';
			sig_sl_idct_value7_flag	<=	'1';
			sig_sl_idct_value8_flag	<=	'0';
		elsif(sig_slv2t0_count="101")then--
			sig_slv11t0_idct_value1	<=	"010001110010";
			sig_slv11t0_idct_value2	<=	"011111011001";
			sig_slv11t0_idct_value3	<=	"000110010000";
			sig_slv11t0_idct_value4	<=	"011010100111";
			sig_slv11t0_idct_value5	<=	"011010100111";
			sig_slv11t0_idct_value6	<=	"000110010000";
			sig_slv11t0_idct_value7	<=	"011111011001";
			sig_slv11t0_idct_value8	<=	"010001110010";
			sig_sl_idct_value1_flag	<=	'0';
			sig_sl_idct_value2_flag	<=	'1';
			sig_sl_idct_value3_flag	<=	'0';
			sig_sl_idct_value4_flag	<=	'0';
			sig_sl_idct_value5_flag	<=	'1';
			sig_sl_idct_value6_flag	<=	'1';
			sig_sl_idct_value7_flag	<=	'0';
			sig_sl_idct_value8_flag	<=	'1';
		elsif(sig_slv2t0_count="110")then
			sig_slv11t0_idct_value1	<=	"001100010000";
			sig_slv11t0_idct_value2	<=	"011101100100";
			sig_slv11t0_idct_value3	<=	"011101100100";
			sig_slv11t0_idct_value4	<=	"001100010000";
			sig_slv11t0_idct_value5	<=	"001100010000";
			sig_slv11t0_idct_value6	<=	"011101100100";
			sig_slv11t0_idct_value7	<=	"011101100100";
			sig_slv11t0_idct_value8	<=	"001100010000";
			sig_sl_idct_value1_flag	<=	'0';
			sig_sl_idct_value2_flag	<=	'1';
			sig_sl_idct_value3_flag	<=	'0';
			sig_sl_idct_value4_flag	<=	'1';
			sig_sl_idct_value5_flag	<=	'1';
			sig_sl_idct_value6_flag	<=	'0';
			sig_sl_idct_value7_flag	<=	'1';
			sig_sl_idct_value8_flag	<=	'0';
		elsif(sig_slv2t0_count="111")then
			sig_slv11t0_idct_value1	<=	"000110010000";
			sig_slv11t0_idct_value2	<=	"010001110010";
			sig_slv11t0_idct_value3	<=	"011010100111";
			sig_slv11t0_idct_value4	<=	"011111011001";
			sig_slv11t0_idct_value5	<=	"011111011001";
			sig_slv11t0_idct_value6	<=	"011010100111";
			sig_slv11t0_idct_value7	<=	"010001110010";
			sig_slv11t0_idct_value8	<=	"000110010000";
			sig_sl_idct_value1_flag	<=	'0';
			sig_sl_idct_value2_flag	<=	'1';
			sig_sl_idct_value3_flag	<=	'0';
			sig_sl_idct_value4_flag	<=	'1';
			sig_sl_idct_value5_flag	<=	'0';
			sig_sl_idct_value6_flag	<=	'1';
			sig_sl_idct_value7_flag	<=	'0';
			sig_sl_idct_value8_flag	<=	'1';
		end if;
	end if;
end process;


process(I_SL_CLK)
begin
	if(I_SL_CLK'event and I_SL_CLK='1')then
		sig_slv2t0_count_d01	<=	sig_slv2t0_count;
		sig_slv2t0_count_d02	<=	sig_slv2t0_count_d01;
		sig_slv2t0_count_d03	<=	sig_slv2t0_count_d02;
		sig_slv2t0_count_d04	<=	sig_slv2t0_count_d03;
		sig_slv2t0_count_d05	<=	sig_slv2t0_count_d04;
		sig_slv2t0_count_d06	<=	sig_slv2t0_count_d05;
		sig_slv2t0_count_d07	<=	sig_slv2t0_count_d06;
		sig_slv2t0_count_d08	<=	sig_slv2t0_count_d07;
		sig_slv2t0_count_d09	<=	sig_slv2t0_count_d08;
		sig_slv2t0_count_d10	<=	sig_slv2t0_count_d09;
		sig_slv2t0_count_d11	<=	sig_slv2t0_count_d10;
		sig_slv2t0_count_d12	<=	sig_slv2t0_count_d11;
		sig_slv2t0_count_d13	<=	sig_slv2t0_count_d12;
		sig_slv2t0_count_d14	<=	sig_slv2t0_count_d13;
		sig_slv2t0_count_d15	<=	sig_slv2t0_count_d14;
		sig_slv2t0_count_d16	<=	sig_slv2t0_count_d15;
		sig_slv2t0_count_d17	<=	sig_slv2t0_count_d16;
	end if;                                      
end process;

-------------------------------------------------------------------------

	point1	:	IDCT_POINT1	port map(
			I_SL_CLK					=>	I_SL_CLK,
			I_SLV11T0_DATA			=>	sig_slv11t0_data,
			I_SLV11T0_IDCT_VALUE	=>	sig_slv11t0_idct_value1,
			I_SL_IDCT_VALUE_FLAG	=>	sig_sl_idct_value1_flag,
			O_SLV11T0_DATA			=>	sig_slv11t0_idct_point1_1
	);
	point2	:	IDCT_POINT1	port map(
			I_SL_CLK					=>	I_SL_CLK,
			I_SLV11T0_DATA			=>	sig_slv11t0_data,
			I_SLV11T0_IDCT_VALUE	=>	sig_slv11t0_idct_value2,
			I_SL_IDCT_VALUE_FLAG	=>	sig_sl_idct_value2_flag,
			O_SLV11T0_DATA			=>	sig_slv11t0_idct_point2_1
	);    
	point3	:	IDCT_POINT1	port map(
			I_SL_CLK					=>	I_SL_CLK,
			I_SLV11T0_DATA			=>	sig_slv11t0_data,
			I_SLV11T0_IDCT_VALUE	=>	sig_slv11t0_idct_value3,
			I_SL_IDCT_VALUE_FLAG	=>	sig_sl_idct_value3_flag,
			O_SLV11T0_DATA			=>	sig_slv11t0_idct_point3_1
	);    
	point4	:	IDCT_POINT1	port map(
			I_SL_CLK					=>	I_SL_CLK,
			I_SLV11T0_DATA			=>	sig_slv11t0_data,
			I_SLV11T0_IDCT_VALUE	=>	sig_slv11t0_idct_value4,
			I_SL_IDCT_VALUE_FLAG	=>	sig_sl_idct_value4_flag,
			O_SLV11T0_DATA			=>	sig_slv11t0_idct_point4_1
	);	   
	point5	:	IDCT_POINT1	port map(
			I_SL_CLK					=>	I_SL_CLK,
			I_SLV11T0_DATA			=>	sig_slv11t0_data,
			I_SLV11T0_IDCT_VALUE	=>	sig_slv11t0_idct_value5,
			I_SL_IDCT_VALUE_FLAG	=>	sig_sl_idct_value5_flag,
			O_SLV11T0_DATA			=>	sig_slv11t0_idct_point5_1
	);    
	point6	:	IDCT_POINT1	port map(
			I_SL_CLK					=>	I_SL_CLK,
			I_SLV11T0_DATA			=>	sig_slv11t0_data,
			I_SLV11T0_IDCT_VALUE	=>	sig_slv11t0_idct_value6,
			I_SL_IDCT_VALUE_FLAG	=>	sig_sl_idct_value6_flag,
			O_SLV11T0_DATA			=>	sig_slv11t0_idct_point6_1
	);    
	point7	:	IDCT_POINT1	port map(
			I_SL_CLK					=>	I_SL_CLK,
			I_SLV11T0_DATA			=>	sig_slv11t0_data,
			I_SLV11T0_IDCT_VALUE	=>	sig_slv11t0_idct_value7,
			I_SL_IDCT_VALUE_FLAG	=>	sig_sl_idct_value7_flag,
			O_SLV11T0_DATA			=>	sig_slv11t0_idct_point7_1
	);    
	point8	:	IDCT_POINT1	port map(
			I_SL_CLK					=>	I_SL_CLK,
			I_SLV11T0_DATA			=>	sig_slv11t0_data,
			I_SLV11T0_IDCT_VALUE	=>	sig_slv11t0_idct_value8,
			I_SL_IDCT_VALUE_FLAG	=>	sig_sl_idct_value8_flag,
			O_SLV11T0_DATA			=>	sig_slv11t0_idct_point8_1
	);	   

-------------------------------------------------------------------------
--M^C~O悭EĂB
--8_oĂ̂ŁEEEB
process(I_SL_CLK)
begin
	if(I_SL_CLK'event and I_SL_CLK='1')then
		sig_slv11t0_idct_point2_2	<=	sig_slv11t0_idct_point2_1;
	end if;
end process;
process(I_SL_CLK)
begin
	if(I_SL_CLK'event and I_SL_CLK='1')then
		sig_slv11t0_idct_point3_2	<=	sig_slv11t0_idct_point3_1;
		sig_slv11t0_idct_point3_3	<=	sig_slv11t0_idct_point3_2;
	end if;
end process;
process(I_SL_CLK)
begin
	if(I_SL_CLK'event and I_SL_CLK='1')then
		sig_slv11t0_idct_point4_2	<=	sig_slv11t0_idct_point4_1;
		sig_slv11t0_idct_point4_3	<=	sig_slv11t0_idct_point4_2;
		sig_slv11t0_idct_point4_4	<=	sig_slv11t0_idct_point4_3;
	end if;
end process;
process(I_SL_CLK)
begin
	if(I_SL_CLK'event and I_SL_CLK='1')then
		sig_slv11t0_idct_point5_2	<=	sig_slv11t0_idct_point5_1;
		sig_slv11t0_idct_point5_3	<=	sig_slv11t0_idct_point5_2;
		sig_slv11t0_idct_point5_4	<=	sig_slv11t0_idct_point5_3;
		sig_slv11t0_idct_point5_5	<=	sig_slv11t0_idct_point5_4;
	end if;
end process;
process(I_SL_CLK)
begin
	if(I_SL_CLK'event and I_SL_CLK='1')then
		sig_slv11t0_idct_point6_2	<=	sig_slv11t0_idct_point6_1;
		sig_slv11t0_idct_point6_3	<=	sig_slv11t0_idct_point6_2;
		sig_slv11t0_idct_point6_4	<=	sig_slv11t0_idct_point6_3;
		sig_slv11t0_idct_point6_5	<=	sig_slv11t0_idct_point6_4;
		sig_slv11t0_idct_point6_6	<=	sig_slv11t0_idct_point6_5;
	end if;
end process;
process(I_SL_CLK)
begin
	if(I_SL_CLK'event and I_SL_CLK='1')then
		sig_slv11t0_idct_point7_2	<=	sig_slv11t0_idct_point7_1;
		sig_slv11t0_idct_point7_3	<=	sig_slv11t0_idct_point7_2;
		sig_slv11t0_idct_point7_4	<=	sig_slv11t0_idct_point7_3;
		sig_slv11t0_idct_point7_5	<=	sig_slv11t0_idct_point7_4;
		sig_slv11t0_idct_point7_6	<=	sig_slv11t0_idct_point7_5;
		sig_slv11t0_idct_point7_7	<=	sig_slv11t0_idct_point7_6;
	end if;
end process;
process(I_SL_CLK)
begin
	if(I_SL_CLK'event and I_SL_CLK='1')then
		sig_slv11t0_idct_point8_2	<=	sig_slv11t0_idct_point8_1;
		sig_slv11t0_idct_point8_3	<=	sig_slv11t0_idct_point8_2;
		sig_slv11t0_idct_point8_4	<=	sig_slv11t0_idct_point8_3;
		sig_slv11t0_idct_point8_5	<=	sig_slv11t0_idct_point8_4;
		sig_slv11t0_idct_point8_6	<=	sig_slv11t0_idct_point8_5;
		sig_slv11t0_idct_point8_7	<=	sig_slv11t0_idct_point8_6;
		sig_slv11t0_idct_point8_8	<=	sig_slv11t0_idct_point8_7;
	end if;
end process;

process(I_SL_CLK)
begin
	if(I_SL_CLK'event and I_SL_CLK='1')then
		if(sig_slv2t0_count_d17="000")then
			O_SLV11T0_DATA	<=	sig_slv11t0_idct_point1_1;
		elsif(sig_slv2t0_count_d17="001")then
			O_SLV11T0_DATA	<=	sig_slv11t0_idct_point2_2;
		elsif(sig_slv2t0_count_d17="010")then
			O_SLV11T0_DATA	<=	sig_slv11t0_idct_point3_3;
		elsif(sig_slv2t0_count_d17="011")then
			O_SLV11T0_DATA	<=	sig_slv11t0_idct_point4_4;
		elsif(sig_slv2t0_count_d17="100")then
			O_SLV11T0_DATA	<=	sig_slv11t0_idct_point5_5;
		elsif(sig_slv2t0_count_d17="101")then
			O_SLV11T0_DATA	<=	sig_slv11t0_idct_point6_6;
		elsif(sig_slv2t0_count_d17="110")then
			O_SLV11T0_DATA	<=	sig_slv11t0_idct_point7_7;
		elsif(sig_slv2t0_count_d17="111")then
			O_SLV11T0_DATA	<=	sig_slv11t0_idct_point8_8;
		end if;
	end if;
end process;

end Behavioral;