----------------------------------------------------------------------------------
-- Company: Kanagawa Institute of Technology
-- Engineer: Takuya Katayama
--
-- ʎqH(QUANTIZATION_PROCESS.vhd)
-- Revision: 1.0
--
-- Revision 1.0 - 2010/04/13 łJ܂
--
-- memo
-- ̃W[͗ʎqe[uɏ]ē͒l̗ʎqs܂
-- pCvC1CLKł܂
-- ́Ao͂Ƃ12bitUNSIGNED^ł
--@ʎq̓X^[gM1CLKĂĂ΁ACLK̓̓f[^ʎqJn܂
--
--
-- ԁ@F 5 clk   ς邱ƁEtʎqp
--
-- gݍ݃ubN
-- DIVIDER_PROCESS_12BIT_8BIT.vhd		ZsubN
-- QUANTIZATION_VALUE.vhd					ʎqe[ȕo̓ubN
--
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

---- Uncomment the following library declaration if instantiating
---- any Xilinx primitives in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity IQUANTIZATION_PROCESS is
port(	
		I_SL_CLK					:	in		std_logic;								--NbNM
		I_SL_RESET				:	in		std_logic;								--ZbgM(0FZbg@1Fʏ)
		I_SL_START				:	in		std_logic;								--ʎqJnM(0FOFF@1FON)
		I_SLV11T0_DATA			:	in		std_logic_vector(11 downto 0);	--͐M(UNSIGNED^12bitŕ\\Ȑ)
		I_SLV11T0_Q_FACTOR	:	in		std_logic_vector(11 downto 0);
		O_SLV11T0_DATA			:	out	std_logic_vector(11 downto 0)		--o͐M(UNSIGNED^12bitŕ\\Ȑ)
);
end IQUANTIZATION_PROCESS;

architecture Behavioral of IQUANTIZATION_PROCESS is

component	MULT8_12_mk2
	port(
			I_SL_CLK				:	in		std_logic;
			I_SLV7T0_INPUT_A	:	in		std_logic_vector(7 downto 0);
			I_SLV11T0_INPUT_B	:	in		std_logic_vector(11 downto 0);
			O_SLV19T0_RESULT	:	out	std_logic_vector(19 downto 0)
	);
end component;

signal	sig_sl_signed_flag			:	std_logic;
signal	sig_sl_signed_flag_01c_dff	:	std_logic;
signal	sig_sl_signed_flag_02c_dff	:	std_logic;
signal	sig_sl_signed_flag_03c_dff	:	std_logic;
signal	sig_sl_signed_flag_04c_dff	:	std_logic;

component	IQUANTIZATION_VALUE
port(
		I_SL_CLK			:	in		std_logic;
		I_SL_RESET		:	in		std_logic;
		I_SL_START		:	in		std_logic;
		O_SLV7T0_DATA	:	out	std_logic_vector(7 downto 0)
);
end component;

signal	sig_slv19t0_mult		:	std_logic_vector(19 downto 0);
signal	sig_slv19t0_result		:	std_logic_vector(19 downto 0);
signal	sig_slv11t0_data_1c_dff	:	std_logic_vector(11 downto 0);
signal	sig_slv11t0_data_2c_dff	:	std_logic_vector(11 downto 0);
signal	sig_slv11t0_data_3c_dff	:	std_logic_vector(11 downto 0);
signal	sig_slv11t0_data_4c_dff	:	std_logic_vector(11 downto 0);
signal	sig_slv11t0_data_5c_dff	:	std_logic_vector(11 downto 0);
signal	sig_slv11t0_data_6c_dff	:	std_logic_vector(11 downto 0);
signal	sig_slv11t0_in_data	:	std_logic_vector(11 downto 0);
signal	sig_slv19t0_out_data	:	std_logic_vector(19 downto 0);
signal	sig_slv7t0_iquantization_value	:	std_logic_vector(7 downto 0);

begin

	u1	:	IQUANTIZATION_VALUE	port map(
		I_SL_CLK					=>	I_SL_CLK,
		I_SL_RESET				=>	I_SL_RESET,
		I_SL_START				=>	I_SL_START,
		O_SLV7T0_DATA			=>	sig_slv7t0_iquantization_value
	);

	u2	:	MULT8_12_mk2 port map(
		I_SL_CLK				=>	I_SL_CLK,
	   I_SLV7T0_INPUT_A	=>	sig_slv7t0_iquantization_value,
      I_SLV11T0_INPUT_B	=>	I_SLV11T0_Q_FACTOR,
      O_SLV19T0_RESULT	=>	sig_slv19t0_result
	);

process(I_SL_CLK)
begin
	if(I_SL_CLK'event and I_SL_CLK='1')then
		if(sig_slv19t0_result="00000000000000000000")then
			sig_slv19t0_mult	<=	"00000000010000000000";
		else
			sig_slv19t0_mult	<=	sig_slv19t0_result;
		end if;
	end if;
end process;


--Z4CLǨvZx{P
process(I_SL_CLK)
begin
	if(I_SL_CLK'event and I_SL_CLK='1')then
		sig_slv11t0_data_1c_dff	<=	I_SLV11T0_DATA;
		sig_slv11t0_data_2c_dff	<=	sig_slv11t0_data_1c_dff;
		sig_slv11t0_data_3c_dff	<=	sig_slv11t0_data_2c_dff;
		sig_slv11t0_data_4c_dff	<=	sig_slv11t0_data_3c_dff;
		sig_slv11t0_data_5c_dff	<=	sig_slv11t0_data_4c_dff;
		sig_slv11t0_data_6c_dff	<=	sig_slv11t0_data_5c_dff;
	end if;
end process;

--ʎqf[^̓ǂݍݏ̒x@}CiX̒l̏ꍇ̏FxlɂȂ
process(I_SL_CLK)
begin
	if(I_SL_CLK'event and I_SL_CLK='1')then
		if(sig_slv11t0_data_6c_dff(11)='0')then
			sig_slv11t0_in_data	<=	sig_slv11t0_data_6c_dff;
			sig_sl_signed_flag	<=	'0';
		else
			sig_slv11t0_in_data	<=	(not	sig_slv11t0_data_6c_dff)	+	1;
			sig_sl_signed_flag	<=	'1';
		end if;
	end if;
end process;


	u3	:	MULT8_12_mk2 port map(
		I_SL_CLK				=>	I_SL_CLK,
	   I_SLV7T0_INPUT_A	=>	sig_slv19t0_mult(17 downto 10),
      I_SLV11T0_INPUT_B	=>	sig_slv11t0_in_data,
      O_SLV19T0_RESULT	=>	sig_slv19t0_out_data
	);

process(I_SL_CLK)
begin
	if(I_SL_CLK'event and I_SL_CLK='1')then
		sig_sl_signed_flag_01c_dff	<=	sig_sl_signed_flag;
		sig_sl_signed_flag_02c_dff	<=	sig_sl_signed_flag_01c_dff;
		sig_sl_signed_flag_03c_dff	<=	sig_sl_signed_flag_02c_dff;
		sig_sl_signed_flag_04c_dff	<=	sig_sl_signed_flag_03c_dff;
	end if;                                        
end process;

--tO畄𔻒fA}CiX̒l̏ꍇ2̕␔ɂǂ
process(I_SL_CLK)
begin
	if(I_SL_CLK'event and I_SL_CLK='1')then
		if(sig_sl_signed_flag_04c_dff='0')then
			O_SLV11T0_DATA	<=	sig_slv19t0_out_data(11 downto 0);
		else
			O_SLV11T0_DATA		<=	(not	sig_slv19t0_out_data(11 downto 0))	+	1;
		end if;
	end if;
end process;

end Behavioral;