----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date:    22:19:10 07/22/2010 
-- Design Name: 
-- Module Name:    JPEG_DECODER - Behavioral 
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

---- Uncomment the following library declaration if instantiating
---- any Xilinx primitives in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity JPEG_DECODER is
	port(
		I_SL_CLK						:	in		std_logic;
		I_SL_RST						:	in		std_logic;
		I_SL_FLAME_ENABLE			:	in		std_logic;
		I_SL_BLOCK_START			:	in		std_logic;
		I_SLV11T0_DATA				:	in		std_logic_vector(11 downto 0);
		I_SLV11T0_Q_FACTOR		:	in		std_logic_vector(11 downto 0);
		I_SLV11T0_H_RESOLUTION	:	in		std_logic_vector(11 downto 0);
		I_SLV11T0_V_RESOLUTION	:	in		std_logic_vector(11 downto 0);
		I_SL_VSYNC					:	in		std_logic;
		I_SL_HSYNC					:	in		std_logic;
		I_SL_DE						:	in		std_logic;
		I_SL_VSYNC_8L_DFF			:	in		std_logic;
		I_SL_HSYNC_8L_DFF			:	in		std_logic;
		I_SL_DE_8L_DFF				:	in		std_logic;
		O_SLV7T0_DATA				:	out	std_logic_vector(7 downto 0)
	);
end JPEG_DECODER;

architecture Behavioral of JPEG_DECODER is
----------------------------------------------------------------------
--ZIGZAGWRITEubN----------------------------------------------------
----------------------------------------------------------------------
signal	sig_sl_block_start_zigzagwrite_process_processed					:	std_logic;
signal	sig_slv11t0_data_zigzagwrite_process_processed						:	std_logic_vector(11 downto 0);

component ZIGZAGWRITE_PROCESS
port(	
		I_SL_CLK			:	in		std_logic;
		I_SL_RST			:	in		std_logic;
		I_SL_START		:	in		std_logic;
		I_SLV11T0_DATA	:	in		std_logic_vector(11 downto 0);
		O_SL_START		:	out	std_logic;
		O_SLV11T0_DATA	:	out	std_logic_vector(11 downto 0)
);
end component;
----------------------------------------------------------------------
--tʎqubN---------------------------------------------------------
----------------------------------------------------------------------
signal	sig_slv11t0_data_01c_dff													:	std_logic_vector(11 downto 0);
signal	sig_sl_block_start_iquantization_process_processed					:	std_logic;
signal	sig_sl_block_start_iquantization_process_processed_01c_dff		:	std_logic;
signal	sig_sl_block_start_iquantization_process_processed_02c_dff		:	std_logic;
signal	sig_sl_block_start_iquantization_process_processed_03c_dff		:	std_logic;
signal	sig_sl_block_start_iquantization_process_processed_04c_dff		:	std_logic;
signal	sig_sl_block_start_iquantization_process_processed_05c_dff		:	std_logic;
signal	sig_sl_block_start_iquantization_process_processed_06c_dff		:	std_logic;
signal	sig_sl_block_start_iquantization_process_processed_07c_dff		:	std_logic;
signal	sig_sl_block_start_iquantization_process_processed_08c_dff		:	std_logic;
signal	sig_sl_block_start_iquantization_process_processed_09c_dff		:	std_logic;
signal	sig_sl_block_start_iquantization_process_processed_10c_dff		:	std_logic;
signal	sig_sl_block_start_iquantization_process_processed_11c_dff		:	std_logic;
signal	sig_slv11t0_data_iquantization_process_processed					:	std_logic_vector(11 downto 0);

component IQUANTIZATION_PROCESS
	port(	
		I_SL_CLK			:	in		std_logic;
		I_SL_RESET		:	in		std_logic;
		I_SL_START		:	in		std_logic;
		I_SLV11T0_DATA	:	in		std_logic_vector(11 downto 0);
		I_SLV11T0_Q_FACTOR		:	in		std_logic_vector(11 downto 0);
		O_SLV11T0_DATA	:	out	std_logic_vector(11 downto 0)
	);
end component;
----------------------------------------------------------------------
--IDCTubN-----------------------------------------------------------
----------------------------------------------------------------------
signal	sig_sl_block_start_idct_processed	:	std_logic;
signal	sig_slv7t0_data_idct_processed		:	std_logic_vector(7 downto 0);

component IDCT_PROCESS
	port(	
		I_SL_CLK			:	in		std_logic;
		I_SL_RESET		:	in		std_logic;
		I_SL_START		:	in		std_logic;
		I_SLV11T0_DATA	:	in		std_logic_vector(11 downto 0);
		O_SL_START		:	out	std_logic;	
		O_SLV7T0_DATA	:	out	std_logic_vector(7 downto 0)
	);
end component;
----------------------------------------------------------------------
--8~8ubN---------------------------------------------------------
----------------------------------------------------------------------
component BLOCK_CONNECTOR_PROCESS
	port(
		I_SL_CLK						:	in		std_logic;
		I_SL_RST						:	in		std_logic;
		I_SL_FLAME_ENABLE			:	in		std_logic;
		I_SL_BLOCK_START			:	in		std_logic;
		I_SLV7T0_DATA				:	in		std_logic_vector(7 downto 0);
		I_SLV11T0_H_RESOLUTION	:	in		std_logic_vector(11 downto 0);
		I_SLV11T0_V_RESOLUTION	:	in		std_logic_vector(11 downto 0);
		I_SL_VSYNC					:	in		std_logic;
		I_SL_HSYNC					:	in		std_logic;
		I_SL_DE						:	in		std_logic;
		I_SL_VSYNC_8L_DFF			:	in		std_logic;
		I_SL_HSYNC_8L_DFF			:	in		std_logic;
		I_SL_DE_8L_DFF				:	in		std_logic;
		O_SLV7T0_DATA				:	out	std_logic_vector(7 downto 0)
	);
end component;
----------------------------------------------------------------------
----------------------------------------------------------------------
----------------------------------------------------------------------
begin
----------------------------------------------------------------------
--ZIGZAGWRITEubN--65clk----------------------------------------------
----------------------------------------------------------------------
    uut1_1: ZIGZAGWRITE_PROCESS PORT MAP (
			I_SL_CLK					=>	I_SL_CLK,
			I_SL_RST					=>	I_SL_RST,
			I_SL_START				=>	I_SL_BLOCK_START,
			I_SLV11T0_DATA			=>	I_SLV11T0_DATA,
			O_SL_START				=>	sig_sl_block_start_zigzagwrite_process_processed,
			O_SLV11T0_DATA			=>	sig_slv11t0_data_zigzagwrite_process_processed
	);
----------------------------------------------------------------------
--tʎqubN--12clk--------------------------------------------------
----------------------------------------------------------------------
--process(I_SL_CLK)
--begin
--	if(I_SL_CLK'event and I_SL_CLK='1')then
--		sig_slv11t0_data_01c_dff	<=	I_SLV11T0_DATA;
--	end if;                                                                                
--end process;
    uut2_2: IQUANTIZATION_PROCESS PORT MAP (
			I_SL_CLK					=>	I_SL_CLK,
			I_SL_RESET				=>	I_SL_RST,
			I_SL_START				=>	sig_sl_block_start_zigzagwrite_process_processed,
--			I_SLV11T0_DATA			=>	sig_slv11t0_data_01c_dff,
			I_SLV11T0_DATA			=>	sig_slv11t0_data_zigzagwrite_process_processed,
			I_SLV11T0_Q_FACTOR	=>	I_SLV11T0_Q_FACTOR,
			O_SLV11T0_DATA			=>	sig_slv11t0_data_iquantization_process_processed
		);
--bX^[gMx
process(I_SL_CLK)
begin
	if(I_SL_CLK'event and I_SL_CLK='1')then
		sig_sl_block_start_iquantization_process_processed_01c_dff	<=	sig_sl_block_start_zigzagwrite_process_processed;
		sig_sl_block_start_iquantization_process_processed_02c_dff	<=	sig_sl_block_start_iquantization_process_processed_01c_dff;
		sig_sl_block_start_iquantization_process_processed_03c_dff	<=	sig_sl_block_start_iquantization_process_processed_02c_dff;
		sig_sl_block_start_iquantization_process_processed_04c_dff	<=	sig_sl_block_start_iquantization_process_processed_03c_dff;
		sig_sl_block_start_iquantization_process_processed_05c_dff	<=	sig_sl_block_start_iquantization_process_processed_04c_dff;
		sig_sl_block_start_iquantization_process_processed_06c_dff	<=	sig_sl_block_start_iquantization_process_processed_05c_dff;
		sig_sl_block_start_iquantization_process_processed_07c_dff	<=	sig_sl_block_start_iquantization_process_processed_06c_dff;
		sig_sl_block_start_iquantization_process_processed_08c_dff	<=	sig_sl_block_start_iquantization_process_processed_07c_dff;
		sig_sl_block_start_iquantization_process_processed_09c_dff	<=	sig_sl_block_start_iquantization_process_processed_08c_dff;
		sig_sl_block_start_iquantization_process_processed_10c_dff	<=	sig_sl_block_start_iquantization_process_processed_09c_dff;
		sig_sl_block_start_iquantization_process_processed_11c_dff	<=	sig_sl_block_start_iquantization_process_processed_10c_dff;
		sig_sl_block_start_iquantization_process_processed				<=	sig_sl_block_start_iquantization_process_processed_11c_dff;
	end if;                                                                                
end process;
----------------------------------------------------------------------
--IDCTubN--169clk---------------------------------------------------
----------------------------------------------------------------------
    uut2_3: IDCT_PROCESS PORT MAP (
			I_SL_CLK			=>	I_SL_CLK,
			I_SL_RESET		=>	I_SL_RST,	
			I_SL_START		=>	sig_sl_block_start_iquantization_process_processed,
			I_SLV11T0_DATA	=>	sig_slv11t0_data_iquantization_process_processed,
			O_SL_START		=>	sig_sl_block_start_idct_processed,
			O_SLV7T0_DATA	=>	sig_slv7t0_data_idct_processed
		);
----------------------------------------------------------------------
--8~8ubN---------------------------------------------------------
----------------------------------------------------------------------
   uut2_4: BLOCK_CONNECTOR_PROCESS PORT MAP (
          I_SL_CLK					=> I_SL_CLK,
          I_SL_RST					=> I_SL_RST,
          I_SL_FLAME_ENABLE		=> I_SL_FLAME_ENABLE,
          I_SL_BLOCK_START			=> sig_sl_block_start_idct_processed,
          I_SLV7T0_DATA				=> sig_slv7t0_data_idct_processed,
--          I_SLV11T0_H_RESOLUTION	=> I_SLV11T0_H_RESOLUTION,
--          I_SLV11T0_V_RESOLUTION	=> I_SLV11T0_V_RESOLUTION,
          I_SLV11T0_H_RESOLUTION	=> "000100000000",--摜TCY256~256ɐ؂o
          I_SLV11T0_V_RESOLUTION	=> "000100000000",--摜TCY256~256ɐ؂o
          I_SL_VSYNC					=> I_SL_VSYNC,--RAM̐؂ւOɓǂݍݎw߂KvA4CLKDFFő傩œKHiœKǂ͗v
          I_SL_HSYNC					=> I_SL_HSYNC,
          I_SL_DE						=> I_SL_DE,
			 I_SL_VSYNC_8L_DFF		=> I_SL_VSYNC_8L_DFF,
			 I_SL_HSYNC_8L_DFF		=> I_SL_HSYNC_8L_DFF,
			 I_SL_DE_8L_DFF			=> I_SL_DE_8L_DFF,
          O_SLV7T0_DATA				=> O_SLV7T0_DATA
        );
----------------------------------------------------------------------
----------------------------------------------------------------------
----------------------------------------------------------------------
end Behavioral;