------------------------------------------------------------
-- Product     : JPEG_ENCODER v1.1                       --
-- Module      : QUANTIZATION_PROCESS v1.1                --
-- Last Update : 2011/04/20                               --
--                                                        --
-- Engineer    : Takuya Katayama                          --
-- Mail        : pajamas@hotmail.co.jp                    --
--                                                        --
-- Copyright (C) 2011 Takuya Katayama All Rights Reserved.--
------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

entity DIVIDER_PROCESS_12BIT_8BIT is
port(
		I_SL_CLK					:	in		std_logic;								--NbNM
		I_SLV11T0_VALUE		:	in		std_logic_vector(11 downto 0);	--鐔(UNSIGNED^12bitŕ\鐔)
		I_SLV7T0_DIVISOR		:	in		std_logic_vector(7 downto 0);		--鐔(UNSIGNED^8bitŕ\鐔)
		O_SLV7T0_REMAINDER	:	out	std_logic_vector(7 downto 0);		--܂(UNSIGNED^12bitŕ\鐔)
		O_SLV11T0_RESULT		:	out	std_logic_vector(11 downto 0)		--vZ(UNSIGNED^12bitŕ\鐔)
);
end DIVIDER_PROCESS_12BIT_8BIT;

architecture Behavioral of DIVIDER_PROCESS_12BIT_8BIT is

--͒liKIێ
signal	sig_slv11t0_value				:	std_logic_vector(11 downto 0);
signal	sig_slv3t0_value				:	std_logic_vector(3 downto 0);
signal	sig_slv2t0_value				:	std_logic_vector(2 downto 0);
signal	sig_slv1t0_value				:	std_logic_vector(1 downto 0);
signal	sig_sl_value					:	std_logic;

--鐔ێ
signal	sig_slv7t0_divisor			:	std_logic_vector(7 downto 0);
signal	sig_slv7t0_divisor_delay01	:	std_logic_vector(7 downto 0);
signal	sig_slv7t0_divisor_delay02	:	std_logic_vector(7 downto 0);
signal	sig_slv7t0_divisor_delay03	:	std_logic_vector(7 downto 0);
signal	sig_slv7t0_divisor_delay04	:	std_logic_vector(7 downto 0);
signal	sig_slv7t0_divisor_delay05	:	std_logic_vector(7 downto 0);
signal	sig_slv7t0_divisor_delay06	:	std_logic_vector(7 downto 0);
signal	sig_slv7t0_divisor_delay07	:	std_logic_vector(7 downto 0);
signal	sig_slv7t0_divisor_delay08	:	std_logic_vector(7 downto 0);
signal	sig_slv7t0_divisor_delay09	:	std_logic_vector(7 downto 0);
signal	sig_slv7t0_divisor_delay10	:	std_logic_vector(7 downto 0);
signal	sig_slv7t0_divisor_delay11	:	std_logic_vector(7 downto 0);

--͂ŌvẐA1bitʂۑ邽߁Aʂ̕ێ1Ă
signal	sig_sl_q12						:	std_logic;
signal	sig_slv1t0_q12_11				:	std_logic_vector(1 downto 0);
signal	sig_slv2t0_q12_10				:	std_logic_vector(2 downto 0);
signal	sig_slv3t0_q12_9				:	std_logic_vector(3 downto 0);
signal	sig_slv4t0_q12_8				:	std_logic_vector(4 downto 0);
signal	sig_slv5t0_q12_7				:	std_logic_vector(5 downto 0);
signal	sig_slv6t0_q12_6				:	std_logic_vector(6 downto 0);
signal	sig_slv7t0_q12_5				:	std_logic_vector(7 downto 0);
signal	sig_slv8t0_q12_4				:	std_logic_vector(8 downto 0);
signal	sig_slv9t0_q12_3				:	std_logic_vector(9 downto 0);
signal	sig_slv10t0_q12_2				:	std_logic_vector(10 downto 0);
signal	sig_slv11t0_q12_1				:	std_logic_vector(11 downto 0);

--rvZŎgl(̌̌vZ܂łsۂ̗]lĂ)
signal	sig_slv7t0_r12					:	std_logic_vector(7 downto 0);
signal	sig_slv8t0_r11					:	std_logic_vector(8 downto 0);
signal	sig_slv9t0_r10					:	std_logic_vector(9 downto 0);
signal	sig_slv10t0_r9					:	std_logic_vector(10 downto 0);
signal	sig_slv11t0_r8					:	std_logic_vector(11 downto 0);
signal	sig_slv12t0_r7					:	std_logic_vector(12 downto 0);
signal	sig_slv13t0_r6					:	std_logic_vector(13 downto 0);
signal	sig_slv14t0_r5					:	std_logic_vector(14 downto 0);
signal	sig_slv15t0_r4					:	std_logic_vector(15 downto 0);
signal	sig_slv16t0_r3					:	std_logic_vector(16 downto 0);
signal	sig_slv17t0_r2					:	std_logic_vector(17 downto 0);
signal	sig_slv18t0_r1					:	std_logic_vector(18 downto 0);

--]l̒xM
signal	sig_slv7t0_r8_delay01		:	std_logic_vector(7 downto 0);
signal	sig_slv7t0_r8_delay02		:	std_logic_vector(7 downto 0);
signal	sig_slv7t0_r8_delay03		:	std_logic_vector(7 downto 0);
signal	sig_slv7t0_r8_delay04		:	std_logic_vector(7 downto 0);
signal	sig_slv7t0_r8_delay05		:	std_logic_vector(7 downto 0);
signal	sig_slv7t0_r8_delay06		:	std_logic_vector(7 downto 0);
signal	sig_slv7t0_r8_delay07		:	std_logic_vector(7 downto 0);

signal	sig_slv7t0_r7_delay01		:	std_logic_vector(7 downto 0);
signal	sig_slv7t0_r7_delay02		:	std_logic_vector(7 downto 0);
signal	sig_slv7t0_r7_delay03		:	std_logic_vector(7 downto 0);
signal	sig_slv7t0_r7_delay04		:	std_logic_vector(7 downto 0);
signal	sig_slv7t0_r7_delay05		:	std_logic_vector(7 downto 0);
signal	sig_slv7t0_r7_delay06		:	std_logic_vector(7 downto 0);

signal	sig_slv7t0_r6_delay01		:	std_logic_vector(7 downto 0);
signal	sig_slv7t0_r6_delay02		:	std_logic_vector(7 downto 0);
signal	sig_slv7t0_r6_delay03		:	std_logic_vector(7 downto 0);
signal	sig_slv7t0_r6_delay04		:	std_logic_vector(7 downto 0);
signal	sig_slv7t0_r6_delay05		:	std_logic_vector(7 downto 0);

signal	sig_slv7t0_r5_delay01		:	std_logic_vector(7 downto 0);
signal	sig_slv7t0_r5_delay02		:	std_logic_vector(7 downto 0);
signal	sig_slv7t0_r5_delay03		:	std_logic_vector(7 downto 0);
signal	sig_slv7t0_r5_delay04		:	std_logic_vector(7 downto 0);

signal	sig_slv7t0_r4_delay01		:	std_logic_vector(7 downto 0);
signal	sig_slv7t0_r4_delay02		:	std_logic_vector(7 downto 0);
signal	sig_slv7t0_r4_delay03		:	std_logic_vector(7 downto 0);

signal	sig_slv7t0_r3_delay01		:	std_logic_vector(7 downto 0);
signal	sig_slv7t0_r3_delay02		:	std_logic_vector(7 downto 0);

signal	sig_slv7t0_r2_delay01		:	std_logic_vector(7 downto 0);

--lɂtOf[^ƒxM
signal	sig_slv3t0_divisor_flag				:	std_logic_vector(3 downto 0);
signal	sig_slv3t0_divisor_flag_delay01	:	std_logic_vector(3 downto 0);
signal	sig_slv3t0_divisor_flag_delay02	:	std_logic_vector(3 downto 0);
signal	sig_slv3t0_divisor_flag_delay03	:	std_logic_vector(3 downto 0);
signal	sig_slv3t0_divisor_flag_delay04	:	std_logic_vector(3 downto 0);
signal	sig_slv3t0_divisor_flag_delay05	:	std_logic_vector(3 downto 0);
signal	sig_slv3t0_divisor_flag_delay06	:	std_logic_vector(3 downto 0);
signal	sig_slv3t0_divisor_flag_delay07	:	std_logic_vector(3 downto 0);
signal	sig_slv3t0_divisor_flag_delay08	:	std_logic_vector(3 downto 0);
signal	sig_slv3t0_divisor_flag_delay09	:	std_logic_vector(3 downto 0);
signal	sig_slv3t0_divisor_flag_delay10	:	std_logic_vector(3 downto 0);
signal	sig_slv3t0_divisor_flag_delay11	:	std_logic_vector(3 downto 0);
signal	sig_slv3t0_divisor_flag_delay12	:	std_logic_vector(3 downto 0);

begin

process(I_SL_CLK)
begin
	if(I_SL_CLK'event and I_SL_CLK='1')then
		sig_slv11t0_value		<=	I_SLV11T0_VALUE;
	end if;
end process;

--͒liKIێ
process(I_SL_CLK)
begin
	if(I_SL_CLK'event and I_SL_CLK='1')then
		if(I_SLV7T0_DIVISOR(7)	=	'1')then
			sig_slv3t0_divisor_flag	<=	"0001";
			sig_slv7t0_divisor		<=	I_SLV7T0_DIVISOR;
		elsif(I_SLV7T0_DIVISOR(6)	=	'1')then
			sig_slv3t0_divisor_flag	<=	"0010";
			sig_slv7t0_divisor		<=	I_SLV7T0_DIVISOR(6 downto 0)	&	'0';
		elsif(I_SLV7T0_DIVISOR(5)	=	'1')then
			sig_slv3t0_divisor_flag	<=	"0011";	
			sig_slv7t0_divisor		<=	I_SLV7T0_DIVISOR(5 downto 0)	&	"00";
		elsif(I_SLV7T0_DIVISOR(4)	=	'1')then
			sig_slv3t0_divisor_flag	<=	"0100";
			sig_slv7t0_divisor		<=	I_SLV7T0_DIVISOR(4 downto 0)	&	"000";
		elsif(I_SLV7T0_DIVISOR(3)	=	'1')then
			sig_slv3t0_divisor_flag	<=	"0101";	
			sig_slv7t0_divisor		<=	I_SLV7T0_DIVISOR(3 downto 0)	&	"0000";
		elsif(I_SLV7T0_DIVISOR(2)	=	'1')then
			sig_slv3t0_divisor_flag	<=	"0110";
			sig_slv7t0_divisor		<=	I_SLV7T0_DIVISOR(2 downto 0)	&	"00000";
		elsif(I_SLV7T0_DIVISOR(1)	=	'1')then
			sig_slv3t0_divisor_flag	<=	"0111";	
			sig_slv7t0_divisor		<=	I_SLV7T0_DIVISOR(1 downto 0)	&	"000000";
		elsif(I_SLV7T0_DIVISOR(0)	=	'1')then
			sig_slv3t0_divisor_flag	<=	"1000";
			sig_slv7t0_divisor		<=	I_SLV7T0_DIVISOR(0)				&	"0000000";
		else
			sig_slv3t0_divisor_flag	<=	"0000";
		end if;
	end if;
end process;

--lɂtOf[^̒x
process(I_SL_CLK)
begin
	if(I_SL_CLK'event and I_SL_CLK='1')then
		sig_slv3t0_divisor_flag_delay01	<=	sig_slv3t0_divisor_flag;
		sig_slv3t0_divisor_flag_delay02	<=	sig_slv3t0_divisor_flag_delay01;
		sig_slv3t0_divisor_flag_delay03	<=	sig_slv3t0_divisor_flag_delay02;
		sig_slv3t0_divisor_flag_delay04	<=	sig_slv3t0_divisor_flag_delay03;
		sig_slv3t0_divisor_flag_delay05	<=	sig_slv3t0_divisor_flag_delay04;
		sig_slv3t0_divisor_flag_delay06	<=	sig_slv3t0_divisor_flag_delay05;
		sig_slv3t0_divisor_flag_delay07	<=	sig_slv3t0_divisor_flag_delay06;
		sig_slv3t0_divisor_flag_delay08	<=	sig_slv3t0_divisor_flag_delay07;
		sig_slv3t0_divisor_flag_delay09	<=	sig_slv3t0_divisor_flag_delay08;
		sig_slv3t0_divisor_flag_delay10	<=	sig_slv3t0_divisor_flag_delay09;
		sig_slv3t0_divisor_flag_delay11	<=	sig_slv3t0_divisor_flag_delay10;
		sig_slv3t0_divisor_flag_delay12	<=	sig_slv3t0_divisor_flag_delay11;
	end if;
end process;

--͒liKIێ
process(I_SL_CLK)
begin
	if(I_SL_CLK'event and I_SL_CLK='1')then
		sig_slv3t0_value	<=	sig_slv11t0_value(3 downto 0);
		sig_slv2t0_value	<=	sig_slv3t0_value(2 downto 0);
		sig_slv1t0_value	<=	sig_slv2t0_value(1 downto 0);
		sig_sl_value		<=	sig_slv1t0_value(0);
	end if;
end process;

--lێ
process(I_SL_CLK)
begin
	if(I_SL_CLK'event and I_SL_CLK='1')then
		sig_slv7t0_divisor_delay01	<=	sig_slv7t0_divisor;
		sig_slv7t0_divisor_delay02	<=	sig_slv7t0_divisor_delay01;
		sig_slv7t0_divisor_delay03	<=	sig_slv7t0_divisor_delay02;
		sig_slv7t0_divisor_delay04	<=	sig_slv7t0_divisor_delay03;
		sig_slv7t0_divisor_delay05	<=	sig_slv7t0_divisor_delay04;
		sig_slv7t0_divisor_delay06	<=	sig_slv7t0_divisor_delay05;
		sig_slv7t0_divisor_delay07	<=	sig_slv7t0_divisor_delay06;
		sig_slv7t0_divisor_delay08	<=	sig_slv7t0_divisor_delay07;
		sig_slv7t0_divisor_delay09	<=	sig_slv7t0_divisor_delay08;
		sig_slv7t0_divisor_delay10	<=	sig_slv7t0_divisor_delay09;
		sig_slv7t0_divisor_delay11	<=	sig_slv7t0_divisor_delay10;
	end if;
end process;

--12rbgڂ̓߂Ă
process(I_SL_CLK)
begin
	if(I_SL_CLK'event and I_SL_CLK='1')then
		if(sig_slv11t0_value(11 downto 4)	>=	sig_slv7t0_divisor)then						--8bit̒l鐔傫
			sig_sl_q12		<=	'1';																		--1ɂȂ
			sig_slv7t0_r12	<=	sig_slv11t0_value(11 downto 4)	-	sig_slv7t0_divisor;	--āAbiťvZׂ̈Ɉl
		else																									--鐔̕傫
			sig_sl_q12		<=	'0';																		--0ɂȂ
			sig_slv7t0_r12	<=	sig_slv11t0_value(11 downto 4);									--āAbiťvZׂ̈ɒl̂܂܈p悤ɂ
		end if;
	end if;
end process;

--11rbgڂ̓߂Ă
process(I_SL_CLK)
begin
	if(I_SL_CLK'event and I_SL_CLK='1')then
		if(sig_slv7t0_r12	&	sig_slv3t0_value(3)	>=	'0'	&	sig_slv7t0_divisor_delay01)then									--(pl&3bitڂĂl)鐔傫
			sig_slv1t0_q12_11		<=	sig_sl_q12	&	'1';																						--1ɂȂ
			sig_slv8t0_r11			<=	(sig_slv7t0_r12	&	sig_slv3t0_value(3))	-	('0'	&	sig_slv7t0_divisor_delay01);	--āAbiťvZׂ̈Ɉl
		else																																				--鐔̕傫
			sig_slv1t0_q12_11		<=	sig_sl_q12	&	'0';																						--0ɂȂ
			sig_slv8t0_r11			<=	sig_slv7t0_r12	&	sig_slv3t0_value(3);																--āAbiťvZׂ̈ɒl̂܂܈p悤ɂ
		end if;
	end if;
end process;

--10rbgڂ̓߂Ă
process(I_SL_CLK)
begin
	if(I_SL_CLK'event and I_SL_CLK='1')then
		if(sig_slv8t0_r11	&	sig_slv2t0_value(2)	>=	"00"	&	sig_slv7t0_divisor_delay02)then									--(pl&2bitڂĂl)鐔傫
			sig_slv2t0_q12_10		<=	sig_slv1t0_q12_11	&	'1';																				--1ɂȂ
			sig_slv9t0_r10			<=	(sig_slv8t0_r11	&	sig_slv2t0_value(2))	-	("00"	&	sig_slv7t0_divisor_delay02);	--āAbiťvZׂ̈Ɉl
		else																																				--鐔̕傫
			sig_slv2t0_q12_10		<=	sig_slv1t0_q12_11	&	'0';																				--0ɂȂ
			sig_slv9t0_r10			<=	sig_slv8t0_r11	&	sig_slv2t0_value(2);																--āAbiťvZׂ̈ɒl̂܂܈p悤ɂ
		end if;
	end if;
end process;

--9rbgڂ̓߂Ă
process(I_SL_CLK)
begin
	if(I_SL_CLK'event and I_SL_CLK='1')then
		if(sig_slv9t0_r10	&	sig_slv1t0_value(1)	>=	"000"	&	sig_slv7t0_divisor_delay03)then										--(pl&1bitڂĂl)鐔傫
			sig_slv3t0_q12_9		<=	sig_slv2t0_q12_10	&	'1';																					--1ɂȂ
			sig_slv10t0_r9			<=	(sig_slv9t0_r10	&	sig_slv1t0_value(1))	-	("000"	&	sig_slv7t0_divisor_delay03);	--āAbiťvZׂ̈Ɉl
		else																																					--鐔̕傫
			sig_slv3t0_q12_9		<=	sig_slv2t0_q12_10	&	'0';																					--0ɂȂ
			sig_slv10t0_r9			<=	sig_slv9t0_r10	&	sig_slv1t0_value(1);																	--āAbiťvZׂ̈ɒl̂܂܈p悤ɂ
		end if;
	end if;
end process;

--8rbgڂ̓߂Ă
process(I_SL_CLK)
begin
	if(I_SL_CLK'event and I_SL_CLK='1')then
		if(sig_slv10t0_r9	&	sig_sl_value	>=	"0000"	&	sig_slv7t0_divisor_delay04)then									--(pl&0bitڂĂl)鐔傫
			sig_slv4t0_q12_8		<=	sig_slv3t0_q12_9	&	'1';																			--1ɂȂ
			sig_slv11t0_r8			<=	(sig_slv10t0_r9	&	sig_sl_value)	-	("0000"	&	sig_slv7t0_divisor_delay04);	--āAbiťvZׂ̈Ɉl
		else																																			--鐔̕傫
			sig_slv4t0_q12_8		<=	sig_slv3t0_q12_9	&	'0';																			--0ɂȂ
			sig_slv11t0_r8			<=	sig_slv10t0_r9	&	sig_sl_value;																	--āAbiťvZׂ̈ɒl̂܂܈p悤ɂ
		end if;																																		--tO0001̂Ƃr8]ɂȂ
	end if;
end process;

--7rbgڂ̓߂Ă
process(I_SL_CLK)
begin
	if(I_SL_CLK'event and I_SL_CLK='1')then
		if(sig_slv11t0_r8	&	'0'	>=	"00000"	&	sig_slv7t0_divisor_delay05)then									--(pl0)鐔傫
			sig_slv5t0_q12_7		<=	sig_slv4t0_q12_8	&	'1';																--1ɂȂ
			sig_slv12t0_r7			<=	(sig_slv11t0_r8	&	'0')	-	("00000"	&	sig_slv7t0_divisor_delay05);	--āAbiťvZׂ̈Ɉl
		else																																--鐔̕傫
			sig_slv5t0_q12_7		<=	sig_slv4t0_q12_8	&	'0';																--0ɂȂ
			sig_slv12t0_r7			<=	sig_slv11t0_r8	&	'0';																	--āAbiťvZׂ̈ɒl̂܂܈p悤ɂ
		end if;																															--tO0010̂Ƃr7]ɂȂ
	end if;
end process;

--6rbgڂ̓߂Ă
process(I_SL_CLK)
begin
	if(I_SL_CLK'event and I_SL_CLK='1')then
		if(sig_slv12t0_r7	&	'0'	>=	"000000"	&	sig_slv7t0_divisor_delay06)then										--(pl0)鐔傫
			sig_slv6t0_q12_6		<=	sig_slv5t0_q12_7	&	'1';																	--1ɂȂ
			sig_slv13t0_r6			<=	(sig_slv12t0_r7	&	'0')	-	("000000"	&	sig_slv7t0_divisor_delay06);	--āAbiťvZׂ̈Ɉl
		else																																	--鐔̕傫
			sig_slv6t0_q12_6		<=	sig_slv5t0_q12_7	&	'0';																	--0ɂȂ
			sig_slv13t0_r6			<=	sig_slv12t0_r7	&	'0';																		--āAbiťvZׂ̈ɒl̂܂܈p悤ɂ
		end if;																																--tO0011̂Ƃr6]ɂȂ
	end if;
end process;

--5rbgڂ̓߂Ă
process(I_SL_CLK)
begin
	if(I_SL_CLK'event and I_SL_CLK='1')then
		if(sig_slv13t0_r6	&	'0'	>=	"0000000"	&	sig_slv7t0_divisor_delay07)then									--(pl0)鐔傫
			sig_slv7t0_q12_5		<=	sig_slv6t0_q12_6	&	'1';																	--1ɂȂ
			sig_slv14t0_r5			<=	(sig_slv13t0_r6	&	'0')	-	("0000000"	&	sig_slv7t0_divisor_delay07);	--āAbiťvZׂ̈Ɉl
		else																																	--鐔̕傫
			sig_slv7t0_q12_5		<=	sig_slv6t0_q12_6	&	'0';																	--0ɂȂ
			sig_slv14t0_r5			<=	sig_slv13t0_r6	&	'0';																		--āAbiťvZׂ̈ɒl̂܂܈p悤ɂ
		end if;																																--tO0100̂Ƃr5]ɂȂ
	end if;
end process;

--4rbgڂ̓߂Ă
process(I_SL_CLK)
begin
	if(I_SL_CLK'event and I_SL_CLK='1')then
		if(sig_slv14t0_r5	&	'0'	>=	"00000000"	&	sig_slv7t0_divisor_delay08)then									--(pl0)鐔傫
			sig_slv8t0_q12_4		<=	sig_slv7t0_q12_5	&	'1';																	--1ɂȂ
			sig_slv15t0_r4			<=	(sig_slv14t0_r5	&	'0')	-	("00000000"	&	sig_slv7t0_divisor_delay08);	--āAbiťvZׂ̈Ɉl
		else																																	--鐔̕傫
			sig_slv8t0_q12_4		<=	sig_slv7t0_q12_5	&	'0';																	--0ɂȂ
			sig_slv15t0_r4			<=	sig_slv14t0_r5	&	'0';																		--āAbiťvZׂ̈ɒl̂܂܈p悤ɂ
		end if;																																--tO0101̂Ƃr4]ɂȂ
	end if;
end process;

--3rbgڂ̓߂Ă
process(I_SL_CLK)
begin
	if(I_SL_CLK'event and I_SL_CLK='1')then
		if(sig_slv15t0_r4	&	'0'	>=	"000000000"	&	sig_slv7t0_divisor_delay09)then										--(pl0)鐔傫
			sig_slv9t0_q12_3		<=	sig_slv8t0_q12_4	&	'1';																		--1ɂȂ
			sig_slv16t0_r3			<=	(sig_slv15t0_r4	&	'0')	-	("000000000"	&	sig_slv7t0_divisor_delay09);	--āAbiťvZׂ̈Ɉl
		else																																		--鐔̕傫
			sig_slv9t0_q12_3		<=	sig_slv8t0_q12_4	&	'0';																		--0ɂȂ
			sig_slv16t0_r3			<=	sig_slv15t0_r4	&	'0';																			--āAbiťvZׂ̈ɒl̂܂܈p悤ɂ
		end if;																																	--tO0110̂Ƃr3]ɂȂ
	end if;
end process;

--2rbgڂ̓߂Ă
process(I_SL_CLK)
begin
	if(I_SL_CLK'event and I_SL_CLK='1')then
		if(sig_slv16t0_r3	&	'0'	>=	"0000000000"	&	sig_slv7t0_divisor_delay10)then									--(pl0)鐔傫
			sig_slv10t0_q12_2		<=	sig_slv9t0_q12_3	&	'1';																		--1ɂȂ
			sig_slv17t0_r2			<=	(sig_slv16t0_r3	&	'0')	-	("0000000000"	&	sig_slv7t0_divisor_delay10);	--āAbiťvZׂ̈Ɉl
		else																																		--鐔̕傫
			sig_slv10t0_q12_2		<=	sig_slv9t0_q12_3	&	'0';																		--0ɂȂ
			sig_slv17t0_r2			<=	sig_slv16t0_r3	&	'0';																			--āAbiťvZׂ̈ɒl̂܂܈p悤ɂ
		end if;																																	--tO0111̂Ƃr2]ɂȂ
	end if;
end process;

--1rbgڂ̓߂Ă
process(I_SL_CLK)
begin
	if(I_SL_CLK'event and I_SL_CLK='1')then
		if(sig_slv17t0_r2	&	'0'	>=	"00000000000"	&	sig_slv7t0_divisor_delay11)then									--(pl0)Ăl)鐔傫
			sig_slv11t0_q12_1		<=	sig_slv10t0_q12_2	&	'1';																		--1ɂȂ
			sig_slv18t0_r1			<=	(sig_slv17t0_r2	&	'0')	-	("00000000000"	&	sig_slv7t0_divisor_delay11);	--āAbiťvZׂ̈Ɉl
		else																																		--鐔̕傫
			sig_slv11t0_q12_1		<=	sig_slv10t0_q12_2	&	'0';																		--0ɂȂ
			sig_slv18t0_r1			<=	sig_slv17t0_r2	&	'0';																			--āAbiťvZׂ̈ɒl̂܂܈p悤ɂ
		end if;																																	--tO1000̂Ƃr1]ɂȂ
	end if;
end process;

--܂vZpfBC
process(I_SL_CLK)
begin
	if(I_SL_CLK'event and I_SL_CLK='1')then
		sig_slv7t0_r8_delay01	<=	sig_slv11t0_r8(7 downto 0);
		sig_slv7t0_r8_delay02	<=	sig_slv7t0_r8_delay01;
		sig_slv7t0_r8_delay03	<=	sig_slv7t0_r8_delay02;
		sig_slv7t0_r8_delay04	<=	sig_slv7t0_r8_delay03;
		sig_slv7t0_r8_delay05	<=	sig_slv7t0_r8_delay04;
		sig_slv7t0_r8_delay06	<=	sig_slv7t0_r8_delay05;
		sig_slv7t0_r8_delay07	<=	sig_slv7t0_r8_delay06;
	end if;
end process;

process(I_SL_CLK)
begin
	if(I_SL_CLK'event and I_SL_CLK='1')then
		sig_slv7t0_r7_delay01	<=	sig_slv12t0_r7(8 downto 1);
		sig_slv7t0_r7_delay02	<=	sig_slv7t0_r7_delay01;
		sig_slv7t0_r7_delay03	<=	sig_slv7t0_r7_delay02;
		sig_slv7t0_r7_delay04	<=	sig_slv7t0_r7_delay03;
		sig_slv7t0_r7_delay05	<=	sig_slv7t0_r7_delay04;
		sig_slv7t0_r7_delay06	<=	sig_slv7t0_r7_delay05;
	end if;
end process;

process(I_SL_CLK)
begin
	if(I_SL_CLK'event and I_SL_CLK='1')then
		sig_slv7t0_r6_delay01	<=	sig_slv13t0_r6(9 downto 2);
		sig_slv7t0_r6_delay02	<=	sig_slv7t0_r6_delay01;
		sig_slv7t0_r6_delay03	<=	sig_slv7t0_r6_delay02;
		sig_slv7t0_r6_delay04	<=	sig_slv7t0_r6_delay03;
		sig_slv7t0_r6_delay05	<=	sig_slv7t0_r6_delay04;
	end if;
end process;

process(I_SL_CLK)
begin
	if(I_SL_CLK'event and I_SL_CLK='1')then
		sig_slv7t0_r5_delay01	<=	sig_slv14t0_r5(10 downto 3);
		sig_slv7t0_r5_delay02	<=	sig_slv7t0_r5_delay01;
		sig_slv7t0_r5_delay03	<=	sig_slv7t0_r5_delay02;
		sig_slv7t0_r5_delay04	<=	sig_slv7t0_r5_delay03;
	end if;
end process;

process(I_SL_CLK)
begin
	if(I_SL_CLK'event and I_SL_CLK='1')then
		sig_slv7t0_r4_delay01	<=	sig_slv15t0_r4(11 downto 4);
		sig_slv7t0_r4_delay02	<=	sig_slv7t0_r4_delay01;
		sig_slv7t0_r4_delay03	<=	sig_slv7t0_r4_delay02;
	end if;
end process;

process(I_SL_CLK)
begin
	if(I_SL_CLK'event and I_SL_CLK='1')then
		sig_slv7t0_r3_delay01	<=	sig_slv16t0_r3(12 downto 5);
		sig_slv7t0_r3_delay02	<=	sig_slv7t0_r3_delay01;
	end if;
end process;

process(I_SL_CLK)
begin
	if(I_SL_CLK'event and I_SL_CLK='1')then
		sig_slv7t0_r2_delay01	<=	sig_slv17t0_r2(13 downto 6);
	end if;
end process;

--tOɂ钲
process(I_SL_CLK)
begin
	if(I_SL_CLK'event and I_SL_CLK='1')then
		if(sig_slv3t0_divisor_flag_delay12	=	"0001")then
			O_SLV11T0_RESULT		<=	"0000000"	&	sig_slv11t0_q12_1(11 downto 7);	--8bitڂ1Ȃ̂ŃY͖
			O_SLV7T0_REMAINDER	<=	sig_slv7t0_r8_delay07;									--̎_ł̗]
		elsif(sig_slv3t0_divisor_flag_delay12	=	"0010")then
			O_SLV11T0_RESULT		<=	"000000"		&	sig_slv11t0_q12_1(11 downto 6);	--7bitڂ1Ȃ̂1Y
			O_SLV7T0_REMAINDER	<=	sig_slv7t0_r7_delay06;									--1YĂ]
		elsif(sig_slv3t0_divisor_flag_delay12	=	"0011")then
			O_SLV11T0_RESULT		<=	"00000"		&	sig_slv11t0_q12_1(11 downto 5);	--6bitڂ1Ȃ̂2Y
			O_SLV7T0_REMAINDER	<=	sig_slv7t0_r6_delay05;									--2YĂ]
		elsif(sig_slv3t0_divisor_flag_delay12	=	"0100")then
			O_SLV11T0_RESULT		<=	"0000"		&	sig_slv11t0_q12_1(11 downto 4);	--5bitڂ1Ȃ̂3Y
			O_SLV7T0_REMAINDER	<=	sig_slv7t0_r5_delay04;									--3YĂ]
		elsif(sig_slv3t0_divisor_flag_delay12	=	"0101")then
			O_SLV11T0_RESULT		<=	"000"			&	sig_slv11t0_q12_1(11 downto 3);	--4bitڂ1Ȃ̂4Y
			O_SLV7T0_REMAINDER	<=	sig_slv7t0_r4_delay03;									--4YĂ]
		elsif(sig_slv3t0_divisor_flag_delay12	=	"0110")then
			O_SLV11T0_RESULT		<=	"00"			&	sig_slv11t0_q12_1(11 downto 2);	--3bitڂ1Ȃ̂5Y
			O_SLV7T0_REMAINDER	<=	sig_slv7t0_r3_delay02;									--5YĂ]
		elsif(sig_slv3t0_divisor_flag_delay12	=	"0111")then
			O_SLV11T0_RESULT		<=	'0'			&	sig_slv11t0_q12_1(11 downto 1);	--2bitڂ1Ȃ̂6Y
			O_SLV7T0_REMAINDER	<=	sig_slv7t0_r2_delay01;									--6YĂ]
		elsif(sig_slv3t0_divisor_flag_delay12	=	"1000")then
			O_SLV11T0_RESULT		<=						sig_slv11t0_q12_1;					--1bitڂ1Ȃ̂7Y
			O_SLV7T0_REMAINDER	<=	sig_slv18t0_r1(14 downto 7);							--7YĂ]
		else
			O_SLV11T0_RESULT		<=	"000000000000";	--G[p^[
			O_SLV7T0_REMAINDER	<=	"00000000";			--G[p^[
		end if;
	end if;
end process;

end Behavioral;