----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date:    16:09:52 10/30/2009 
-- Design Name: 
-- Module Name:    MULT16_16 - Behavioral 
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

---- Uncomment the following library declaration if instantiating
---- any Xilinx primitives in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity MULT12_12_mk2 is
	port(
			I_SL_CLK				:	in		std_logic;
			I_SLV11T0_INPUT_A	:	in		std_logic_vector(11 downto 0);
			I_SLV11T0_INPUT_B	:	in		std_logic_vector(11 downto 0);
			O_SLV23T0_RESULT	:	out	std_logic_vector(23 downto 0)
	);
end MULT12_12_mk2;

architecture Behavioral of MULT12_12_mk2 is

signal	sig_slv11t0_11bit_shift	:	std_logic_vector(11 downto 0);
signal	sig_slv11t0_10bit_shift	:	std_logic_vector(11 downto 0);
signal	sig_slv11t0_9bit_shift	:	std_logic_vector(11 downto 0);
signal	sig_slv11t0_8bit_shift	:	std_logic_vector(11 downto 0);
signal	sig_slv11t0_7bit_shift	:	std_logic_vector(11 downto 0);
signal	sig_slv11t0_6bit_shift	:	std_logic_vector(11 downto 0);
signal	sig_slv11t0_5bit_shift	:	std_logic_vector(11 downto 0);
signal	sig_slv11t0_4bit_shift	:	std_logic_vector(11 downto 0);
signal	sig_slv11t0_3bit_shift	:	std_logic_vector(11 downto 0);
signal	sig_slv11t0_2bit_shift	:	std_logic_vector(11 downto 0);
signal	sig_slv11t0_1bit_shift	:	std_logic_vector(11 downto 0);
signal	sig_slv11t0_0bit_shift	:	std_logic_vector(11 downto 0);

signal	sig_slv15t0_11_10_9bit_shift_plus	:	std_logic_vector(15 downto 0);
signal	sig_slv15t0_8_7_6bit_shift_plus		:	std_logic_vector(15 downto 0);
signal	sig_slv15t0_5_4_3bit_shift_plus		:	std_logic_vector(15 downto 0);
signal	sig_slv15t0_2_1_0bit_shift_plus		:	std_logic_vector(15 downto 0);

signal	sig_slv19t0_11_10_9_8_7_6bit_shift_plus	:	std_logic_vector(19 downto 0);
signal	sig_slv19t0_5_4_3_2_1_0bit_shift_plus		:	std_logic_vector(19 downto 0);

signal	sig_slv26t0_all_plus		:	std_logic_vector(26 downto 0);

begin



-----------------------------------------------------------------------------------
-----------------------------------------------------------------------------------
-----------------------------------------------------------------------------------
	process(I_SL_CLK)
	begin
		if(I_SL_CLK'event and I_SL_CLK='1')then
			if(I_SLV11T0_INPUT_B(11)='0')then
				sig_slv11t0_11bit_shift	<=	(others => '0');
			else
				sig_slv11t0_11bit_shift	<=	I_SLV11T0_INPUT_A;
			end if;
		end if;
	end process;

	process(I_SL_CLK)
	begin
		if(I_SL_CLK'event and I_SL_CLK='1')then
			if(I_SLV11T0_INPUT_B(10)='0')then
				sig_slv11t0_10bit_shift	<=	(others => '0');
			else
				sig_slv11t0_10bit_shift	<=	I_SLV11T0_INPUT_A;
			end if;
		end if;
	end process;

	process(I_SL_CLK)
	begin
		if(I_SL_CLK'event and I_SL_CLK='1')then
			if(I_SLV11T0_INPUT_B(9)='0')then
				sig_slv11t0_9bit_shift	<=	(others => '0');
			else
				sig_slv11t0_9bit_shift	<=	I_SLV11T0_INPUT_A;
			end if;
		end if;
	end process;

	process(I_SL_CLK)
	begin
		if(I_SL_CLK'event and I_SL_CLK='1')then
			if(I_SLV11T0_INPUT_B(8)='0')then
				sig_slv11t0_8bit_shift	<=	(others => '0');
			else
				sig_slv11t0_8bit_shift	<=	I_SLV11T0_INPUT_A;
			end if;
		end if;
	end process;

	process(I_SL_CLK)
	begin
		if(I_SL_CLK'event and I_SL_CLK='1')then
			if(I_SLV11T0_INPUT_B(7)='0')then
				sig_slv11t0_7bit_shift	<=	(others => '0');
			else
				sig_slv11t0_7bit_shift	<=	I_SLV11T0_INPUT_A;
			end if;
		end if;
	end process;

	process(I_SL_CLK)
	begin
		if(I_SL_CLK'event and I_SL_CLK='1')then
			if(I_SLV11T0_INPUT_B(6)='0')then
				sig_slv11t0_6bit_shift	<=	(others => '0');
			else
				sig_slv11t0_6bit_shift	<=	I_SLV11T0_INPUT_A;
			end if;
		end if;
	end process;

	process(I_SL_CLK)
	begin
		if(I_SL_CLK'event and I_SL_CLK='1')then
			if(I_SLV11T0_INPUT_B(5)='0')then
				sig_slv11t0_5bit_shift	<=	(others => '0');
			else
				sig_slv11t0_5bit_shift	<=	I_SLV11T0_INPUT_A;
			end if;
		end if;
	end process;

	process(I_SL_CLK)
	begin
		if(I_SL_CLK'event and I_SL_CLK='1')then
			if(I_SLV11T0_INPUT_B(4)='0')then
				sig_slv11t0_4bit_shift	<=	(others => '0');
			else
				sig_slv11t0_4bit_shift	<=	I_SLV11T0_INPUT_A;
			end if;
		end if;
	end process;

	process(I_SL_CLK)
	begin
		if(I_SL_CLK'event and I_SL_CLK='1')then
			if(I_SLV11T0_INPUT_B(3)='0')then
				sig_slv11t0_3bit_shift	<=	(others => '0');
			else
				sig_slv11t0_3bit_shift	<=	I_SLV11T0_INPUT_A;
			end if;
		end if;
	end process;

	process(I_SL_CLK)
	begin
		if(I_SL_CLK'event and I_SL_CLK='1')then
			if(I_SLV11T0_INPUT_B(2)='0')then
				sig_slv11t0_2bit_shift	<=	(others => '0');
			else
				sig_slv11t0_2bit_shift	<=	I_SLV11T0_INPUT_A;
			end if;
		end if;
	end process;

	process(I_SL_CLK)
	begin
		if(I_SL_CLK'event and I_SL_CLK='1')then
			if(I_SLV11T0_INPUT_B(1)='0')then
				sig_slv11t0_1bit_shift	<=	(others => '0');
			else
				sig_slv11t0_1bit_shift	<=	I_SLV11T0_INPUT_A;
			end if;
		end if;
	end process;

	process(I_SL_CLK)
	begin
		if(I_SL_CLK'event and I_SL_CLK='1')then
			if(I_SLV11T0_INPUT_B(0)='0')then
				sig_slv11t0_0bit_shift	<=	(others => '0');
			else
				sig_slv11t0_0bit_shift	<=	I_SLV11T0_INPUT_A;
			end if;
		end if;
	end process;

-----------------------------------------------------------------------------------
-----------------------------------------------------------------------------------
-----------------------------------------------------------------------------------


	process(I_SL_CLK)
	begin
		if(I_SL_CLK'event and I_SL_CLK='1')then
			sig_slv15t0_11_10_9bit_shift_plus	<=	("00"	&	sig_slv11t0_11bit_shift	&	"00")	+	("00"	&	'0'	&	sig_slv11t0_10bit_shift	&	'0')	+	("00"	&	"00"	&	sig_slv11t0_9bit_shift);
		end if;
	end process;
	
		process(I_SL_CLK)
	begin
		if(I_SL_CLK'event and I_SL_CLK='1')then
			sig_slv15t0_8_7_6bit_shift_plus		<=	("00"	&	sig_slv11t0_8bit_shift	&	"00")	+	("00"	&	'0'	&	sig_slv11t0_7bit_shift	&	'0')	+	("00"	&	"00"	&	sig_slv11t0_6bit_shift);
		end if;
	end process;
	
		process(I_SL_CLK)
	begin
		if(I_SL_CLK'event and I_SL_CLK='1')then
			sig_slv15t0_5_4_3bit_shift_plus		<=	("00"	&	sig_slv11t0_5bit_shift	&	"00")	+	("00"	&	'0'	&	sig_slv11t0_4bit_shift	&	'0')	+	("00"	&	"00"	&	sig_slv11t0_3bit_shift);
		end if;
	end process;
	
		process(I_SL_CLK)
	begin
		if(I_SL_CLK'event and I_SL_CLK='1')then
			sig_slv15t0_2_1_0bit_shift_plus	<=	("00"	&	sig_slv11t0_2bit_shift	&	"00")	+	("00"	&	'0'	&	sig_slv11t0_1bit_shift	&	'0')	+	("00"	&	"00"	&	sig_slv11t0_0bit_shift);
		end if;
	end process;

-----------------------------------------------------------------------------------
-----------------------------------------------------------------------------------
-----------------------------------------------------------------------------------

	process(I_SL_CLK)
	begin
		if(I_SL_CLK'event and I_SL_CLK='1')then
			sig_slv19t0_11_10_9_8_7_6bit_shift_plus	<=	('0'	&	sig_slv15t0_11_10_9bit_shift_plus	&	"000")	+	('0'	&	"000"	&	sig_slv15t0_8_7_6bit_shift_plus);
		end if;
	end process;
	
	process(I_SL_CLK)
	begin
		if(I_SL_CLK'event and I_SL_CLK='1')then
			sig_slv19t0_5_4_3_2_1_0bit_shift_plus	<=	('0'	&	sig_slv15t0_5_4_3bit_shift_plus	&	"000")	+	('0'	&	"000"	&	sig_slv15t0_2_1_0bit_shift_plus);
		end if;
	end process;

-----------------------------------------------------------------------------------
-----------------------------------------------------------------------------------
-----------------------------------------------------------------------------------

	process(I_SL_CLK)
	begin
		if(I_SL_CLK'event and I_SL_CLK='1')then
			sig_slv26t0_all_plus	<=	('0'	&	sig_slv19t0_11_10_9_8_7_6bit_shift_plus	&	"000000")	+	(	'0'	&	"000000"	&	sig_slv19t0_5_4_3_2_1_0bit_shift_plus);
		end if;
	end process;

-----------------------------------------------------------------------------------
-----------------------------------------------------------------------------------
-----------------------------------------------------------------------------------

--	process(I_SL_CLK)
--	begin
--		if(I_SL_CLK'event and I_SL_CLK='1')then
			O_SLV23T0_RESULT	<=	sig_slv26t0_all_plus(23 downto 0);
--		end if;
--	end process;


end Behavioral;

