--------------------------------------------------------------------------------
-- Company: 
-- Engineer:
--
-- Create Date:   23:52:04 03/25/2011
-- Design Name:   
-- Module Name:   C:/VHDL/home/JPEG_ENCODER_2011_03_25_BLOCK_TEST/src/TEST_HEADER_CONTROLLER.vhd
-- Project Name:  JPEG_ENCODER
-- Target Device:  
-- Tool versions:  
-- Description:   
-- 
-- VHDL Test Bench Created by ISE for module: HEADER_CONTROLLER
-- 
-- Dependencies:
-- 
-- Revision:
-- Revision 0.01 - File Created
-- Additional Comments:
--
-- Notes: 
-- This testbench has been automatically generated using types std_logic and
-- std_logic_vector for the ports of the unit under test.  Xilinx recommends
-- that these types always be used for the top-level I/O of a design in order
-- to guarantee that the testbench will bind correctly to the post-implementation 
-- simulation model.
--------------------------------------------------------------------------------
LIBRARY ieee;
USE ieee.std_logic_1164.ALL;
USE ieee.std_logic_unsigned.all;
USE ieee.numeric_std.ALL;
 
ENTITY TEST_HEADER_CONTROLLER IS
END TEST_HEADER_CONTROLLER;
 
ARCHITECTURE behavior OF TEST_HEADER_CONTROLLER IS 
 
    -- Component Declaration for the Unit Under Test (UUT)
 
    COMPONENT HEADER_CONTROLLER
    PORT(
         I_SL_CLK : IN  std_logic;
         I_SL_RESET : IN  std_logic;
         I_SL_VSYNC : IN  std_logic;
         I_SL_HSYNC : IN  std_logic;
         I_SL_DE : IN  std_logic;
         I_SL_VSYNC_8L_DFF : IN  std_logic;
         I_SL_HSYNC_8L_DFF : IN  std_logic;
         I_SL_DE_8L_DFF : IN  std_logic;
         I_SLV11T0_H_RESOLUTION : IN  std_logic_vector(11 downto 0);
         I_SLV11T0_V_RESOLUTION : IN  std_logic_vector(11 downto 0);
         I_SLV11T0_Q_FACTOR : IN  std_logic_vector(11 downto 0);
         I_SL_PROCESS_ENABLE : IN  std_logic;
         O_SLV15T0_DATA : OUT  std_logic_vector(15 downto 0);
         O_SL_DATA_ENABLE : OUT  std_logic
        );
    END COMPONENT;

component SYNC_CONTROLLER
	port(
		I_SL_CLK							:	in		std_logic;
		I_SL_RESET						:	in		std_logic;
		I_SL_VSYNC						:	in		std_logic;
		I_SL_HSYNC						:	in		std_logic;
		I_SL_DE							:	in		std_logic;
		I_SLV15T0_H_SYNC_TIME		:	in		std_logic_vector(15 downto 0);
		I_SLV15T0_H_BACK_PORCH		:	in		std_logic_vector(15 downto 0);
		I_SLV15T0_H_WIDTH				:	in		std_logic_vector(15 downto 0);
		I_SLV15T0_H_FRONT_PORCH		:	in		std_logic_vector(15 downto 0);
		I_SLV15T0_H_PO					:	in		std_logic;
		I_SLV15T0_V_SYNC_TIME		:	in		std_logic_vector(15 downto 0);
		I_SLV15T0_V_BACK_PORCH		:	in		std_logic_vector(15 downto 0);
		I_SLV15T0_V_WIDTH				:	in		std_logic_vector(15 downto 0);
		I_SLV15T0_V_FRONT_PORCH		:	in		std_logic_vector(15 downto 0);
		I_SLV15T0_V_PO					:	in		std_logic;
		O_SL_VSYNC						:	out	std_logic;
		O_SL_HSYNC						:	out	std_logic;
		O_SL_DE							:	out	std_logic;
		O_SL_VSYNC_8L_DFF				:	out	std_logic;
		O_SL_HSYNC_8L_DFF				:	out	std_logic;
		O_SL_DE_8L_DFF					:	out	std_logic;
		O_SLV11T0_H_RESOLUTION		:	out	std_logic_vector(11 downto 0);
		O_SLV11T0_V_RESOLUTION		:	out	std_logic_vector(11 downto 0)
	);
end component;

   --Inputs
   signal I_SL_CLK : std_logic := '0';
   signal I_SL_RESET : std_logic := '0';
   signal I_SL_VSYNC : std_logic := '0';
   signal I_SL_HSYNC : std_logic := '0';
   signal I_SL_DE : std_logic := '0';
   signal I_SL_VSYNC_8L_DFF : std_logic := '0';
   signal I_SL_HSYNC_8L_DFF : std_logic := '0';
   signal I_SL_DE_8L_DFF : std_logic := '0';
   signal I_SLV11T0_H_RESOLUTION : std_logic_vector(11 downto 0) := (others => '0');
   signal I_SLV11T0_V_RESOLUTION : std_logic_vector(11 downto 0) := (others => '0');
   signal I_SLV11T0_Q_FACTOR : std_logic_vector(11 downto 0) := "010000000000";
   signal I_SL_PROCESS_ENABLE : std_logic := '1';

 	--Outputs
   signal O_SLV15T0_DATA : std_logic_vector(15 downto 0);
   signal O_SL_DATA_ENABLE : std_logic;
	
   signal con_slv15t0_h_sync_time	:	std_logic_vector(15 downto 0):=x"0088";
   signal con_slv15t0_h_back_porch	:	std_logic_vector(15 downto 0):=x"00A0";
   signal con_slv15t0_h_width			:	std_logic_vector(15 downto 0):=x"0400";
   signal con_slv15t0_h_front_porch	:	std_logic_vector(15 downto 0):=x"0018";
   signal con_sl_h_po					:	std_logic:='1';
   signal con_slv15t0_v_sync_time	:	std_logic_vector(15 downto 0):=x"0006";
   signal con_slv15t0_v_back_porch	:	std_logic_vector(15 downto 0):=x"001D";
   signal con_slv15t0_v_width			:	std_logic_vector(15 downto 0):=x"0300";
   signal con_slv15t0_v_front_porch	:	std_logic_vector(15 downto 0):=x"0003";
   signal con_sl_v_po					:	std_logic:='1';
	       
 
BEGIN
 
	-- Instantiate the Unit Under Test (UUT)
   uut: HEADER_CONTROLLER PORT MAP (
          I_SL_CLK => I_SL_CLK,
          I_SL_RESET => I_SL_RESET,
          I_SL_VSYNC => I_SL_VSYNC,
          I_SL_HSYNC => I_SL_HSYNC,
          I_SL_DE => I_SL_DE,
          I_SL_VSYNC_8L_DFF => I_SL_VSYNC_8L_DFF,
          I_SL_HSYNC_8L_DFF => I_SL_HSYNC_8L_DFF,
          I_SL_DE_8L_DFF => I_SL_DE_8L_DFF,
          I_SLV11T0_H_RESOLUTION => con_slv15t0_h_width(11 downto 0),
          I_SLV11T0_V_RESOLUTION => con_slv15t0_v_width(11 downto 0),
          I_SLV11T0_Q_FACTOR => I_SLV11T0_Q_FACTOR,
			 I_SL_PROCESS_ENABLE => I_SL_PROCESS_ENABLE,
          O_SLV15T0_DATA => O_SLV15T0_DATA,
          O_SL_DATA_ENABLE => O_SL_DATA_ENABLE
        );

	U2	:	SYNC_CONTROLLER	port map(
			I_SL_CLK						=>	I_SL_CLK,
			I_SL_RESET					=>	I_SL_RESET,
			I_SL_VSYNC					=>	I_SL_VSYNC,
			I_SL_HSYNC					=>	I_SL_HSYNC,
			I_SL_DE						=>	I_SL_DE,
			I_SLV15T0_H_SYNC_TIME	=>	con_slv15t0_h_sync_time,
			I_SLV15T0_H_BACK_PORCH	=>	con_slv15t0_h_back_porch,
			I_SLV15T0_H_WIDTH			=>	con_slv15t0_h_width,
			I_SLV15T0_H_FRONT_PORCH	=>	con_slv15t0_h_front_porch,
			I_SLV15T0_H_PO				=>	con_sl_h_po,
			I_SLV15T0_V_SYNC_TIME	=>	con_slv15t0_v_sync_time,
			I_SLV15T0_V_BACK_PORCH	=>	con_slv15t0_v_back_porch,
			I_SLV15T0_V_WIDTH			=>	con_slv15t0_v_width,
			I_SLV15T0_V_FRONT_PORCH	=>	con_slv15t0_v_front_porch,
			I_SLV15T0_V_PO				=>	con_sl_v_po,
			O_SL_VSYNC					=>	sig_sl_vsync,
			O_SL_HSYNC					=>	sig_sl_hsync,
			O_SL_DE						=>	sig_sl_de,
			O_SL_VSYNC_8L_DFF			=>	sig_sl_vsync_8l_dff,
			O_SL_HSYNC_8L_DFF			=>	sig_sl_hsync_8l_dff,
			O_SL_DE_8L_DFF				=>	sig_sl_de_8l_dff,
			O_SLV11T0_H_RESOLUTION	=>	sig_slv11t0_h_resolution,
			O_SLV11T0_V_RESOLUTION	=>	sig_slv11t0_v_resolution
		);
I_SL_CLK	<=	not I_SL_CLK after 5 ns;

END;